2025-01-22 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/peeph.def,
	  support/regression/tests/bug-3824.c:
	  Fix bug #3824.

2025-01-21 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/scripts/sdcc.nsi:
	  Fix bug #3820 via patch by Janko Stamenović.
	* src/z80/gen.c:
	  Fix bug #3821.

2025-01-19 Benedikt Freisen <b.freisen AT gmx.net>

	* doc/sdccman.lyx:
	  Clarify linking order resulting from mixed command lines.

2025-01-19 Philipp Klaus Krause <philipp@colecovision.eu>

	* doc/sdccman.lyx:
	  Improve Rabbit port documentation.

2025-01-18 Benedikt Freisen <b.freisen AT gmx.net>

	* support/regression/Makefile.in:
	  Check if python is available when running tests. Patch by Felix Salfelder, see bug #3646.

2025-01-18 Benedikt Freisen <b.freisen AT gmx.net>

	* sdas/asxxsrc/asmain.c:
	  Apply patch #485 by bbbbbr to properly document the -N flag.

2025-01-12 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mos6502/gen.c:
	  Fix mos6502 part of bug #3814.
	* sdas/astlcs90/t90mch.c:
	  Fix bug #3815.

2025-01-11 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-3601.c:
	  Commit fix for typo in disabling of test for low-memory devices.

2025-01-09 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCicode.c,
	  src/SDCCsymt.c,
	  src/SDCCsymt.h,
	  support/regression/MakeList,
	  support/regression/tests/bug-3601.c:
	  Fix bug #3601.
	* src/z80/gen.c,
	  support/regression/tests/bug-3814.c:
	  Fix z80 part of bug #3814.

2025-01-08 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/strnlen.c,
	  support/regression/tests/wcsnlen.c:
	  Fix bug #3812.

2025-01-02 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8mch.c,
	  sim/ucsim/src/sims/f8.src/glob.cc:
	  f8 ldw instruction fixes for assembler and simulator.

2024-12-31 Philipp Klaus Krause <philipp@colecovision.eu>

	* .version,
	  doc/INSTALL.txt,
	  doc/sdccman.lyx,
	  sdcc.spec:
	  Prepare for SDCC 4.5.0 release.

2024-12-31 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mcs51/gen.c,
	  support/regression/tests/largeoddstruct.c.in:
	  Fix bug #3804.

2024-12-31 Benedikt Freisen <b.freisen AT gmx.net>

	* doc/sdccman.lyx:
	  Update section 3.1 "Standard Compliance" and improve readability.
	* support/scripts/sdcclogo.svg,
	  support/scripts/sdcclogo_bakedtext.svg,
	  support/scripts/sdcclogo_simplified.svg,
	  support/scripts/sdcclogo_simplified_bakedtext.svg:
	  Add logo SVGs for future use, see RFE #813.

2024-12-30 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCicode.c,
	  support/regression/tests/bug-3799.c:
	  Fix bug #3800.
	* support/regression/tests/bug-3013.c:
	  Test for non-longer-reproducible bug #3013.

2024-12-22 Benedikt Freisen <b.freisen AT gmx.net>

	* device/lib/strtoull.c,
	  device/lib/wcstoul.c,
	  device/lib/wcstoull.c:
	  Hackfix and re-enable strtoull and wcstoull, see bug #3798.

2024-12-21 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCast.c,
	  support/regression/tests/structinit.c.in,
	  .version:
	  struct / union in initializer, RFE #901, RFE #797.

2024-12-20 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Enable use of ldir for r2k and r2ka in a few cases that are not affected by the wait-state bug.
	* src/z80/gen.c:
	  Improve Rabbit negation codegen.
	* support/regression/tests/sieve.c:
	  Regression test based on historic Byte magazine sieve of Eratosthenes benchmark.

2024-12-19 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/r2k/crt0.s,
	  device/lib/r2ka/crt0.s,
	  device/lib/r3ka/crt0.s:
	  Fix comment in Rabbit startup code.

2024-12-18 Philipp Klaus Krause <philipp@colecovision.eu>

	* doc/README.txt:
	  Fix some links in documentation.

2024-12-17 Philipp Klaus Krause <philipp@colecovision.eu>

	* sim/ucsim/src/sims/f8.src/decode.h,
	  sim/ucsim/src/sims/f8.src/f8cl.h,
	  sim/ucsim/src/sims/f8.src/glob.cc,
	  sim/ucsim/src/sims/f8.src/imove.cc:
	  Fixes for f8 ldw instruction simulation.
	* src/f8/gen.c:
	  Improve use of ldw instructions in f8 codegen.

2024-12-15 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc:
	  Fix bug #3807.
	* support/regression/tests/rabbit.c:
	  Rabbit cipher regression test.
	* src/f8/gen.c:
	  Improve f8 addition codegen.
	* sdas/asf8/f8mch.c:
	  Assembler support for ldw x, (y) f8 instruction.

2024-12-14 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/typeof_retfptr.c:
	  Test for a function pointer idiom becoming popular with C23.
	* src/mcs51/gen.c,
	  src/hc08/gen.c:
	  Make mcs51, hc08 and s08 list --i-code-in-asm list ic->key prominently, instead of ic->seq (ic->key is more useful for debugging, and used by all other ports).
	* src/SDCCgenconstprop.cc:
	  Fix bug #3806.
	* src/f8/gen.c:
	  Improve f8 codegen.
	* src/f8/peeph.def:
	  Optimize out f8 pop(w)/push(w) pairs.

2024-12-13 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCicode.c:
	  Do not propagate volatile qualifier to iTemp in implicit casts.
	* src/f8/gen.c:
	  f8 codegen improvements.

2024-12-12 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc,
	  src/f8/gen.c,
	  src/f8/main.c,
	  src/f8/peeph.def:
	  Various improvements, mostly for bitwise operations.

2024-12-11 Philipp Klaus Krause <philipp@colecovision.eu>

	* sim/ucsim/src/sims/f8.src/decode.h,
	  sim/ucsim/src/sims/f8.src/f8cl.h,
	  sim/ucsim/src/sims/f8.src/glob.cc,
	  sim/ucsim/src/sims/f8.src/imove.cc,
	  src/f8/gen.c:
	  f8 xchw instruction fixes.

2024-12-11 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c,
	  src/f8/peeph.def:
	  Improve code for f8 bit-field access. Improve code for f8 extended stack access.

2024-12-11 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/main.c,
	  src/f8/gen.c:
	  Improve f8 codegen for rotations.

2024-12-10 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  f8 carry bit caching fix. Some f8 code generation improvements.

2024-12-10 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/peeph.def:
	  Optimize out some more redundant loads for f8.

2024-12-08 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/f8/_modsint.s,
	  device/lib/f8/_moduint.s,
	  device/lib/f8/Makefile.in,
	  device/lib/f8/_divsint.s,
	  device/lib/f8/_divuint.s:
	  Improve f8 modulo support routines.

2024-12-07 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  f8 codegen improvements.
	* src/stm8/gen.c:
	  stm8 codegen improvements for some reads of signed bit-fields.
	* src/f8/peeph.def,
	  src/f8/peep.c:
	  f8 optimizations for string handling.

2024-12-06 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/f8/_divuint.s,
	  src/f8/peeph.def:
	  Save a few bytes in f8 division support routines.
	* src/f8/gen.c:
	  f8 codegen improvements.

2024-02-29 Gabriele Gorla <gorlik@yahoo.com>

	* doc/sdccman.lyx:
      additional documentation for the MOS6502 port. Addresses:
      - bug #3749
      - bug #3787
      - support req #199
      - feature request #931

2024-12-05 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Improve f8 codegen for some operations.

2024-12-03 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/largeoddstruct.c.in:
	  Disable test for host, since we can't assume C23 support in host compilers yet. Disable for -mmcs51 --stack-auto, due to bug #3804.

2024-12-02 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c,
	  src/stm8/gen.c,
	  src/z80/gen.c:
	  Some assertions to catch bugs like #3803 a bit earlier.

2024-12-02 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8mch.c,
	  sim/ucsim/src/sims/f8.src/glob.cc,
	  sim/ucsim/src/sims/f8.src/imove.cc,
	  src/f8/gen.c,
	  src/f8/peep.c,
	  support/regression/tests/largeoddstruct.c.in:
	  Change destination operand to y-relative for f8 ld(w)i instruction.
	* src/z80/gen.c,
	  src/z80/peeph.def:
	  Safeguards against accidential use of ld r, r instructions for Rabbits.

2024-12-01 Benedikt Freisen <b.freisen AT gmx.net>

	* src/SDCCast.c:
	  Fix typeofOp not using the actual decorated tree.

2024-11-30 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/pdk/ralloc2.cc:
	  pdk stack allocation improvement.
	* src/f8/gen.c:
	  Fix a corner case in f8 block move codegen optimization.

2024-11-29 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c,
	  src/f8/ralloc2.cc:
	  Small f8 codegen and stack allocation improvements.

2024-11-29 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Improve f8 code generation for pointer access and left shift.
	* src/f8/ralloc.c,
	  src/stm8/ralloc.c:
	  Code cleanup.

2024-11-28 Philipp Klaus Krause <philipp@colecovision.eu>

	* sim/ucsim/src/sims/f8.src/glob.cc,
	  sim/ucsim/src/sims/f8.src/ialu.cc:
	  Fix simulation of msk instruction.
	* src/f8/gen.c:
	  Use msk instruction in codegen for bit-field writes.

2024-11-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8mch.c,
	  sim/ucsim/src/sims/f8.src/f8cl.h,
	  sim/ucsim/src/sims/f8.src/glob.cc:
	  ld(w) prefix fixes.
	* src/f8/gen.c:
	  Improve f8 codegen for writes via pointer.

2024-11-25 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/Makefile.in
	  support/regression/ports/*/spec.mk:
	  Since we have the cycle timeout now, the realtime-timeout has become less important. So don't bother maintaining is separately at the port level.

2024-11-24 Benedikt Freisen <b.freisen AT gmx.net>

	* src/SDCCast.c,
	  support/regression/tests/bug-3802.c:
	  Fix bug #3802.

2024-11-24 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8mch.c,
	  sim/ucsim/src/sims/f8.src/decode.h,
	  sim/ucsim/src/sims/f8.src/f8cl.h,
	  sim/ucsim/src/sims/f8.src/glob.cc,
	  sim/ucsim/src/sims/f8.src/imove.cc:
	  ldi, ldwi operand swap.

2024-11-24 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCsymt.c:
	  Fix printing of C23 nullptr in diagnostics.
	* sim/ucsim/src/sims/f8.src/ialu.cc,
	  src/f8/peeph.def:
	  Change f8 n flag semantics for 8-bit shifts. Fix some flag issues in f8 peephole optimizer rules.

2024-11-24 Maarten Brock <sourceforge.brock AT dse.nl>

	* sdas/asxxsrc/asmain.c: applied patch #483 to use search path for
	  .incbin, thanks Michel Iwaniec,
	  also added some synchronization with ASxxxx v5.50

2024-11-23 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/peep.c,
	  src/f8/peeph.def,
	  src/f8/ralloc.c:
	  Various f8 improvements.

2024-11-23 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc,
	  src/SDCCnaddr.hpp,
	  src/SDCCpeeph.c,
	  src/hc08/ralloc2.cc,
	  src/mos6502/ralloc2.cc,
	  src/pdk/ralloc2.cc,
	  src/stm8/ralloc2.cc,
	  src/z80/ralloc2.cc,
	  src/f8/ralloc2.cc:
	  Fix issues found via the infer linter.
	* src/f8/gen.c:
	  Fixes for f8 codegen/regalloc cost function.

2024-11-23 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Improve z80 struct/union parameter passing codegen.
	* src/SDCCcse.h,
	  src/SDCCsymt.c,
	  support/valdiag/tests/bug-3801.c:
	  Fix issues found via the sparse linter, including bug #3801.

2024-11-22 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  src/z80/main.c,
	  src/z80/peeph.def:
	  Improve z80 jump tables (RFE #941).

2024-11-21 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  support/regression/tests/bug-3799.c,
	  support/regression/tests/gcc-torture-execute-pr44575.c:
	  Fix bug #3799.

2024-11-20 Benedikt Freisen <b.freisen AT gmx.net>

	* support/regression/ports/ds390/uCsim.cmd,
	  support/regression/ports/ez80-z80/uCsim.cmd,
	  support/regression/ports/f8/uCsim.cmd,
	  support/regression/ports/hc08/uCsim.cmd,
	  support/regression/ports/mcs51-common/uCsim.cmd,
	  support/regression/ports/pdk13/uCsim.cmd,
	  support/regression/ports/pdk14/uCsim.cmd,
	  support/regression/ports/pdk15-stack-auto/uCsim.cmd,
	  support/regression/ports/pdk15/uCsim.cmd,
	  support/regression/ports/s08-stack-auto/uCsim.cmd,
	  support/regression/ports/s08/uCsim.cmd,
	  support/regression/ports/stm8-large/uCsim.cmd,
	  support/regression/ports/stm8/uCsim.cmd,
	  support/regression/ports/tlcs90/uCsim.cmd,
	  support/regression/ports/uc6502-stack-auto/uCsim.cmd,
	  support/regression/ports/uc6502/uCsim.cmd,
	  support/regression/ports/uc65c02/uCsim.cmd,
	  support/regression/ports/ucgbz80/uCsim.cmd,
	  support/regression/ports/ucr2k/uCsim.cmd,
	  support/regression/ports/ucr2ka/uCsim.cmd,
	  support/regression/ports/ucr3ka/uCsim.cmd,
	  support/regression/ports/ucr800/uCsim.cmd,
	  support/regression/ports/ucz180-resiy/uCsim.cmd,
	  support/regression/ports/ucz180/uCsim.cmd,
	  support/regression/ports/ucz80-resiy/uCsim.cmd,
	  support/regression/ports/ucz80-undoc/uCsim.cmd,
	  support/regression/ports/ucz80-unsafe-read/uCsim.cmd,
	  support/regression/ports/ucz80/uCsim.cmd,
	  support/regression/ports/ucz80n/uCsim.cmd:
	  Limit regression tests in ucsim to 100000000 vclk cycles.

2024-11-20 Benedikt Freisen <b.freisen AT gmx.net>

	* device/include/wchar.h,
	  device/lib/incl.mk,
	  device/lib/wcsnlen.c,
	  support/regression/tests/wcsnlen.c,
	  Derive wcsnlen from strnlen, RFE #925.

2024-11-18 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/gcc-torture-execute-pr44575.c:
	  Redisable one test that turned out to fail for z80-related ports (bug #3799).

2024-11-16 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/gcc-torture-execute-20000706-1.c,
	  support/regression/tests/gcc-torture-execute-20081103-1.c,
	  support/regression/tests/gcc-torture-execute-950607-2.c,
	  support/regression/tests/gcc-torture-execute-pr44575.c:
	  Enable further struct parameter tests.

2024-11-14 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-3231.c:
	  Enable test for f8.
	* support/regression/tests/gcc-torture-execute-20050826-1.c:
	  Enable test for stm8.

2024-11-12 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/peeph.def,
	  src/z80/gen.c:
	  Unify formatting of conditional jump asm for z80-related ports.

2024-11-11 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/ato.c:
	  Disable atoll test for pdk15 due to lack of target RAM.

2024-11-10 Philipp Klaus Krause <philipp@colecovision.eu>

	* sim/ucsim/src/sims/f8.src/imove.cc:
	  Fix simulation of f8 N and Z flags.
	* src/f8/main.c:
	  Use Z flag of 16-bit load to shorten startup code.
	* src/f8/peeph.def:
	  Optimize out some f8 tst, tstw where N and Z flags were already set by previous instructions, optimize jumps.
	* src/f8/peep.c:
	  Fix calculation of relative jump distance over f8 xch instruction.
	* src/f8/gen.c:
	  Improve f8 code generation for conditional jumps; improve value caching.

2024-11-10 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCpeeph.c,
	  src/f8/gen.c,
	  src/f8/peeph.def:
	  Improve code for conditional branches in f8 port.
	* device/include/stdlib.h,
	  device/lib/strtoll.c,
	  device/lib/strtoull.c,
	  device/lib/wcstoll.c,
	  device/lib/wcstoull.c:
	  Partial fix for bug #3798, to get atoll.

2024-11-09 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8.h,
	  sdas/asf8/f8mch.c,
	  sim/ucsim/src/sims/f8.src/disass.cc,
	  sim/ucsim/src/sims/f8.src/f8.cc,
	  sim/ucsim/src/sims/f8.src/f8cl.h,
	  sim/ucsim/src/sims/f8.src/glob.cc,
	  sim/ucsim/src/sims/f8.src/ialu.cc:
	  Fixes for two-operand 16 and 16/8 bit f8 instructions.
	* src/f8/gen.c:
	  Improve use of two-operand f8 instructions. Improve f8 code generation for pointer access.
	* src/f8/peep.c:
	  Fix asm argument handling buffer overflow. Fix handling of clear via pointer.

2024-11-09 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Fix generation of invalid asm for bit-field read.
	* sim/ucsim/src/sims/f8.src/decode.h,
	  sim/ucsim/src/sims/f8.src/f8cl.h,
	  sim/ucsim/src/sims/f8.src/glob.cc:
	  Fix ldw y, z f8 instruction simulation.

2024-11-08 Benedikt Freisen <b.freisen AT gmx.net>

	* doc/sdccman.lyx,
	  src/SDCC.y,
	  src/SDCCerr.c,
	  src/SDCCerr.h,
	  src/SDCCsymt.c,
	  src/SDCCsymt.h,
	  support/regression/tests/typed-enum.c,
	  support/valdiag/tests/typed-enum.c:
	  Implement C23's explicitly typed enums, see [feature-requests:#847].

2024-11-06 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCralloc.hpp:
	  Fallback to std::multimap instead of boost::container::flat_multimap for all boost up to 1.85.0.
	* src/SDCCopt.c,
	  support/regression/tests/bug-3780.c:
	  Fix bug #3780.
	* src/SDCCsystem.c:
	  Fix bug #3616 via patch #482 by Janko Stamenović.

2024-11-04 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/cpp/gcc/c-family/c-ppoutput.cc:
	  Fix bug #3794.
	* support/valdiag/tests/bug-3014.c:
	  Adapt test to recent K&R changes.

2024-11-03 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/scripts/sdcc.nsi:
	  Do not try to include XA-51 simulator (which is no longer built by default) in Windows installer.

2024-11-03 Benedikt Freisen <b.freisen AT gmx.net>

	* doc/sdccman.lyx,
	  src/SDCC.y,
	  src/SDCCerr.c,
	  src/SDCCerr.h,
	  src/SDCCsymt.c,
	  src/SDCCsymt.h:
	  Add syntactic support for K&R-style functions.

2024-11-03 Benedikt Freisen <b.freisen AT gmx.net>

	* doc/sdccman.lyx,
	  src/SDCC.y,
	  src/SDCCast.c,
	  src/SDCCerr.c,
	  src/SDCCerr.h,
	  support/regression/tests/generic.c:
	  Add C2y generic selection based on a type name.

2024-11-03 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-3795.c:
	  Add a regression test for a bug encountered in z88dk.

2024-11-03 Benedikt Freisen <b.freisen AT gmx.net>

	* support/regression/cases/Makefile.in:
	  Tidy up list of excluded test cases.

2024-11-01 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCpeeph.c:
	  Fix bug #3792.
	* src/SDCCopt.c:
	  Workaround for bug #3793.
	* src/SDCCmain.c:
	  Fix bug #3790.

2024-10-31 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  support/regression/tests/bug-3791.c:
	  Fix bug #3791.

2024-10-29 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-3788.c:
	  Disable a test that assumes SDCC implementation-defined behaviour for host.
	* src/z80/peeph.def:
	  z80 peephole optimizer rule improvements.
	* src/z80/gen.c:
	  Improve use of information from generalized constant propagation in z80 subtraction code generation.
	* src/SDCCopt.c:
	  Optimize out a few more casts, part of RFE #937.

2024-10-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* doc/sdccman.lyx:
	  Fix some mentions of Windows in manual.

2024-10-27 Benedikt Freisen <b.freisen AT gmx.net>

	* doc/sdccman.lyx,
	  src/SDCC.y,
	  src/SDCCast.c,
	  src/SDCCast.h,
	  src/SDCCerr.c,
	  src/SDCCerr.h,
	  support/regression/tests/caseranges.c,
	  support/valdiag/tests/switch.c:
	  Add C2y case range expressions [feature-requests:#947] based on [patches:#313], adapted to match n3370.

2024-10-27 Benedikt Freisen <b.freisen AT gmx.net>

	* doc/sdccman.lyx,
	  src/SDCC.lex,
	  src/SDCCglobl.h,
	  src/SDCCmain.c:
	  Add C2y mode in preparation for the first C2y features.

2024-10-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/stm8/gen.c:
	  Small improvment in stm8 struct/union parameter passing.

2024-10-26 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/z80n/mul.s,
	  device/lib/z80n/mulchar.s:
	  Z80N hardware multiplication for _mulint, patch #481 by Janko Stamenović.
	* src/SDCCcse.c,
	  support/regression/tests/bug-3788.c:
	  Fix bug #3788.

2024-10-18 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-3788.c:
	  Regression test for bug #3788 (disabled until bug is fixed).

2024-10-16 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Fix bug #3789.

2024-10-16 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Generalize a byte-assembly | optimization to make better use of 16-bit stores to stack.

2024-10-15 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc,
	  src/z80/gen.c:
	  Some improvements in optimizations based on generalized constant propagation.

2024-10-15 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCopt.c:
	  Optimize out some casts and assignments earlier, part of RFE #937.
	* src/z80/gen.c:
	  Improve handling of parameters of z80 builtin functions.

2024-10-14 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCopt.c:
	  Optimize out some more casts, part of RFE #937.

2024-10-13 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/stm8/gen.c,
	  src/z80/gen.c:
	  Fix a z80 pointer write codegen bug.

2024-10-12 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/f8/gen.c: fixed warnings
	* src/mos6502/gen.c (genFunction, genEndFunction): fixed bug #3787
	* src/ds390/main.c: cosmetics
	* src/SDCCralloc.hpp: fail for all 1.85.x
	* src/SDCCsalloc.hpp: require Boost >= 1.79
	* src/SDCCgenconstprop.cc,
	* src/SDCClospre.hpp,
	* src/SDCCnaddr.hpp: removed BOOST_VERSION = 1.60 test
	* src/SDCCmem.c (printAllocInfoSeg): print upto 8 registers
	* src/SDCCmem.h: Added void as parameter
	* src/SDCCsymt.h: removed unused IS_RENT

2024-10-12 Maarten Brock <sourceforge.brock AT dse.nl>

	* sdas/as6500/clean.mk,
	* sdas/as6808/clean.mk,
	* sdas/as8051/clean.mk,
	* sdas/as8xcxxx/clean.mk,
	* sdas/asf8/clean.mk,
	* sdas/asgb/clean.mk,
	* sdas/aspdk13/clean.mk,
	* sdas/aspdk14/clean.mk,
	* sdas/aspdk15/clean.mk,
	* sdas/aspdk16/clean.mk,
	* sdas/asrab/clean.mk,
	* sdas/asstm8/clean.mk,
	* sdas/astlcs90/clean.mk,
	* sdas/asz80/clean.mk,
	* sdas/linksrc/clean.mk,
	* sdas/clean.mk,
	* src/clean.mk,
	* src/port-clean.mk,
	* support/makebin/clean.mk,
	* support/packihx/clean.mk,
	* support/scripts/clean.mk,
	* clean.mk: improved cleaning

2024-10-11 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCopt.c:
	  Optimize out CAST following ADDRESS_OF, part of RFE #937.
	* src/SDCCglue.c,
	  support/regression/tests/bug-3786.c,
	  support/regression/tests/bug-3728.c:
	  Fix bug #3786.

2024-10-09 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCopt.c:
	  Fix an issue in cast optimization that resulted in a -mmcs51 --model-large regression test failure.

2024-10-08 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCopt.c,
	  src/SDCCopt.h,
	  src/stm8/ralloc.c:
	  Code cleanup using C99 features.

2024-10-07 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCopt.c:
	  Optimize out some assignments followed by casts, part of RFE #937.
	* src/stm8/peep.c,
	  src/stm8/peeph.def:
	  Merge some offset calculations into stm8 instructions.

2024-10-07 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mcs51/gen.c:
	  Fix a code generation bug in pointer write (register save/restore order).
	* src/z80/gen.c:
	  Improve flexibility of handling of rematerialized on-stack addresses.
	* src/SDCCcse.c,
	  src/SDCCloop.c,
	  src/SDCCopt.c:
	  unsetDefsAndUses at uses of remiCodeFromeBBlockcalls.

2024-10-04 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCopt.c,
	  src/mcs51/gen.c:
	  Fix bug #3783.

2024-09-30 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCopt.c:
	  Disable an optimization while bug #3783 is being looked into.
	* doc/sdccman.lyx,
	  src/port.h:
	  Remove references to obsolete RLC, RRC iCode.

2024-09-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCmain.c:
	  Fix an issue in command line parsing.

2024-09-26 Philipp Klaus Krause <philipp@colecovision.eu>

	* doc/sdccman.lyx,
	  src/SDCCmain.c:
	  Make the official standard names and nicknames the most prominent way to refer to standards in documentation.

2024-09-23 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCopt.c,
	  src/SDCCsymt.c,
	  src/SDCClospre.cc:
	  Improve handling of nested struct/union/array, part of RFE #937.

2024-09-20 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/stm8/gen.c:
	  Improve handling of rematerialized stack locations.

2024-09-19 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/hc08/gen.c,
	  src/mos6502/gen.c:
	  Assertions to help track down bug #3781.

2024-09-18 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/peeph.def:
	  Peephole optimizer rule flag condition fix.

2024-09-18 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  src/z80/peeph.def:
	  Fix and improve right shift optimization, RFE #935.

2024-09-17 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  src/z80/peeph.def,
	  support/regression/tests/shifts3.c.in:
	  Right shift optimization inspired by RFE #935.

2024-09-15 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdcc/support/scripts/sdcc.nsi:
	  Include f8 port in Windows installer.
	* src/SDCClabel.c,
	  src/SDCCopt.c:
	  Improve handling of string literals in dead-code elimination, RFE #567.

2024-09-10 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  support/regression/tests/bug-3779.c:
	  Fix bug #3779.

2024-09-09 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCval.c,
	  src/pic14/main.c,
	  src/pic16/main.c,
	  src/stm8/gen.c,
	  src/z80/gen.c:
	  Operator priority fixes from patch #474.
	* device/lib/clean.mk:
	  Fix make clean for f8 library.
	* src/mcs51/main.c,
	  support/regression/tests/patch-466.c:
	  Pick some bits of patch #466.

2024-09-08 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/ports/ez80-z80/spec.mk,
	  support/regression/ports/ucz180/spec.mk,
	  support/regression/ports/ucz180-resiy/spec.mk:
	  Use 60s regression test timeout for most z80-related ports.

2024-09-06 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-2645.c,
	  support/regression/tests/bug-2663.c:
	  Fix remaining part of bug #3770.

2024-09-04 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc:
	  Fix a remaining aspect of bug #3778, affecting the huge memory model of mcs51.

2024-09-04 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-3460.c.in,
	  support/regression/tests/sizeof.c.in,
	  support/regression/tests/bug-2854.c,
	  support/regression/MakeList,
	  support/regression/tests/bug-2776.c,
	  support/regression/tests/implicit_int.c
	  Fix most of bug #3770, mostly by disabling tests for host target that rely on features no longer available in current host compilers.

2024-09-03 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCerr.c,
	  src/SDCCerr.h,
	  src/SDCCsymt.c,
	  support/valdiag/tests/bug-3773.c:
	  Improve diagnostics on out-of-range absolute addresses.
	* sim/ucsim/src/sims/stm8.src/stm8.cc:
	  Fix stm8 program counter width.
	* src/SDCCgenconstprop.cc,
	  support/regression/tests/bug-3778.c,
	  .version:
	  Fix bug #3778.

2024-09-01 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Optimize shift of 8-bit values, part of RFE #939.

2024-09-01 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Fix an unsafe read being used even without --allow-unsafe-read.

2024-08-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCsalloc.hpp:
	  Do not compile with older, known-to-be-broken boost.

2024-08-23 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCval.c:
	  Fix bug #3745.

2024-08-23 Maarten Brock <sourceforge.brock AT dse.nl>

	* support/regression/Makefile.in: fixed distclean for cases dir

2024-08-21 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Fix label at end of compound statement.

2024-08-18 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Fix label defore declaration.
	* src/pdk/gen.c:
	  Fix a pdk code generation issue, part of bug #3697.

2024-08-14 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdccconf_in.h:
	  Regenerate file via autoheader to fix --disable-f8-port.
	* support/regression/tests/bug-3745.c.in:
	  Test more qualifiers.

2024-08-11 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/MakeList:
	  Disable a test for pdk15, where it fails due to lack of memory.
	* src/SDCCast.c,
	  src/SDCCopt.c,
	  src/SDCCsalloc.hpp,
	  src/mcs51/main.c,
	  src/z80/gen.c,
	  src/SDCCsymt.c:
	  A bit of code refactoring inspired by GCC 14 / clang 19 warnings.
	* support/regression/tests/wcsto.c:
	  Fix an issue discovered via a GCC 14 warning.

2024-08-09 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/ds390/gen.c:
	  Fix bug #3769.

2024-08-08 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCopt.c,
	  src/SDCCsymt.c,
	  support/regression/tests/bug-3766.c:
	  Fix bug #3766.
	* src/pic16/glue.c:
	  Try to fix bug #3767.
	* support/regression/tests/bug-3745.c:
	  Regression test for bug #3745.

2024-08-04 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/include/setjmp.h,
	  sim/ucsim/src/sims/f8.src/decode.h,
	  sim/ucsim/src/sims/f8.src/f8cl.h,
	  sim/ucsim/src/sims/f8.src/glob.cc,
	  sim/ucsim/src/sims/f8.src/imove.cc,
	  support/regression/tests/rotate.c.in:
	  f8 fixes.

2024-08-04 Philipp Klaus Krause <philipp@colecovision.eu>

	* Merge sdcc from f8 branch to trunk.

2024-08-04 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Small f8 codegen improvements.

2024-08-02 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8mch.c,
	  src/f8/gen.c:
	  Adapt to instruction changes.

2024-07-31 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/f8/Makefile.in,
	  sdas/asf8/f8mch.c,
	  src/f8/gen.c:
	  Replace xchb by modified msk.

2024-07-29 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8mch.c:
	  Update xchw instruction.

2024-06-24 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/ports/f8/spec.mk:
	  Adapt f8 regression testing to new simulator directory structure.

2024-07-24 Maarten Brock <sourceforge.brock AT dse.nl>

	* support/regression/tests/wchar.c.in: added _FORTIFY_SOURCE==3 exception

2024-07-23 Maarten Brock <sourceforge.brock AT dse.nl>

	* support/regression/cases/HTMLgen.py: fixed bad escape no longer accepted
	  by Python 3.12

2024-07-17 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/lib/z80/__ultobcd.s: removed comments about odd ABI,
	  added .optsdcc -mz80 sdcccall(1)

2024-07-17 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/lib/ds390/__sdcc_atomic_maybe_rollback.c: bugfix moved push psw,
	  renamed __sdcc_atomic_exchange_rollback_impl to sdcc_atomic_exchange_rollback_start,
	  changed __sdcc_atomic_exchange_rollback_impl+40 to sdcc_atomic_exchange_rollback_end,
	  bugfix outer_skip, 3$ & 4$
	* device/lib/mcs51/__sdcc_atomic_maybe_rollback.asm: bugfix moved push psw,
	  renamed __sdcc_atomic_exchange_rollback_impl to sdcc_atomic_exchange_rollback_start,
	  changed __sdcc_atomic_exchange_rollback_impl+40 to sdcc_atomic_exchange_rollback_end
	* device/lib/ds390/atomic_flag_test_and_set.c,
	* device/lib/mcs51/atomic_flag_test_and_set.asm: renamed
	  ___sdcc_atomic_exchange_gptr_impl to sdcc_atomic_exchange_gptr_impl,
	  use ljmp instead of lcall saving stack space,
	  let that return in dpl instead of going through acc
	* device/lib/mcs51/gptr_cmp.asm: moved push/pop dpl inside if
	* device/lib/z80/__itoa.s,
	* device/lib/z80/__ltoa.s,
	* device/lib/z80/__mulsint2slong.s,
	* device/lib/z80/__strreverse.s,
	* device/lib/z80/__uitobcd.s,
	* device/lib/z80/abs.s,
	* device/lib/z80/atomic_flag_test_and_set.s,
	* device/lib/z80/crt0.s,
	* device/lib/z80/divmixed.s,
	* device/lib/z80/divsigned.s,
	* device/lib/z80/divunsigned.s,
	* device/lib/z80/memcpy.s,
	* device/lib/z80/memmove.s,
	* device/lib/z80/modmixed.s,
	* device/lib/z80/modsigned.s,
	* device/lib/z80/modunsigned.s,
	* device/lib/z80/mul.s,
	* device/lib/z80/mulchar.s,
	* device/lib/z80/setjmp.s,
	* device/lib/z80/strcpy.s,
	* device/lib/z80/strlen.s: added .module <name> & .optsdcc -mz80 sdcccall(1)
	* device/lib/z80/__ultobcd.s: added .module <name>,
	  added comments about odd ABI,
	  small optimization
	* src/SDCCerr.c (vwerror): print with newlines
	* src/SDCCglue.c (glue): emit .module first,
	  renamed genAssemblerPreamble to genAssemblerStart,
	  moved mcs51_like part to genAssemblerStart,
	  emit .optsdcc in genAssemblerStart
	* src/SDCCopt.c (checkRestartAtomic),
	* src/SDCCsymt.c (newSymbol): added commented out C11 check
	* src/pic14/glue.c (picglue),
	* src/pic16/glue.c (pic16glue),
	* src/port.h: renamed genAssemblerPreamble to genAssemblerStart
	* src/avr/main.c (_avr_genAssemblerPreamble): emit .optsdcc,
	   renamed to _avr_genAssemblerStart
	* src/ds390/main.c (_ds390_genAssemblerPreamble): emit .optsdcc,
	  renamed to _ds390_genAssemblerStart,
	  (ds390_genAtomicSupport): added commented out C11 check,
	  renamed __sdcc_atomic_exchange_rollback_impl to sdcc_atomic_exchange_rollback_start,
	  renamed ___sdcc_atomic_exchange_<>_impl to sdcc_atomic_exchange_<>_impl,
	  added sdcc_atomic_exchange_rollback_end,
	  added sdcc_atomic_exchange_exit to load dpl,
	  (_ds390_genIVT): bugfix nextbyteaddr calculations
	* src/hc08/main.c (_hc08_genAssemblerPreamble): emit .optsdcc,
	  renamed to _hc08_genAssemblerStart
	* src/mcs51/gen.c (genCall, genPcall): skip saving regs & call cleanup for
	  NoReturn destination, also use ljmp
	* src/mcs51/main.c (_mcs51_genAssemblerPreamble): emit .optsdcc,
	  renamed to _mcs51_genAssemblerStart,
	  (mcs51_genAtomicSupport): added commented out C11 check,
	  renamed __sdcc_atomic_exchange_rollback_impl to sdcc_atomic_exchange_rollback_start,
	  renamed ___sdcc_atomic_exchange_<>_impl to sdcc_atomic_exchange_<>_impl,
	  added sdcc_atomic_exchange_rollback_end,
	  added sdcc_atomic_exchange_exit to load dpl,
	  (_mcs51_genIVT): bugfix nextbyteaddr calculations
	* src/mos6502/main.c: emit .optsdcc,
	  renamed <>_genAssemblerPreamble to <>_genAssemblerStart,
	  many cosmetics
	* src/pdk/main.c (pdk_genAssemblerStart): emit .optsdcc
	* src/pic14/main.c (_pic14_genAssemblerPreamble),
	* src/pic16/main.c (_pic16_genAssemblerPreamble): renamed to <>_genAssemblerStart
	* src/z80/main.c (_z80_genAssemblerStart): new, added to emit .optsdcc,
	  includes calling convention
	* src/z80/mappings.i: added .optsdcc

2024-07-15 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/ds390/main.c,
	  src/mcs51/main.c:
	  Optimize atomic_exchange / atomic_flag_test_and_set.
	* src/SDCCpeeph.c:
	  Fix bug #3753.
	* src/stm8/peep.c:
	  Improve stm8 notUsed() accuracy, part of RFE #936.
	* src/stm8/gen.c:
	  Improve choice of shift location, part of RFE #936.

2024-07-14 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/include/setjmp.h: explicit __SDCC_mcs51 condition
	* device/lib/_fs2schar.c,
	* device/lib/_fs2sint.c,
	* device/lib/_fs2slong.c,
	* device/lib/_fs2uchar.c,
	* device/lib/_fs2uint.c,
	* device/lib/_fs2ulong.c,
	* device/lib/_fsadd.c,
	* device/lib/_fsdiv.c,
	* device/lib/_fseq.c,
	* device/lib/_fslt.c,
	* device/lib/_fsmul.c,
	* device/lib/_fsneq.c,
	* device/lib/_fssub.c,
	* device/lib/_schar2fs.c,
	* device/lib/_sint2fs.c,
	* device/lib/_slong2fs.c,
	* device/lib/_uchar2fs.c,
	* device/lib/_uint2fs.c,
	* device/lib/_ulong2fs.c: __fs* explicitly marked __SDCC_FLOAT_NONBANKED
	* device/lib/printf_tiny.c: indented #if, simplified
	* src/z80/gen.c (genJumpTab): fixed warning
	* support/regression/MakeList: extended EXCLUDE_mcs51-xstack-auto
	* support/regression/compact-results.py: tidied result output
	* support/regression/gte/loop-ivopts-2.c: cosmetics
	* support/regression/gte/memcpy-1.c: fixed warnings
	* support/regression/gte/20030920-1.c,
	* support/regression/qct/0025-string.c,
	* support/regression/qct/0027-charval.c,
	* support/regression/qct/0059-multistring.c,
	* support/regression/tcc/21_char_array.c,
	* support/regression/tcc/80_flexarray.c: const pointers to fix warnings
	* support/regression/gte/20041218-1.c,
	* support/regression/tests/bug-3727.c: void cast unused params to fix warnings
	* support/regression/tests/bug-3741.c: fixed warnings

2024-07-11 Philipp Klaus Krause <philipp@colecovision.eu>

	* .version,
	  device/include/stdatomic.h,
	  device/lib/ds390/Makefile.in,
	  device/lib/ds390/atomic_flag_test_and_set.c,
	  device/lib/ds390/__sdcc_atomic_maybe_rollback.c,
	  device/lib/mcs51/__sdcc_atomic_maybe_rollback.asm,
	  device/lib/mcs51/Makefile.in,
	  device/lib/mcs51/atomic_flag_test_and_set.asm,
	  src/SDCCopt.c,
	  src/SDCCsymt.c,
	  src/SDCCsymt.h,
	  src/ds390/main.c,
	  src/mcs51/gen.c,
	  src/mcs51/main.c,
	  support/regression/tests/atomic.c:
	  Full atomic_flag for mcs51, ds390. Some infrastructure for lock-free atomics.

2024-07-05 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/peeph.def:
	  Fix bug #3757.

2024-06-28 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/peep.c,
	  src/z80/peeph.def:
	  z80 peephole optimizer improvements.

2024-06-25 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Improve 16-bit signed right shift code generation.

2024-06-24 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  src/z80/peeph.def:
	  Improve handling of hl in code generation.

2024-06-22 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/*/setjmp.s:
	  Improve setjmp/longjmp for z80-related ports, patch #479 by Janko Stamenović.

2024-06-18 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* device/lib/s08-stack-auto/_setjmp.c: fix bug #3743
	* support/regression/tests/longjump.c: re-enable test affected by bug

2024-06-17 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/sm83/Makefile.in:
	  Fix strnlen build for sm83 port.

2024-06-16 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/longjmp.c:
	  Disable a test for configuration affected by known bug #3743 (-ms08 --stack-auto).

2024-06-14 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/hc08/main.c (hasExtBitOp),
	  src/mos6502/main.c (hasExtBitOp): fix bug #3731
	* support/regression/tests/sha3-256.c: only enabled for ports
	  that can handle returning large structs 
	* src/mos6502/gen.c (genRet): fail unsupported struct return better

2024-06-13 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/r2k/setjmp.s
	  device/lib/r2ka/setjmp.s
	  device/lib/r3ka/setjmp.s
	  support/regression/tests/setjmp.c,
	  support/regression/tests/longjmp.c:
	  Fix setjmp/longjmp return value for Rabbits.
	* device/include/string.h,
	  device/lib/strlen.v,
	  device/lib/strnlen.v,
	  device/lib/strndup.c,
	  device/lib/Makefile.in,
	  device/lib/*/Makefile.in,
	  device/lib/pic14/libc/Makefile.am,
	  device/lib/pic14/libc/Makefile.in,
	  support/regression/tests/strnlen.c:
	  C2Y strnlen.
	* support/regression/tests/bug-3730.c,
	  support/regression/tests/bug-3740.c:
	  Disable warnings on (intentionally) unused parameters in two regression tests.
	* device/lib/tlcs90/setjmp.s:
	  Fix TLCs-90 interrupt flag handling in longjmp.

2024-06-08 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCsalloc.hpp:
	  Fix handling of edges in vertex removal from stack conflict graph on spill location parameter merge.

2024-06-06 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-3741.c:
	  Fix test for ports without banked function calls.

2024-06-05 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-3741.c:
	  Add a regression test for a reported bug that I haven't been able to reproduce locally.

2024-06-03 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc,
	  src/SDCCdflow.h:
	  Fix a z80 codegen issue in the handling of information from generalized constant propagation.

2024-06-03 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  support/regression/tests/bug-3740.c:
	  Fix bug #3740.

2024-05-31 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/peep.c:
	  Parse ZX Spectrum Next nextreg instruction.

2024-05-30 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCralloc.hpp,
	  src/hc08/gen.c:
	  Reject boost 1.85.0.

2024-05-29 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Skip leading zeroes on comparisons and some increments.

2024-05-28 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Use information from generalized constant propagation to optimize comparisons of signed types.

2024-05-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  z80 codegen improvements.

2024-05-21 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCsalloc.hpp,
	  src/stm8/ralloc2.cc,
	  src/stm8/gen.c,
	  src/z80/ralloc2.cc:
	  Use stack parameter locations as spill locations in some simple cases.

2024-05-16 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/peeph.def,
	  support/regression/tests/bug-3733.c:
	  Fix bug #3733.

2024-05-14 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/peep.c:
	  f8 jump distance calculation.

2024-05-13 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/peep.c:
	  f8 jump distance estimation.

2024-05-08 Philipp Klaus Krause <philipp@colecovision.eu>

	* sim/ucsim/f8.src/decode.h,
	  sim/ucsim/f8.src/f8cl.h,
	  sim/ucsim/f8.src/glob.cc,
	  sim/ucsim/f8.src/imove.cc:
	  ldi, ldwi f8 simulator support.

2024-05-07 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8.h,
	  sdas/asf8/f8mch.c,
	  sdas/asf8/f8pst.c,
	  sim/ucsim/f8.src/decode.h,
	  sim/ucsim/f8.src/disass.cc,
	  sim/ucsim/f8.src/f8.cc,
	  sim/ucsim/f8.src/f8cl.h,
	  sim/ucsim/f8.src/glob.cc,
	  sim/ucsim/f8.src/ialu.cc,
	  sim/ucsim/f8.src/imove.cc,
	  src/f8/gen.c,
	  src/f8/peep.c:
	  Revise f8 instruction set.

2024-05-03 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/sha3-256.c:
	  SHA3-256 test assumes little endian, so disable it for other systems.

2024-05-02 Philipp Klaus Krause <philipp@colecovision.eu>

	* doc/sdccman.lyx:
	  mcs51 named address space clarifications.
	* support/regression/tests/sha3-256.c:
	  Test for bug #3731.

2024-05-01 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/peeph.def:
	  Fix an issue in previous commit.

2024-04-30 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/ralloc2.cc,
	  src/z80/peeph.def:
	  Improve use of register a and (hl) in comparisons.

2024-04-29 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  Fix an issue in the handling of register hl vs a in write via pointer.

2024-04-29 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/main.c:
	  Assume 6 KB RAM for f8 by default.

2024-04-26 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/ralloc2.cc:
	  Fix bug #3730.

2024-04-25 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-3730.c:
	  Test for bug #3730.

2024-04-24 Philipp Klaus Krause <philipp@colecovision.eu>

	* doc/sdccman.lyx:
	  Update documentation on implementation-defined behaviour.
	* sdas/astlcs90/t90.h,
	  sdas/astlcs90/t90mch.c,
	  sdas/astlcs90/t90pst.c,
	  src/z80/gen.c:
	  Use lda for tlcs90 codegen.

2024-04-23 Felix Salfelder <felix AT salfelder.org>

	* support/cpp/gcc/cc1_dummies.cc
	  Amend unused function prototypes. Fixes #3725

2024-04-23 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Global operand handling fixes.

2024-04-22 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  support/regression/ports/ucz80-unsafe-read:
	  Allow use 16-bit loads from memory to load 8-bit registers.

2024-04-22 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  src/z80/peeph.def:
	  Improve storing of 0 into global variables.

2024-04-22 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/scripts/as2gbmap.py:
	  Migrate as2gbmap to Python 3, patch from Debian.
	* src/z80/peep.c:
	  Improve handling of function calls in notUsed(From)('iy').
	* src/z80/gen.c:
	  Fix handling of operand in a in built-in strchr.

2024-04-19 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Improve handling of register argument in a in register allocation.

2024-04-19 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Fix generation of a redundant instruction in z80 comparison.

2024-04-18 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/peep.c:
	  Improve handling of function calls in notUsed(From).
	* src/z80/gen.c:
	  Improve addition of 256 to 16-bit register operand.

2024-04-17 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/discussion-1854.c,
	  support/regression/tests/bug-3728.c,
	  support/regression/tests/bug-3729.c:
	  Add 2 regression tests for potential issues.
	* src/f8/gen.c:
	  Fix bug #3729.
	* support/regression/tests/bug-2568.c,
	  support/regression/tests/bug2729218.c:
	  Adapt two tests that potentially use fixed addresses for f8 RAM location.

2024-04-16 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/include/asm/r2k/features.h,
	  device/include/asm/r3ka/features.h,
	  device/include/asm/sm83/features.h,
	  device/include/asm/stm8/features.h,
	  device/include/asm/tlcs90/features.h,
	  device/include/asm/z80/features.h,
	  device/lib/_strcmp.c,
	  device/lib/_strcpy.c,
	  src/z80/peeph.def,
	  support/regression/tests/bug-3728.c:
	  Fix bug #3728.
	* support/regression/tests/bug-3727.c:
	  Simplify regression test, as suggested by Janko Stamenović.

2024-04-16 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  src/z80/peeph.def,
	  src/z80/ralloc2.cc:
	  Improve use of hl, towards RFE #905.

2024-04-13 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  src/z80/ralloc2.cc:
	  Small z80 codegen improvements, part of RFE #905.

2024-04-12 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Small z80 codegen improvements, RFE #904.
	* support/regression/tests/bug-3727.c:
	  Regression test (for now disabled) for not-yet fixed bug #3727.

2024-03-31 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/ralloc2.cc,
	  src/z80/gen.c:
	  Improve code generation for z80 comparisons.
	* src/SDCClospre.cc,
	  src/SDCClospre.hpp:
	  Improve lospre debug output.

2024-03-29 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  src/stm8/ralloc.c,
	  src/pdk/ralloc.c,
	  src/z80/ralloc.c,
	  src/f8/ralloc.c:
	  Enable more register packing optimizations.

2024-03-29 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/ralloc.c,
	  src/f8/gen.c,
	  sim/ucsim/f8.src/ialu.cc:
	  Improve handling of global operands for f8.

2024-03-28 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/peeph.def:
	  Optimize out some more intermediate pop/push.
	* src/z80/gen.c:
	  Fine-tune djnz optimization hint.

2024-03-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc:
	  Fix an issue introduced in yesterday's fix for bug #3720.

2024-03-26 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Fix an optimization hint inversion bug that prevented use of djnz.

2024-03-26 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc,
	  src/SDCCsymt.c:
	  Fix bug #3720.
	* src/z80/gen.c:
	  Allow for some more flexibility in the handling of register arguments.

2024-03-25 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc:
	  Improve generalized constant propagation analysis accuracy.
	* src/stm8/peep.c,
	  src/z80/peep.c:
	  Fix a peephole optimizer issue in the handling of register parameters to calls through function pointers when a symbol had the same name as a register.

2023-03-24 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/peep.c,
	  src/f8/peeph.def:
	  Improve f8 notUsed() and notUsedFrom(), add more peephole optimizer rules using these.
	* sim/ucsim/f8.src/ialu.cc:
	  Fix n flag for sllw y, xl.
	* src/f8/gen.c:
	  Improve codegen for bitwise operations with partially-known operands.

2023-03-23 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.h,
	  src/f8/peep.c,
	  src/f8/peeph.def,
	  src/f8/gen.c,
	  src/f8/gen.h:
	  f8 notUsed().

2024-03-23 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc,
	  support/regression/tests/bug-3717.c:
	  Fix bug #3717.

2024-03-23 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc,
	  src/pdk/gen.c:
	  Improve generalized constant propagation analysis accuracy.

2023-03-19 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/f8/setjmp.s,
	  sdas/asf8/f8.h,
	  sdas/asf8/f8mch.c,
	  src/f8/gen.c:
	  Adjustments in f8 opcode prefix semantics.

2024-03-18 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/ralloc2.cc:
	  Improve use of hl for --reserve-regs-iy.

2023-03-17 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/f8/_divuint.s,
	  src/f8/peep.c,
	  src/f8/peeph.def:
	  Some small f8 codesize improvements.

2024-03-17 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/stm8/peeph.def:
	  Optimize out some tnz(w).

2024-03-16 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/stm8/peeph.def:
	  Simplify some stm8 pushw, common at beginning of function.

2024-03-09 Philipp Klaus Krause <philipp@colecovision.eu>

	* sim/ucsim/f8.src/imove.cc,
	  device/lib/f8/_divsint.s:
	  Implement new behaviour of n and z flags for loads from memory.

2024-03-05 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c,
	  src/f8/main.c:
	  Fix code generation for interrupt handlers.

2024-03-03 Benedikt Freisen <b.freisen AT gmx.net>

	* src/SDCCgenconstprop.cc:
	  Remove semicolon after if-condition. (bug #3713)

2024-03-01 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8mch.c:
	  Implement f8 instruction cax (y), zl, xl.

2024-03-01 Philipp Klaus Krause <philipp@colecovision.eu>

	* doc/sdccman.lyx:
	  Workaround for a LyX 2.4 issue, fixes bug #3708.

2024-02-29 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c:
	  change safeLabelKey2num macro to safeLabeNum function.

2024-02-29 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mcs51/gen.c,
	  src/SDCCsymt.c,
	  support/regression/tests/bug-3711.c:
	  Fix bug #3711.

2024-02-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/main.c:
	  Code cleanup: f8 port does not support different memory models.

2024-02-26 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8.h,
	  sdas/asf8/f8mch.c,
	  sdas/asf8/f8pst.c:
	  Implement f8 dnjnz and ld yh, #i.

2024-02-20 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c:
	  Rename jflag in genIfxJump from "a" to "z".
	  Refactor genAnd, GenOr, GenXor.

2024-02-19 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdcc/sdas/asf8/f8.h,
	  sdcc/sdas/asf8/f8mch.c,
	  sdcc/sdas/asf8/f8pst.c:
	  Implement f8 xchw.
	* src/f8/gen.c:
	  Enable use of all jump instructions in comparison codegen.

2024-02-19 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c:
	  Remove a few dead code paths.
	  Improve tracking of literals in the RegTemp stack.
	* src/mos6502/peeph.def:
	  Add rule for tax/tay followed by tax/tay.

2024-02-17 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c,
	  src/mos6502/main.c,
	  src/mos6502/ralloc.c:
	  Fix compile warnings and a few typos.

2024-02-10 Benedikt Freisen <b.freisen AT gmx.net>

	* device/include/mcs51/stc89.h:
	  Fix typo in watchdog SFR definition. (bug #3710)

2024-02-04 Benedikt Freisen <b.freisen AT gmx.net>

	* debugger/mcs51/sdcdb.h,
	  debugger/mcs51/symtab.c:
	  Fix bug #3529 via patch #450 by Mark Symonds.

2024-02-04 Benedikt Freisen <b.freisen AT gmx.net>

	* device/include/stddef.h:
	  Use >= instead of > for C23 test. (bug #3709)

2024-02-03 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/scripts/sdcc.nsi:
	  Fix installer creation script for recent pic16 library changes.

2024-02-01 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asrab/rabmch.c:
	  Back-port error messages from asrab 5.40, patch #473 by D-mo.
	* support/scripts/sdcc.nsi:
	  Fix installer creation script for recent pic16 library changes.

2024-01-31 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/include/pic16,
	  device/lib/pic16,
	  device/non-free/lib/pic16,
	  src/pic16,
	  device/include/asm/pic16/features.h,
	  device/include/sdcc-lib.h,
	  device/include/setjmp.h,
	  device/include/stdarg.h,
	  device/include/stdint.h,
	  support/regression/tests/float_single.c.in:
	  pic16 refactoring and fixes, parts 1 to 3 and 7 to 10 of patch #472 by Jonathon Hall.

2024-01-29 Philipp Klaus Krause <philipp@colecovision.eu>

	* Merge next branch to trunk.

2024-01-28 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c:
	  Refactor asmopToBool().
  	* src/mos6502/gen.c:
  	  Improvements to genAnd().

2024-01-27 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c,
	  src/mos6502/ralloc.h:
	  Remove dead references to M6502MASK_REV.

2024-01-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asz80/z80mch.c:
	  Fix bug #3700.

2024-01-27 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/ralloc.c:
	  Small cleanup of m6502_dirtyReg.
   	* src/mos6502/gen.c:
   	  Imporvements to genCmp.

2024-01-26 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asgb/gbmch.c
	  .version,
	  doc/sdccman.lyx:
	  Export 32-bit addresses from gb assembler (instead of 24-bit).

2024-01-22 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/pdk/gen.c:
	  Fix pdk code generation issues, bug #3697.
	* sdas/asz80/z80mch.c:
	  Export 32-bit addresses from z80 assembler (instead of 24-bit).

2024-01-20 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/pdk/gen.c:
	  Fix pdk code generation issues, bug #3697.

2024-01-16 Benedikt Freisen <b.freisen AT gmx.net>

	* src/Makefile.in:
	  Makeshift fix for bug #3694: Delete sdcpp in uninstall.

2024-01-15 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/peep.def:
	  Fix bug in peephole load 12 rule.
  	* src/mos6502/gen.c,
	  src/mos6502/peep.def:
	  Improvements in genCast(), genCopy() and loadRegFromAop().

2024-01-15 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/scripts/sdcc.nsi:
	  Fix bug #3695.

2023-01-14 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/pdk/gen.c,
	  src/pdk/ralloc.c,
	  src/pdk/ralloc2.cc:
	  Optimize pdk register packing for some operations on __sfr (part of RFE #801).

2024-01-13 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c:
	  Fix constanRange regression failure for mos6502-stack-auto.
	  Implement special case for genCompare < 0
	* src/mos6502/ralloc2.cc:
	  Add instruction cost for IPUSH_VALUE_AT_ADDRESS icode.
	* src/mos6502/peep.def:
	  Add several new rules that take advantage of if used().
	* support/regression/ports/uc6502-stack-auto/spec.mk,
	  support/regression/tests/gcc-torture-execute-20010129-1.c,
	  support/regression/tests/gcc-torture-execute-20030916-1.c,
	  support/regression/tests/gcc-torture-execute-20071030-1.c,
	  support/regression/tests/gcc-torture-execute-930614-2.c,
	  support/regression/tests/gcc-torture-execute-930628-1.c,
	  support/regression/tests/gcc-torture-execute-990513-1.c,
	  support/regression/tests/gcc-torture-execute-ssad-run.c,
	  support/regression/tests/gcc-torture-execute-usad-run.c,
	  support/regression/tests/lonesha256.c,
	  support/regression/tests/tinyaes.c.in:
	  disable tests failing in the mos6502-stack-auto port due to stack size limitation.
  	* src/mos6502/main.c:
	  Rearrange memory segments to support systems without ROM space.
   	* src/mos6502/gen.c,
   	  src/mos6502/ralloc.h:
   	  Remove dead code to support registers in reverse order.

2024-01-12 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c:
	  Improve asmopToBool.

2024-01-12 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/hc08/main.c:
	  Fix bug #3690.

2024-01-12 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/pdk/peep.c:
	  Improve pdk notUsed() accuracy.

2024-01-11 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/main.c:
	  Fix bug #3693.
	* support/scripts/sdcc.nsi:
	  Fix bug #3686.

2024-01-10 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c:
	  Implement a few 65C02 optimizations.

2024-01-09 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c:
	  Additional carry flag tracking optimizations.
  	* src/mos6502/gen.c:
	  Improve debug messages.

2024-01-08 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/ports/pic16/spec.mk,
	  sdcc/src/pic16/gen.c,
	  sdcc/src/pic16/gen.h,
	  sdcc/src/pic16/genutils.c,
	  sdcc/src/pic16/genutils.h,
	  sdcc/src/pic16/ralloc.c,
	  sdcc/src/SDCCsymt.c:
	  Basic pic16 long long support, patch #471 by Jonathon Hall.

2024-01-08 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c:
	  replace all instances of emitLabel() with safeEmitLabel().
 	* src/mos6502/gen.c,
 	  src/mos6502/main.c:
 	  enable last operation flag tracking.
   	* src/mos6502/gen.c:
	  enable carry flag tracking.

2024-01-03 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/_divuchar.c,
	  device/lib/_moduchar.c:
	  Fix optimization turning division support troutines into infinite loops.
	* device/lib/pdk*/Makefile.in,
	  device/lib/pdk*/_muluchar.s:
	  Improve pdk 8x8 multiplication efficiency, based on patch #470 by Konstantin Kim.

2024-01-02 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/satcounteroverflow.c.in:
	  Regression test for saturating counter implemented via overflow-check-revert, inspired by discussion of patch #447 by Konstantin Kim.

2023-12-30 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/pdk/peeph.def:
	  Fixes for z flag handling in pdk peephole optimizer rules.
	* src/pdk/gen.c,
	  src/pdk/peeph.def:
	  Optimize out some redundant stores to a, insprired by parts of patch #447 by Konstantin Kim.
	* src/SDCCpeeph.c:
	  Fix notVolatile('a') for pdk.
	* src/pdk/peep.c:
	  Improve flag handling in pdk peephole optimizer.
	* src/z80/peep.c:
	  Improve flag handling in z80 peephole optimizer.

2023-12-29 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c:
	  Imporve use of BIT instruction.
	* src/mos6502/ralloc.c,
	  src/mos6502/ralloc.h:
	  Prepare for improved register pair handling.
	* src/mos6502/gen.c:
	  correct constant size in isLiteralBit().
	* src/mos6502/gen.c:
	  Prepare for improved register pair handling.

2023-12-29 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/pdk/peep.c:
	  pdk peephole optimizer improvements, mostly from patch #447 by Konstantin Kim.
	* support/regression/tests/iobit.c.in:
	  Improve test coverage for bit access on __sfr, inspired by discussion of patch #447.
	* src/pdk/peeph.def:
	  Add a peephole optimizer rule from patch #447 by Konstantin Kim.

2023-12-29 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c,
	  src/mos6502/gen.h,
	  src/hc08/gen.c,
	  src/hc08/gen.h:
	  remove unused aop_immd2 from aop structure.

2023-12-28 Gabriele Gorla <gorlik@yahoo.com>

	* device/lib/mos6502/_divuchar.s,
	  device/lib/mos6502/_moduchar.s:
	  Fix regression failures introduced by r14555
	* src/mos6502/gen.c,
	  src/hc08/gen.c,
	  support/regression/tests/gcc-torture-execute-strlen-4.c:
	  Fix bug #2987 and enable gcc-torture-execute-strlen-4 for mos6502 and hc08.
	* src/SDCCicode.c:
	  Fix small debug print bug.
	* src/mos6502/peep.c:
	  Fix affected flags and add "sec".
	* src/mos6502/gen.c:
	  Minor code cleanups
	  Make comments style consistent

2023-12-28 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mcs51/peeph.def:
	  Optimize out some unnecessary register use.

2023-12-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/peep.c:
	  Improve handling of I/O and tail calls, fixes bug #3688.
	* src/SDCCerr.c,
	  src/SDCCerr.h,
	  src/SDCCpeeph.c:
	  Peephole rule application limit, fixes bug #3557.
	* src/SDCCgenconstprop.cc:
	  Improve narrowing of multiplicative operators based on generalized constant propagation.
	* src/mcs51/peeph.def:
	  Peephole optimizer rule to optimize another variant of __code array access.
	* src/mos6502/main.c,
	  src/mos6502/peeph.def,
	  src/mos6502/peep.c,
	  src/mos6502/peep.h:
	  notUsed/notUsedFrom for mos6502 flags.

2023-12-20 Philipp Klaus Krause <philipp@colecovision.eu>

	* doc/sdccman.lyx:
	  Remove comment on non-compliance with C2X draft N3047 wrt. tag compatibility: current C23 draft N3149 matches SDCC behaviour.

2023-12-20 Benedikt Freisen <b.freisen AT gmx.net>

	* doc/sdccman.lyx:
	  Various updates to the manual.

2023-12-20 Philipp Klaus Krause <philipp@colecovision.eu>

	* .version,
	  doc/INSTALL.txt,
	  sdcc.spec:
	  Set version to 4.4.0 to prepare for release.
	* sdcc/support/scripts/sdcc.nsi
	  Enable mos65c02 port.

2023-12-19 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdcc/configure,
	  sdcc/configure.ac:
	  Enable mos65c02 port.

2023-12-18 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Fix bug #3681.
	* src/z80/peeph.def:
	  Whitespace fix.
	* src/stm8/gen.c:
	  Fix bug #3683.

2023-12-17 Gabriele Gorla <gorlik@yahoo.com>

  	* src/mos6502/main.c
  	  fix bra in the opcode table. Use strncmp in the opcode search to support 65C02 bit manipulation instructions.
	* src/mos6502/gen.c
	  fix wrong offset for struct return in mos6502-stack-auto port
	  indentation changes

2023-12-14 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-3685.c:
	  Provide extern declartion to make test compile on hosts that choose not to inline.

2023-12-13 Gabriele Gorla <gorlik@yahoo.com>

	* support/regression/tests/stack-restore.c.in
	  partially disable test for mos6502-stack-auto due to stack size limitations

2023-12-13 Philipp Klaus Krause <philipp@colecovision.eu>

	* configure.ac,
	  configure:
	  Fix bug #3508, patch by Steve Schnepp.

2023-12-12 Gabriele Gorla <gorlik@yahoo.com>

  	* src/mos6502/gen.c
  	  fix bug3223041 regression failure for mos6502-stack-auto port
  	  fix bug3531687 regression failure for mos6502-stack-auto port
  	* device/lib/mos65c02/Makefile.in,
  	  device/lib/mos65c02/__memcpy.s,
  	  device/lib/mos65c02/_memcmp.s,
  	  device/lib/mos65c02/_memset.s,
  	  device/lib/mos65c02/_mullong.s,
  	  device/lib/mos65c02/_mulschar.s,
  	  device/lib/mos65c02/_muluchar.s,
  	  device/lib/mos65c02/_setjmp.s,
  	  device/lib/mos65c02/_strcmp.s,
  	  device/lib/mos65c02/_strcpy.s,
  	  device/lib/mos65c02/_strlen.s,
  	  device/lib/mos65c02/abs.s,
  	  device/lib/mos65c02/crt0.s,
  	  device/lib/mos65c02/memcpy.s
	  add mos6502 improvements to mos65c02 port

2023-12-12 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCopt.c:
	  Enable elimination of dead RECEIVE iCodes. Fixs the rest of bug #3482.

2023-12-12 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  tests/bug-3482.c:
	  Fix the worst part of bug #3482.

2023-12-12 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  support/regression/tests/bug-3685.c:
	  Fix bug #3685.

2023-12-11 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/pic16/libc/Makefile.am,
	  device/lib/pic16/libc/Makefile.in,
	  device/include/pic16/setjmp.h,
	  device/lib/pic16/libc/stdlib/setjmp.c:
	  setjmp for pic16, patch by Jonathon Hall.

2023-12-10 Philipp Klaus Krause <philipp@colecovision.eu>

	* sim/ucsim/pdk.src/inst.cc:
	  Fix simulation of z flag for not and neg.
	* src/pdk/gen.c:
	  pdk code generation improvements.
	* src/z80/gen.c:
	  Fix a Rabbit multiplication code generation bug.

2023-12-09 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/pdk/gen.c:
	  Fix a popP bug.

2023-12-07 Gabriele Gorla <gorlik@yahoo.com>

  	* device/lib/mos6502/memcpy.s,
  	  device/lib/mos6502/_memcmp.s,
  	  device/lib/mos6502/_setjmp.s,
  	  device/lib/mos6502/Makefile.in
  	  optimize memcpy, memcmp amd setjump implemetations

2023-12-06 Gabriele Gorla <gorlik@yahoo.com>

  	* device/lib/mos6502/_muluchar.s,
  	  device/lib/mos6502/_mulschar.s
  	  use ZP instead of absolute address
   	* device/lib/mos6502/_strcpy.s,
  	  device/lib/mos6502/_strcmp.s
  	  use DPTR instead of temp
   	* device/lib/mos6502/_strlen.s
	  implement strlen in asm
   	* device/lib/mos6502/_memset.s,
   	  device/lib/mos6502/crt0.s
   	  implement memset in asm
   	* device/lib/mos6502/abs.s,
   	  device/lib/mos6502/abs.c
   	  rename abs.c to abs.s
   	* doc/sdccman.lyx
   	  add mos6502 port documentation to SDCC manual

2023-12-05 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/include/pic16/pic16devices.txt,
	  device/lib/pic16/startup/crt0iz.c,
	  src/pic16/glue.c,
	  support/regression/ports/pic16/spec.mk:
	  pic16 memory zeroing fixes, patch by Jonathon Hall.

2023-12-04 Gabriele Gorla <gorlik@yahoo.com>

  	* device/lib/mos6502/_setjump.c,
  	  device/lib/mos65c02/_setjump.c,
  	  device/lib/mos6502-stack-auto/_setjump.c
  	  Reduce ZP usage in setjump.
  	* device/lib/mos6502/_ret01.s,
  	  device/lib/mos6502/_ret23.s,
	  device/lib/mos6502/_ret4567.s,
	  device/lib/mos65c02/_ret01.s,
  	  device/lib/mos65c02/_ret23.s,
	  device/lib/mos65c02/_ret4567.s,
	  device/lib/mos6502-stack-auto/_ret01.s,
  	  device/lib/mos6502-stack-auto/_ret23.s,
	  device/lib/mos6502-stack-auto/_ret4567.s
	  Remove unnecessary .optsdcc directive.
	* src/SDCCmem.c,
	  src/SDCCglobl.h,
	  src/mos6502/ralloc.c,
	  src/mos6502/main.c
	  Add --no-zp-spill option to avoid register spills in ZP.

2023-12-03 Gabriele Gorla <gorlik@yahoo.com>

  	* src/mos6502/gen.c
	  Fix bug #3511
	* src/mos6502/gen.c,
	  src/SDCCsymt.c
  	  Add limited support to return aggregates to mos6502 port.
  	* device/lib/div.c,
  	  device/lib/ldiv.c,
  	  device/include/stdlib.h
  	  Add div and ldiv to the mos6502 standard library.
  	* device/lib/_divulonglong.c
  	  Trivial spelling fix.
  	* sdas/as6500/r6500.h,
  	  sdas/as6500/r65adr.c,
  	  sdas/as6500/r65mch.c,
  	  sdas/as6500/pst.c
  	  Merge several minor changes from upstream asxxxx 5.50
  	* support/regression/MakeList,
  	  support/regression/tests/bigstack.c.in,
  	  support/regression/tests/div.c,
  	  support/regression/tests/gcc-roture-execute-20131127-1.c
  	  Enable additional tests for mos6502.

2023-12-02 Gabriele Gorla <gorlik@yahoo.com>

  	* src/mos6502/gen.c,
  	  support/regression/tests/structreturn.c.in,
	  support/regression/tests/gcc-torture-execute-va-arg-4.c,
  	  support/regression/tests/gcc-torture-execute-va-arg-23.c,
	  support/regression/tests/gcc-torture-execute-struct-ret-1.c,
  	  support/regression/tests/gcc-torture-execute-strct-varg-1.c,
	  support/regression/tests/gcc-torture-execute-pr60017.c,
  	  support/regression/tests/gcc-torture-execute-920625-1.c,
	  support/regression/tests/funptrsstructreturn.c,
  	  support/regression/tests/div.c,
	  support/regression/tests/bug-3385.c,
	  support/regression/tests/bug-3368.c,
	  support/regression/tests/bug-2776.c,
	  support/regression/tests/bigreturn-remat.c.in,
	  support/regression/MakeList,
  	  Implement IPUSH_VALUE_AT_ADDRESS iCode and enable corresponding regression tests.
  	  Disable failing tests for mos65c02.
	* src/mos6502/gen.c
	  Make sure result is a register before dereferencing the pointer (fix bug #3631)

2023-12-02 Gabriele Gorla <gorlik@yahoo.com>

  	* src/mos6502/main.c
	  Correct opcode ordering.
	  Fix get_model() reporting.
   	* src/mos6502/gen.c
	  Make mos65c02 register transfer code use phx/phy/plx/ply.
   	* src/mos6502/gen.c,
   	  src/hc08/gen.c
	  Reformat comments to match other ports.

2023-12-02 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/ports/pic16/spec.mk:
	  pic16 regression test infrastructure fix, patch by Jonathon Hall.
	* support/regression/tests/sdcccall.c.in:
	  Disable a long long test for pic16, which does not support long long yet, patch by Jonathon Hall.

2023-12-02 Gabriele Gorla <gorlik@yahoo.com>

	* sdas/asz80/z80pst.c,
	  sdas/asz80/z80.h,
	  sdas/asxxsrc/asxxxx.h,
	  sdas/as6808/m6808.h,
	  sdas/as6808/m08pst.c:
	  Change several constants to match upstream asxxxx.
	* sdas/as6500/r6500.h,
	  sdas/as6500/r65mch.c,
	  sdas/as6500/r65pst.c:
	  Enable cpu type selection for as6500.
	* device/lib/mos65c02/Makefile.in,
	  device/lib/mos65c02/crt0.s,
	  device/lib/mos65c02/abs.c,
	  device/lib/mos65c02/_srulonglong.c,
	  device/lib/mos65c02/_srslonglong.c,
	  device/lib/mos65c02/_setjmp.c,
	  device/lib/mos65c02/_ret4567.s,
	  device/lib/mos65c02/_ret23.s,
	  device/lib/mos65c02/_ret01.s,
	  device/lib/mos65c02/_muluchar.s,
	  device/lib/mos65c02/_mulschar.s,
	  device/lib/mos65c02/_mulint.s,
	  device/lib/mos65c02/__memcpy.s
	  Make the mos65c02 library compile.
	* support/regression/ports/uc65c02/uCsim.cmd,
	  support/regression/ports/uc65c02/support.c,
	  support/regression/ports/uc65c02/spec.mk
	  Add regression for mos65c02 using uCsim.
  	* src/mos6502/main.c
	  Add crt to mos65c02 link step by default.
	* src/mos6502/gen.c
	  Implement GenAnd and GenOr for mos65c02.

2023-12-02 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-2776.c,
	  support/regression/tests/bug-3368.c,
	  support/regression/tests/gcc-torture-execute-920625-1.c,
	  support/regression/tests/gcc-torture-execute-va-arg-23.c,
	  support/regression/tests/gcc-torture-execute-va-arg-4.c:
	  Enable struct parameter tests for all ports except mos6502 (which doesn't support them yet).

2023-12-01 Gabriele Gorla <gorlik@yahoo.com>

	* sdas/asxxsrc/asmain.c:
	  simplify parsing of number radix (similar to upstream asxxxx).
	* src/mos6502/main.c:
	  add ".r56c02" to the assembler output for mos65c02 port.
	* src/device/lib/mos65c02/Makefile.in,
	  src/device/lib/mos65c02/__sdcc_indirect_jsr.s,
	  src/device/lib/mos65c02/_dptr.s,
	  src/device/lib/mos65c02/_temp.s
	  add missing files to the mos65c02 std lib.

2023-12-01 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/stm8/gen.c:
	  Port a simplification from f8 to stm8.
	* src/mcs51/main.c:
	  Fix an mcs51 peephole optimizer issue noticed by Oleg Endo.

2023-12-01 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Fixes and improvements for (partial) stack-to-stack copies. Improve struct argument passing codegen.

2023-11-30 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/f8/Makefile.in,
	  src/f8/ralloc2.cc:
	  Update f8 port for changes in trunk.

2023-11-29 Gabriele Gorla <gorlik@yahoo.com>

	* sdas/as6500/r65mch.c:
	  enable 24bit address in sdas for mos6502 (patch #436).

2023-11-29 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mcs51/main.c:
	  Fix handling of jz, jnz in asmLineNodeFromLineNode.

2023-11-28 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Fix bug #3682.

2023-11-28 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/stm8/gen.c:
	  Fix an stm8 codegen bug resulting an omitted carry for some wide subtractions where the least-significant byte of the subtrahend is in a.
	* src/mcs51/peep.c:
	  Fix checking of return values for mcs51 notUsed.

2023-11-28 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mcs51/peep.c,
	  src/mcs51/peeph.def:
	  Replace deadMove by notUsed in non-push/pop roles.
	* src/stm8/gen.c:
	  Fix an stm8 rotation codegen issue resulting in invalid asm for --opt-code-speed.

2023-11-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Fix a codegen crash affecting sm83 function calls via pointers to functions returning struct.

2023-11-26 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  src/z80/ralloc2.cc:
	  Fully enable code speed optimization for z80 (and related).

2023-11-25 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Improve cost function accuracy.

2023-11-25 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/stm8/gen.c,
	  src/z80/gen.c:
	  Shift optimization using information from generalized constant propagation.

2023-11-24 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Fix bug #3680.

2023-11-24 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Fix bug #3679.

2023-11-23 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Speed optimization in register allocation for z80 and related.

2023-11-22 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Preparations for improved speed optimization for z80.
	* src/*/ralloc2.cc:
	  Do another execution frequency estimate just before register allocation to improve the accuracy of speed optimizations.
	* src/mcs51/main.c,
	  src/mcs51/peep.c,
	  src/mcs51/peep.h:
	  Implement notUsed peephole condition for mcs51, patch by Oleg Endo.

2023-11-21 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  src/pdk/gen.c,
	  support/regression/tests/bug-3678.c:
	  Preparations for improved speed optimization for z80. Fix bug #3678.
	* src/z80/peeph.def:
	  Fix a peephole rule bug.
	* src/SDCCmain.c:
	  Use -std=c23 when calling preprocessor.

2023-11-20 Felix Salfelder <felix AT salfelder.org>

	* support/cpp/gcc/c-family/c-common.{cc,h},
	  support/cpp/gcc/c-family/c-{lex,opts}.cc,
	  support/cpp/gcc/c-family/c.opt,
	  support/cpp/gcc/c/c-errors.cc:
	  Fix #3677.

2023-11-20 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  src/z80/ralloc2.cc:
	  Optimize towards djnz use.
	* sdccman.lyx:
	  Fix dead link.
	* src/mcs51/gen.c,
	  support/regression/tests/gcc-torture-execute-20050713-1.c:
	  Fix an mcs51 codegen bug affecting calls to reentrant functions where the last parameter is a struct, and some registers are live across the call.

2023-11-19 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCicode.c,
	  support/regression/tests/bug-3675.c,
	  support/regression/tests/gcc-torture-execute-20180131-1.c,
	  support/regression/tests/gcc-torture-execute-pr67226.c,
	  support/regression/tests/gcc-torture-execute-20040707-1.c:
	  Fix bug #3675.

2023-11-18 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCicode.c,
	  src/SDCCicode.h:
	  Directly create iCode chain instead of via intermediate set-style linked list.

2023-11-18 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-3675.c:
	  Regression test for bug #3675.
	* src/SDCCicode.c,
	  src/SDCCopt.c,
	  src/SDCCgenconstprop.cc,
	  src/SDCClrange.c:
	  Code refactoring for iCode operand replacement.
	* src/mcs51/gen.c:
	  Fix a typo.

2023-11-16 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mcs51/gen.c,
	  src/mcs51/gen.h:
	  Provide mcs51IsParmInCall.

2023-11-16 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mcs51/gen.c:
	  Replace further uses of fReturn by aopArg and aopRet.

2023-11-16 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mcs51/ralloc.c,
	  src/mcs51/ralloc.h:
	  Fix mcs51_regname_to_idx, patch by Oleg Endo.
	* src/mcs51/peeph.def:
	  Fix peephole optimizer rule 186.e, patch by Oleg Endo.

2023-11-16 Philipp Klaus Krause <philipp@colecovision.eu>

	* doc/sdccman.lyx:
	  Improve mcs51 calling convention documentation.
	* src/mcs51/gen.c,
	  src/mcs51/gen.h,
	  src/mcs51/main.c,
	  src/mcs51/rtrack:
	  Use aopArg, provide mcs51IsReturned and mcs51IsRegArg.

2023-11-14 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mcs51/gen.c,
	  src/mcs51/gen.h:
	  Use aopRet.

2023-11-13 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mcs51/gen.c:
	  Basic aopArg for mcs51.

2023-11-13 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mcs51/gen.c,
	  src/mcs51/gen.h,
	  src/stm8/gen.c,
	  src/z80/gen.c:
	  Handle return values via aopRet.

2023-11-13 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mcs51/gen.h,
	  src/mcs51/gen.c:
	  mcs51 code generation refactoring.

2023-11-13 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.h,
	  src/z80/gen.c:
	  Burn AOP_STR.

2023-11-12 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mcs51/gen.c:
	  Make aopGet use asmop * instead of operand *.

2023-11-12 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mcs51/gen.c:
	  Fix opIsGptr, so it works even when the op has no aop yet.

2023-11-11 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mcs51/gen.c,
	  src/mcs51/gen.h,
	  src/mcs51/main.c,
	  src/mcs51/ralloc.c,
	  src/SDCCglue.c:
	  mcs51 code generation refactoring.

2023-11-11 Felix Salfelder <felix AT salfelder.org>

	* Makefile.in:
	  Fix Ticket #193

2023-11-10 Philipp Klaus Krause <philipp@colecovision.eu>

	* .version,
	  doc/sdccman.lyx,
	  src/mcs51/gen.c,
	  src/mcs51/main.c:
	  Remove --parms-in-bank1 support in mcs51 port.

2023-11-00 Felix Salfelder <felix AT salfelder.org>

	* support/cpp/gcc/cc1_dummies.cc:
	  Rectify dummy prototype. Fixes bug #3654.

2023-11-09 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCmain.c:
	  Fix --std-c2x.
	* src/SDCCralloc.hpp:
	  Fix an UB issue in register allocation affecting z80 (and related).
	* src/mcs51/ralloc.h,
	  src/mcs51/ralloc.c:
	  Destroy the xreg relics.

2023-11-08 Felix Salfelder <felix AT salfelder.org>

	* support/cpp/gcc/diagnostic-color.cc,
	  support/cpp/gcc/prefix.cc:
	  attempt to fix bug #3669, cf
	  https://gcc.gnu.org/pipermail/gcc-patches/2023-January/609526.html

2023-11-07 Philipp Klaus Krause <philipp@colecovision.eu>

	* .version,
	  device/lib/Makefile.in,
	  device/lib/ckd_add.c,
	  device/lib/ckd_mul.c,
	  device/lib/ckd_sub.c,
	  device/lib/*/Makefile.in,
	  doc/sdccman.lyx,
	  src/SDCC.lex,
	  src/SDCC.y,
	  src/SDCCglobl.h,
	  src/SDCCmain.c,
	  src/SDCCval.c,
	  support/regression/tests/assert.c,
	  support/regression/tests/auto.c,
	  support/regression/tests/bitcount.c.in,
	  support/regression/tests/bitcountleading.c.in,
	  support/regression/tests/bitcounttrailing.c.in,
	  support/regression/tests/bitfirst.c.in,
	  support/regression/tests/bitfirstleading.c.in,
	  support/regression/tests/bitwidth.c.in,
	  support/regression/tests/c2xkeywords.c,
	  support/regression/tests/checkedint.c.in,
	  support/regression/tests/digit_separators.c,
	  support/regression/tests/memalignment.c.in,
	  support/regression/tests/typeof.c,
	  support/regression/tests/unreachable.c,
	  support/valdiag/tests/enum.c,
	  support/valdiag/tests/static_assert.c,
	  support/valdiag/tests/struct.c:
	  Since the standard name is now fixed at C23, use that instead of C2X (for compatibility, keep c2x option and pragma for now).

2023-11-07 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCClrange.c,
	  support/regression/tests/bug-3642.c,
	  .version:
	  Fix bug #3642.

2023-11-06 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCpeeph.c:
	  Fix bug #3656.
	* src/SDCCgenconstprop.cc,
	  src/SDCCcse.c:
	  Fix bug #3640.

2023-11-02 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mcs51/gen.c,
	  src/mcs51/main.c,
	  support/regression/tests/bitintshift.c.in:
	  Fix bug #3634.

2023-11-02 Maarten Brock <sourceforge.brock AT dse.nl>

	* Makefile.common.in,
	* Makefile.in,
	* sdccconf_in.h: added OPT_DISABLE_R800

2023-10-28 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCpeeph.c:
	  operandsNotRelated improvements for mcs51 (and related), based on patch 1 from patch ticket #466 by Oleg Endo.
	* src/mcs51/gen.c:
	  Patch 2 from patch ticket #466 by Oleg Endo.
	* src/mcs51/peep.c,
	  src/mcs51/ralloc.c,
	  src/mcs51/ralloc.h,
	  src/mcs51/rtrack.c:
	  Patch 3 from patch ticket #466 by Oleg Endo.
	* src/mcs51/main.c:
	  Patch 6 from patch ticket #466 by Oleg Endo.
	* src/SDCCbitv.c,
	  src/SDCCbitv.h:
	  Patch 10 from patch ticket #466 by Oleg Endo.

2023-10-28 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc:
	  Fix generalized constant propagation analysis of pointers for host with 32-bit long (bug #3667).

2023-10-26 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-3579.c,
	  support/regression/tests/bug-3606.c:
	  Fix reads from unitialized memory in regression tests, should fix bug #3583.
	* support/regression/tests/bug-3642.c:
	  Regression test for bug #3642 (disabled for now, as the bug is not yet fixed).

2023-10-19 Maarten Brock <sourceforge.brock AT dse.nl>

	* support/regression/tests/push_pop_sp.c: bug fix, remove unintended code
	* src/SDCCmem.c(printAllocInfoSeg): adjust stack offsets for struct
	  returning functions
	* src/mcs51/gen.c(genRet): fixed stack/xstack with/without framepointer

2023-10-18 Maarten Brock <sourceforge.brock AT dse.nl>

	* sdas/linksrc/lklist.c,
	* sdas/linksrc/lkmem.c,
	* sdas/linksrc/lkrloc3.c: cosmetics
	* src/SDCCglobl.h: reduced LEVEL_UNIT to 10000 for human readability
	* src/SDCCicode.c(geniCodeCall): support xstack
	* src/SDCCmem.c(printAllocInfoSeg): also print size on stack
	* src/mcs51/gen.c(pushbigreturn): use xstack when asked for,
	  (genCall): clean up xstack when asked for,
	  (genFunction): optimize stack adjustment > 7,
	  (genRet): try to use tempregs for bigreturn,
	  use add in A instead of many inc dptr for larger offsets,
	  support xstack,
	  (genPagedPointerSet): add pdata support
	* src/mcs51/rtrack.c(_mcs51_rtrackUpdate): updated comments
	* src/mos6502/main.c(m6502_genAssemblerPreamble): attempt to keep areas in
	  correct order
	* support/regression/tests/gcc-torture-execute-20020328-1.c: renamed testit()
	  to tryit() since the test prefix has special meaning in regression testing
	* support/regression/tests/push_pop_sp.c: new, added

2023-10-13 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/r*/crt0.s:
	  Fix reti vs. ipres ret in crt0 templates for Rabbits (last part of bug #3652).

2023-10-13 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/mos6502/gen.h: moved NUM_TEMP_REGS into gen.c
	* src/mos6502/gen.c: renamed __DPTR & __TEMP to DPTR & REGTEMP to remove
	  them from the C namespace,
	  simplified INDFMT_IY macro
	* src/mos6502/main.c (m6502_genAssemblerPreamble): moved __DPTR & __TEMP
	  definition to libraries,
	  removed ZPABS so --data_loc works as expected, leaving address 0 unused
	* device/lib/mos6502/__memcpy.s: use REGTEMP instead of ___SDCC_m6502_retN,
	  use local labels
	* device/lib/mos6502-stack-auto/__sdcc_indirect_jsr.s,
	* device/lib/mos6502/__sdcc_indirect_jsr.s: use renamed REGTEMP
	* device/lib/mos6502-stack-auto/_dptr.s,
	* device/lib/mos6502/_dptr.s: new, DPTR in zero page
	* device/lib/mos6502-stack-auto/_ret.c,
	* device/lib/mos6502/_ret.c: replace by _ret01.s, _ret23.s & _ret4567.s
	* device/lib/mos6502-stack-auto/_ret01.s,
	* device/lib/mos6502-stack-auto/_ret23.s,
	* device/lib/mos6502-stack-auto/_ret4567.s,
	* device/lib/mos6502/_ret01.s,
	* device/lib/mos6502/_ret23.s,
	* device/lib/mos6502/_ret4567.s: new, ___SDCC_m6502_retN in zero page
	* device/lib/mos6502-stack-auto/_temp.s,
	* device/lib/mos6502/_temp.s: new, REGTEMP in zeropage
	* device/lib/mos6502-stack-auto/Makefile.in,
	* device/lib/mos6502/Makefile.in: added _dptr.rel, _ret01.rel, _re23,rel,
	  _ret4567.rel & _temp.rel

2023-10-13 Philipp Klaus Krause <philipp@colecovision.eu>

	* .version:
	  Bump version for now fully working generalized constant propagation.

2023-10-09 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCerr.c,
	  src/SDCCerr.h,
	  src/SDCCmain.c:
	  Fix bug #3658 by warning on non-default sdcccall with default stdlib or crt0.
	* src/z80/main.c,
	  doc/sdccman.lyx,
	  device/lib/r2k/*.s,
	  device/lib/r2ka/*.s,
	  device/lib/r3ka/*.s,
	  device/lib/tlcs90/*.s,
	  device/lib/ez80_z80/*.s,
	  device/lib/_memset:
	  Make new calling convention the default for r2k, r2ka, r3ka, tlcs90, ez80-z80.
	* support/regression/ports/uc6502/spec.mk:
	  Increase test-uc6502 timeout to work around bug #3663.

2023-10-07 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc:
	  Fix a use of an uninitialized struct member in generalized constant propagation analysis of some left shifts: bugs #3625, #3665.

2023-10-05 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCCmain.c (parseCmdLine): place -Wl-f options in linkOptionsSet2,
	  (linkEdit): pass linkOptionsSet2 for $L,
	  (assemble): pass NULL for $L
	* src/SDCCutil.h,
	* src/SDCCutil.c (buildCmdLine): added list2 for $L command line options
	* src/ds390/main.c (_tininative_do_assemble): pass NULL for $L
	* src/avr/main.c (_linkCmd),
	* src/ds390/main.c (_linkCmd),
	* src/hc08/main.c (_linkCmd),
	* src/mcs51/main.c (_linkCmd),
	* src/mos6502/main.c (_linkCmd),
	* src/pdk/main.c (_linkCmd),
	* src/stm8/main.c (_linkCmd),
	* src/z80/main.c (_z80LinkCmd): added $L for command line options
	* src/z80/main.c (_sm83_rgblink): pass NULL for $L
	* src/SDCCsymt.c (checkSClass): cosmetics

2023-10-05 Maarten Brock <sourceforge.brock AT dse.nl>

	* sdas/linksrc/lkmain.c (parse): warn about ignored nested linker script

2023-10-04 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCopt.c,
	  support/regression/tests/bug-3660.c:
	  Fix bug #3660.

2023-10-04 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Rabbit interrupt handling fixes, based on patch by D-mo.

2023-10-03 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asrab/rabmch.c:
	  Fix bug #3661, patch by D-mo.
	* support/regression/tests/bug-3661.c:
	  Regression test for bug #3661.

2023-09-30 Maarten Brock <sourceforge.brock AT dse.nl>

	* support/regression/ports/uc6502-stack-auto/support.c,
	* support/regression/ports/uc6502-stack-auto/uCsim.cmd,
	* support/regression/ports/uc6502/support.c,
	* support/regression/ports/uc6502/uCsim.cmd: moved simif to safer location

2023-09-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/r2k/crt0.s,
	  device/lib/r2ka/crt0.s,
	  device/lib/r3ka/crt0.s:
	  Place interrupt vector table at multiple of 512B, as required on Rabbit 3000 and above.

2023-09-27 Maarten Brock <sourceforge.brock AT dse.nl>

	* support/regression/tests/bug-3563.c: revert accidental enable of failing test

2023-09-25 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/mm-pnvi-ae-udi-pointer_from_int_disambiguation_1_xy.c:
	  Disable test for FreeBSD 13 / clang-14, where it fails due to known bug.

2023-09-25 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/lib/mos6502-stack-auto/crt0.s,
	* device/lib/mos6502/crt0.s: clear zero page, reorder areas
	* src/mos6502/main.c(m6502_finaliseOptions): use whole zero page,
	  improved default memory map
	  (m6502_genAssemblerPreamble): move __DPTR & __TEMP to fixed
	  address from 0 and up,
	  (m6502_genIVT): fixed, allow only 2 interrupts
	* support/regression/ports/uc6502-stack-auto/spec.mk,
	* support/regression/ports/uc6502/spec.mk: use more logical memory map
	* support/regression/gte/pr34099.c: suppress valid warning
	* support/regression/gte/pr97404.c,
	* support/regression/gte/pr97836.c,
	* support/regression/tests/bug-3563.c: fixed warnings

2023-09-21 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asstm8/stm8.h,
	  sdas/asstm8/stm8mch.c,
	  sdas/linksrc/lklist.c,
	  src/SDCCopt.c,
	  src/SDCCval.c:
	  Fix a few cases of undefined behavior.
	* device/lib/r*k*/crt0.s:
	  Fix location of secondary watchdog interrupt vector (part of bug #3652).

2023-09-18 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/charconst.c,
	  support/regression/tests/escape.c,
	  support/regression/tests/new_wide.c,
	  support/regression/tests/string.c,
	  support/regression/tests/wchar.c.in:
	  Handle hosts that are C11-compliant on the compiler side, but not the library side better.
	* support/regression/tests/wchar.c.in:
	  Disable a test for OpenBSD, where it fails due to known OpenBSD bug.

2023-09-14 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/mm-pnvi-ae-udi-pointer_from_int_disambiguation_1_xy.c,
	  support/regression/tests/mm-pnvi-ae-udi-provenance_basic_using_uintptr_t_auto_yx.c,
	  support/regression/tests/mm-pnvi-ae-udi-provenance_basic_using_uintptr_t_global_xy.c,
	  support/regression/tests/setjmp.c,
	  support/regression/tests/wchar.c.in:
	  Disable tests where they fail due to known FreeBSD 13 bugs.

2023-09-12 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Fix handling of negative offsets in pointer reads.

2023-09-11 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCcse.c,
	  src/SDCClrange.c:
	  Fix issues that resulted in isaddr flag value loss, confusing the ds390 register allocator.
	* src/SDCCgenconstprop.cc:
	  Improve optimizations based on information from generalized constant propagation.
	* support/regression/tests/bug-3641.c:
	  Disable test for target where it fails due to known bug #3643.

2023-09-10 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-3641.c:
	  Support pre-C23 hosts in test for bug #3641.

2023-09-09 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-3641.c:
	  Regression test for bug #3641.

2023-09-05 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/hc08/gen.c (genAssignLit): fix bug #3641

2023-09-01 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc,
	  src/pdk/gen.c:
	  Optimize some pointer writes using intrinsic named address space information from generalized constant propagation.

2023-09-01 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bitintshift.c.in:
	  Disable parts of test that fail due to known bug #3634.

2023-09-01 Philipp Klaus Krause <philipp@colecovision.eu>

	* sim/ucsim/f8.src/decode.h,
	  sim/ucsim/f8.src/f8cl.h,
	  sim/ucsim/f8.src/glob.cc,
	  sim/ucsim/f8.src/imove.cc:
	  Fix simulator for change in xch f, (n, sp).

2023-08-29 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asrab/rab.h,
	  sdas/asrab/rabmch.c,
	  sdas/asrab/rabpst.c:
	  Fix handling of some valid instructions in Rabbit assembler (bug #3639, patch by by D-mo).
	* support/regression/tests/bug-3639.c:
	  Regression test for bug #3639.

2023-08-28 Philipp Klaus Krause <philipp@colecovision.eu>

	* doc/README.txt,
	  doc/sdccman.lyx:
	  Basic r800 port documentation.
	* support/scripts/sdcc.nsi:
	  Include r800 library in Windows installer.
	* src/z80/gen.c:
	  Cost function fixes for z80-related backends.

2023-08-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* Merge r800 branch to trunk.
	* support/regression/Makefile.in:
	  Include r800 port in test-z80 regression test target.
	* support/regression/MakeList:
	  Disable a test for r800 that fails for all z80-related ports.

2023-08-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* sim/ucsim/z80.src/inst_ed.cc,
	  src/z80/gen.c,
	  src/z80/peep.c:
	  Fixes for R800 multiplication instructions.

2023-08-27 Felix Salfelder <felix AT salfelder.org>

	* support/regression/Makefile.in: deal with longer subresult list.
	* support/regression/tests/bitintshift.c.in: more subcases.

2023-08-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/fwk/include/testfwk.h,
	  support/regression/ports/ucr800/spec.mk:
	  r800 regression test infrstructure.
	* src/z80/gen.c:
	  r800 calling convention fix.

2023-08-27 Maarten Brock <sourceforge.brock AT dse.nl>

	* support/regression/gte/960830-1.c: deleted, is only relevant for i386
	* support/regression/ports/mcs51-common/support.c: don't include mcs51reg.h,
	  define TI & SBUF directly instead, prevents name clash with B
	* support/regression/MakeList: enabled tcc_30_hanoi
	* support/regression/cases/Makefile.in: remove disabled warnings,
	  fixed warnings
	* support/regression/collate-results.py,
	* support/regression/compact-results.py: cosmetics
	* support/regression/gte/20001124-1.c,
	* support/regression/gte/20001229-1.c,
	* support/regression/gte/20010119-1.c,
	* support/regression/gte/20030216-1.c,
	* support/regression/gte/20091229-1.c,
	* support/regression/gte/900409-1.c,
	* support/regression/gte/930930-2.c,
	* support/regression/gte/950426-2.c,
	* support/regression/gte/951204-1.c,
	* support/regression/gte/960405-1.c,
	* support/regression/gte/970214-1.c,
	* support/regression/gte/970214-2.c,
	* support/regression/gte/990324-1.c,
	* support/regression/gte/991019-1.c,
	* support/regression/gte/alias-access-path-2.c,
	* support/regression/gte/pr17252.c,
	* support/regression/gte/pr22493-1.c,
	* support/regression/gte/pr23047.c,
	* support/regression/gte/pr38048-2.c,
	* support/regression/gte/pr40493.c,
	* support/regression/gte/pr49712.c: fixed warnings
	* support/regression/gte/20010329-1.c,
	* support/regression/gte/20030404-1.c,
	* support/regression/gte/20080222-1.c,
	* support/regression/gte/980526-2.c,
	* support/regression/gte/pr17133.c,
	* support/regression/gte/pr29798.c,
	* support/regression/gte/pr34099-2.c,
	* support/regression/gte/pr43629.c,
	* support/regression/gte/pr44942.c,
	* support/regression/gte/pr53465.c: suppressed valid warnings
	* support/regression/qct/0025-string.c,
	* support/regression/qct/0027-charval.c,
	* support/regression/qct/0032-indec.c,
	* support/regression/qct/0059-multistring.c,
	* support/regression/tcc/30_hanoi.c: cosmetics

2023-08-27 Maarten Brock <sourceforge.brock AT dse.nl>

	* support/regression/tests/bug-3165.c: enabled for mcs51 & ds390,
	  fixed warnings

2023-08-26 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asrab/rab.h,
	  sdas/asrab/rabadr.c,
	  sdas/asrab/rabmch.c:
	  Fix handling of some valid instructions in Rabbit assembler (bug #3636, patch by by D-mo).
	* support/regression/tests/bug-3636.c:
	  Regression test for bug #3636.

2023-08-26 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asrab/rab.h,
	  sdas/asrab/rabadr.c,
	  sdas/asrab/rabmch.c:
	  Fix handling of some invalid instructions in Rabbit assembler (bug #3638, patch by by D-mo).

2023-08-26 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-3165.c,
	  support/regression/tests/bug-3167.c:
	  Rename regression test to match correct bug number.

2023-08-26 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/lib/pic16/libc/string/memchr.c,
	* device/lib/pic16/libc/string/memchrpgm.c,
	* device/lib/pic16/libc/string/memchrram.c: fixed buggy implementations
	* src/pic14/genarith.c(genPlus): fixed warning
	* support/regression/qct/0026-implicitret.c: disable expected warning 278
	* support/regression/tcc/97_utf8_string_literal.c: replaced abort() by
	  return, is this test even linked, let alone run?
	* support/regression/tests/gcc-torture-execute-930106-1.c: very odd test,
	  fixed warnings
	* support/regression/tests/gcc-torture-execute-cmpsf-1.c: enabled for mcs51
	  with correct_results[] const, fixed warnings
	* support/regression/tests/gcc-torture-execute-strct-varg-1.c: enabled for
	  hc08 & s08, fixed warnings
	* support/regression/tests/lonesha256.c: disabled for mcs51-stack-auto
	* support/regression/tests/mm-pnvi-ae-udi-pointer_from_int_disambiguation_2_xy.c:
	  added comment about incorrect warning 127
	* support/regression/tcc/109_float_struct_calling.c,
	* support/regression/tcc/10_pointer.c,
	* support/regression/tcc/11_precedence.c,
	* support/regression/tcc/30_hanoi.c,
	* support/regression/tcc/52_unnamed_enum.c,
	* support/regression/tcc/54_goto.c,
	* support/regression/tcc/55_lshift_type.c,
	* support/regression/tests/gcc-torture-execute-20000717-3.c,
	* support/regression/tests/gcc-torture-execute-20020201-1.c,
	* support/regression/tests/gcc-torture-execute-20020328-1.c,
	* support/regression/tests/gcc-torture-execute-20020819-1.c,
	* support/regression/tests/gcc-torture-execute-20041019-1.c,
	* support/regression/tests/gcc-torture-execute-20100430-1.c,
	* support/regression/tests/gcc-torture-execute-20120427-1.c,
	* support/regression/tests/gcc-torture-execute-20120427-2.c,
	* support/regression/tests/gcc-torture-execute-920202-1.c,
	* support/regression/tests/gcc-torture-execute-920428-1.c,
	* support/regression/tests/gcc-torture-execute-920520-1.c,
	* support/regression/tests/gcc-torture-execute-920812-1.c,
	* support/regression/tests/gcc-torture-execute-921123-1.c,
	* support/regression/tests/gcc-torture-execute-930123-1.c,
	* support/regression/tests/gcc-torture-execute-930518-1.c,
	* support/regression/tests/gcc-torture-execute-930603-2.c,
	* support/regression/tests/gcc-torture-execute-931017-1.c,
	* support/regression/tests/gcc-torture-execute-950322-1.c,
	* support/regression/tests/gcc-torture-execute-950621-1.c,
	* support/regression/tests/gcc-torture-execute-950809-1.c,
	* support/regression/tests/gcc-torture-execute-960219-1.c,
	* support/regression/tests/gcc-torture-execute-960302-1.c,
	* support/regression/tests/gcc-torture-execute-960327-1.c,
	* support/regression/tests/gcc-torture-execute-960402-1.c,
	* support/regression/tests/gcc-torture-execute-980701-1.c,
	* support/regression/tests/gcc-torture-execute-990106-1.c,
	* support/regression/tests/gcc-torture-execute-991023-1.c,
	* support/regression/tests/gcc-torture-execute-cmpsi-1.c,
	* support/regression/tests/gcc-torture-execute-divconst-1.c,
	* support/regression/tests/gcc-torture-execute-divmod-1.c,
	* support/regression/tests/gcc-torture-execute-lto-tbaa-1.c,
	* support/regression/tests/gcc-torture-execute-packed-1.c,
	* support/regression/tests/gcc-torture-execute-postmod-1.c,
	* support/regression/tests/gcc-torture-execute-strct-stdarg-1.c,
	* support/regression/tests/gcc-torture-execute-string-opt-5.c,
	* support/regression/tests/gcc-torture-execute-va-arg-1.c,
	* support/regression/tests/gcc-torture-execute-va-arg-5.c,
	* support/regression/tests/gcc-torture-execute-va-arg-6.c: fixed warnings

2023-08-25 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/mcs51/rtrack.c(_mcs51_rtrackUpdate): added dptr+=2 case,
	  added detecting modified bits in B

2023-08-21 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/lib/mcs51/Makefile.in: reverted accidental commit

2023-08-19 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/include/asm/default/features.h,
	* device/include/asm/ds390/features.h,
	* device/include/asm/mcs51/features.h,
	* device/include/asm/pic14/features.h,
	* device/include/asm/pic16/features.h,
	* device/include/asm/r2k/features.h,
	* device/include/asm/r3ka/features.h,
	* device/include/asm/sm83/features.h,
	* device/include/asm/stm8/features.h,
	* device/include/asm/tlcs90/features.h,
	* device/include/asm/z80/features.h: added __SDCC_NONBANKED
	* device/include/float.h: use __SDCC_NONBANKED for __SDCC_FLOAT_NONBANKED
	* device/include/sdcc-lib.h: cosmetics
	* device/lib/_divsint.c,
	* device/lib/_divslong.c,
	* device/lib/_divslonglong.c,
	* device/lib/_divuint.c,
	* device/lib/_divulong.c,
	* device/lib/_divulonglong.c,
	* device/lib/_modsint.c,
	* device/lib/_modslong.c,
	* device/lib/_modslonglong.c,
	* device/lib/_moduint.c,
	* device/lib/_modulong.c,
	* device/lib/_modulonglong.c,
	* device/lib/_mulint.c,
	* device/lib/_mullong.c,
	* device/lib/_mullonglong.c: moved __SDCC_NONBANKED to sdcc-lib.h
	* device/lib/_slonglong2fs.c: cosmetics
	* device/lib/Makefile.in,
	* device/lib/hc08/Makefile.in,
	* device/lib/mos6502/Makefile.in,
	* device/lib/mos6502-stack-auto/Makefile.in,
	* device/lib/mos65c02/Makefile.in,
	* device/lib/pdk13/Makefile.in,
	* device/lib/pdk14/Makefile.in,
	* device/lib/pdk15/Makefile.in,
	* device/lib/pdk15-stack-auto/Makefile.in,
	* device/lib/s08/Makefile.in,
	* device/lib/s08-stack-auto/Makefile.in,
	* device/lib/stm8/Makefile.in,
	* device/lib/stm8-large/Makefile.in,
	* src/SDCCsymt.c (initCSupport): renamed _r[lr][su]longlong.c to
	  _s[lr][su]longlong.c because they are shifts not rotates
	* device/lib/_slslonglong.c: renamed from _rlslonglong.c,
	  moved __SDCC_NONBANKED to sdcc-lib.h
	* device/lib/_slulonglong.c: renamed from _rlulonglong.c,
	  moved __SDCC_NONBANKED to sdcc-lib.h,
	  use _AUTOMEM for better code generation
	* device/lib/_srslonglong.c: renamed from _rrslonglong.c,
	  bugfix little endian variant,
	  moved __SDCC_NONBANKED to sdcc-lib.h,
	  use _AUTOMEM for better code generation,
	  removed comment about non-existing rrulonglong_rrx_s.c
	* device/lib/_srulonglong.c: renamed from _rrulonglong.c,
	  moved __SDCC_NONBANKED to sdcc-lib.h,
	  use _AUTOMEM for better code generation,
	  removed comment about non-existing rrulonglong_rrx_s.c
	* device/lib/mos6502/_srslonglong.c: renamed from _rrslonglong.c
	* device/lib/mos6502/_srulonglong.c: renamed from _rrulonglong.c
	* device/lib/mos6502-stack-auto/_srslonglong.c: renamed from _rrslonglong.c
	* device/lib/mos6502-stack-auto/_srulonglong.c: renamed from _rrulonglong.c

	* device/lib/atomic_flag_clear.c: generate external definition for
	  inline definition with external linkage
	* device/include/stdatomic.h: inline atomic_flag_clear(),
	  use 0xfe for z80-like,
	  use __SDCC_NONBANKED
	* device/lib/ez80_z80/atomic_flag_test_and_set.s,
	* device/lib/r2k/atomic_flag_test_and_set.s,
	* device/lib/r2ka/atomic_flag_test_and_set.s,
	* device/lib/r3ka/atomic_flag_test_and_set.s,
	* device/lib/sm83/atomic_flag_test_and_set.s,
	* device/lib/z180/atomic_flag_test_and_set.s,
	* device/lib/z80/atomic_flag_test_and_set.s,
	* device/lib/z80n/atomic_flag_test_and_set.s: use sra on 0xfe and drop ccf

	* device/lib/strtoull.c: drop oldret
	* device/lib/wcstoull.c: drop oldret,
	  (_isdigit): fix L'a',
	  (strtoull): bugfix, renamed to wcstoull() & use iswblank()

	* debugger/mcs51/sdcdb.c (readCdb): fixed warning/bug
	* src/SDCC.y: fixed warnings
	* src/SDCCval.h,
	* src/SDCCval.c (ullFromVal): make val const to fix warnings
	* src/mcs51/ralloc.c (regsUsedIniCode): removed label to fix warning
	* src/mos6502/gen.c (opInfo): fix warning,
	  (genRightShift): fixed warning
	* src/z80/ralloc.c (regsUsedIniCode): removed label to fix warning
	* support/cpp/gcc/diagnostic.cc (fancy_abort): fixed warning,
	  removed formfeeds
	* support/cpp/gcc/gcc.cc (insert_comments,get_random_number): fixed warnings
	  removed formfeeds
	* support/cpp/libcpp/expr.cc (cpp_classify_number): fixed warnings,
	  removed formfeeds
	* support/cpp/libcpp/macro.cc (update,create_iso_definition): fixed warnings
	* support/makebin/makebin.c: fixed warning

2023-08-17 Benedikt Freisen <b.freisen AT gmx.net>

	* device/include/inttypes.h,
	  device/include/stdlib.h,
	  device/include/wchar.h,
	  device/lib/Makefile.in,
	  device/lib/imaxabs.c,
	  device/lib/imaxdiv.c,
	  device/lib/incl.mk,
	  device/lib/llabs.c,
	  device/lib/strtoimax.c,
	  device/lib/strtoll.c,
	  device/lib/strtoul.c,
	  device/lib/strtoull.c,
	  device/lib/strtoumax.c,
	  device/lib/wcsncmp.c,
	  device/lib/wcstoimax.c,
	  device/lib/wcstol.c,
	  device/lib/wcstoll.c,
	  device/lib/wcstoul.c,
	  device/lib/wcstoull.c,
	  device/lib/wcstoumax.c,
	  support/regression/tests/wcsto.c:
	  Add inttypes.h and missing dependencies.

2023-08-17 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/pdk/gen.c:
	  Fix a bug in pdk code generation for shifts.
	* support/regression/tests/shifts2.c.in:
	  Disable a part of a test for configurations where it fails due to lack of memory.

2023-08-17 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/pic14/glue.c,
	* src/pic16/glue.c: moved no_assemble into options

2023-08-17 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/shifts2.c.in,
	  support/regression/tests/bitintshift.c.in:
	  Improve test coverage for shifts of wide variables.
	* device/lib/_rlulonglong.c,
	  device/lib/_rrslonglong.c,
	  device/lib/_rrulonglong.c:
	  Fix choice of endiannness for support functions for shifts of wide variables.

2023-08-16 Maarten Brock <sourceforge.brock AT dse.nl>

	* debugger/mcs51/cmd.c: fixed compiler warning
	* src/SDCCglobl.h,
	* src/SDCCglue.c,
	* src/SDCCmain.c: moved syntax_only & no_assemble into options
	* src/SDCCopt.c(eBBlockFromiCode): do not call assignRegisters() for
	    --syntax-only

2023-08-15 Maarten Brock <sourceforge.brock AT dse.nl>

	* sim/ucsim/test-target.mk: do not remove ihx files that are in svn

2023-08-14 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCCmain.c: added --syntax-only option, implements RFE #886
	* doc/sdccman.lyx: documented --syntax-only

2023-08-13 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8mch.c:
	  Fix f8 instruction xch xl, (y).

2023-08-11 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* support/regression/tests/charconst.c,
	  support/regression/tests/wchar.c.in: disable for MacOS host test

2023-08-10 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8adr.c,
	  sdas/asf8/f8mch.c,
	  sim/ucsim/f8.src/decode.h,
	  sim/ucsim/f8.src/disass.cc,
	  sim/ucsim/f8.src/f8.cc,
	  sim/ucsim/f8.src/f8cl.h,
	  sim/ucsim/f8.src/glob.cc,
	  src/f8/gen.c:
	  Switch to new f8 altacc prefixes.

2023-08-10 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8pst.c:
	  Fix assembly of f8 instruction xch xl, (n, sp).

2023-08-09 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8.h,
	  sdas/asf8/f8mch.c,
	  sdas/asf8/f8pst.c:
	  Support msk, cax, caxw f8 instructions in assembler.

2023-08-09 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* support/regression/tests/bug-2855.c: disable for MacOS host test
	* support/regression/tests/charconst.c,
	  support/regression/tests/string.c,
	  support/regression/tests/wchar.c.in: work around missing uchar.h
	  on MacOS host test

2023-08-08 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* support/scripts/sdcc.nsi: Remove unused/unbuilt simulators

2023-08-08 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8pst.c:
	  Fix assembly of f8 instruction cltz.

2023-08-07 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8.h,
	  sdas/asf8/f8mch.c,
	  sdas/asf8/f8pst.c:
	  Fix assembly of f8 instructions xch f, (n, sp) and mad.

2023-08-03 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8mch.c,
	  sim/ucsim/f8.src/ibranch.cc:
	  Fix offsets in relative jumps.

2023-08-03 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/ds390/gen.c,
	  src/ds390/ralloc.c,
	  src/hc08/gen.c,
	  src/mcs51/gen.c,
	  src/mcs51/ralloc.c,
	  src/pdk/gen.c,
	  src/z80/gen.c:
	  Fix various bugs found by sanitizers.

2023-08-02 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c,
	  src/f8/gen.h,
	  src/f8/ralloc2.cc:
	  Use information from generalized constant propagation analysis in f8 code generation.

2023-08-01 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc,
	  src/SDCCpeeph.c,
	  src/pdk/gen.c,
	  src/stm8/gen.c,
	  src/z80/gen.c:
	  Fix various bugs found by sanitizers.

2023-07-31 Philipp Klaus Krause <pkk@spth.de>

	* support/regression/ports/ucr800/spec.mk:
	  Infrastructure for future r800 regression testing.

2023-07-31 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc,
	  src/pdk/ralloc.c:
	  Fix some issues, mostly in generalized constant propagation.

2023-07-29 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCcse.c,
	  src/SDCCcse.h,
	  src/SDCCopt.c,
	  support/regression/tests/bug-3636.c:
	  Fix bug #3626.
	* src/SDCCsymt.c,
	  support/regression/tests/bug-3597.c:
	  Fix bug #3597.
	* src/SDCCast.c,
	  support/valdiag/tests/bug-2240.c:
	  Fix bug #2240.

2023-07-28 Philipp Klaus Krause <pkk@spth.de>

	* sdas/asz80/z80.h,
	  sdas/asz80/z80mch.c,
	  sdas/asz80/z80pst.c:
	  Basic R800 assembler support.
	* configure,
	  configure.ac,
	  src/SDCCmain.c,
	  src/port.h,
	  src/z80/main.c,
	  src/SDCCglue.c,
	  src/z80/gen.c,
	  src/z80/z80.h,
	  src/z80/peep.c,
	  device/include/*.h,
	  device/lib/Makefile.in,
	  device/lib/_memset.c,
	  device/lib/clean.mk,
	  device/lib/r800:
	  Infrastructure for r800 port, use multu for 8x8->16 multiplication.

2023-07-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/mbrtowc.c,
	  support/regression/tests/wchar.c.in:
	  Fix an issue in the return value of mbrtowc for 0 character (it indirectly also affected mbrtoc16 and mbrtoc32).

2023-07-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Fix bug #3619.

2023-07-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib:
	  Spelling fixes, patch #465 by Konstantin Kim.

2023-07-26 Maarten Brock <sourceforge.brock AT dse.nl>

	* _gptrget.c,
	* _gptrgetc.c,
	* _gptrput.c: applied patch #464, Thanks Konstantin Kim
	    also fixed/improved non-active SDCC_MODEL_MEDIUM variants of this lib

2023-07-21 Benedikt Freisen <b.freisen AT gmx.net>

	* doc/sdccman.lyx:
	  Update documentation of pragma sdcc_hash.

2023-07-17 Felix Salfelder <felix AT salfelder.org>

	* support/regression/cases/generate-cases.py:
	  Fix bug #3614.

2023-07-17 Felix Salfelder <felix AT salfelder.org>

	* support/regression/Makefile.in,
	  support/regression/compact-results.py:
	  Fix bug #3613.

2023-07-13 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/pdk/gen.c:
	  Fix bug #3615 for pdk15.

2023-07-13 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/_minimal.c:
	  Fix an accidentially comitted debug line.
	* src/stm8/gen.c:
	  Fix bug #3615 for stm8.

2023-07-10 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Fix a Z(1)80 bug in wide reads from pointers into registers.

2023-07-09 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCicode.c,
	  src/*/main.c:
	  Fix bug #3611 via patch by bbbbbr.
	* src/SDCCgenconstprop.cc:
	  Use (CHAR_BIT * sizeof (unsigned long long)) when C2X ULLONG_WIDTH is not available.
	* src/SDCCcse.c:
	  Fix bug #3612.

2023-07-07 Philipp Klaus Krause <philipp@colecovision.eu>

	* Merge genconstprop branch to trunk.

2023-07-07 Philipp Klaus Krause <philipp@colecovision.eu>

	* .version:
	  Bump version for generalized constant propagation.

2023-07-07 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c,
	  src/f8/main.c,
	  src/f8/ralloc.c,
	  src/f8/ralloc2.cc:
	  Update for changes from next branch.

2022-07-07 Philipp Klaus Krause <philipp@colecovision.eu>
	* Merge next branch to trunk.
	* device/lib/stm8/support:
	  Cleanup.

2023-07-03 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCopt.c:
	  Fix a compiler crash due to operation narrowing invalidating iCode sequence numbers.

2023-07-03 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/ds390/gen.c:
	  Fix an issue in ds390 casts to _BitInt.

2023-07-03 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc,
	  src/pdk/main.c:
	  Generalized constant propagation optimization for pdk and mcs51 pointers.

2023-07-02 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc:
	  Basic generalized constant propagation analysis for pdk and mcs51 pointers.

2023-07-02 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc:
	  Fix dumping of generalized constant propagation analysis graph debug info for initialization of global objects.

2023-07-01 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mcs51/gen.c,
	  support/regression/tests/bug-3607.c:
	  Fix bug #3607, using a variant of the patch by Oleg Endo.

2023-06-30 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/stm8/gen.c:
	  Fix bug #3609.
	* src/z80/gen.c,
	  support/regression/tests/bug-3606.c:
	  Fix bug #3606.
	* src/hc08/gen.c:
	  Fix bug #3604.
	* doc/README.txt:
	  Fix bug #3605.

2023-06-30 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/stm8/gen.c:
	  Improve 16-bit comparisons.

2023-06-29 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc:
	  Improve generalized constant propagation analysis for /, %.

2023-06-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc:
	  Improve interval / bit synchronization in generalized constant propagation analysis.

2023-06-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCast.c,
	  support/valdiag/tests/bug-3603.c:
	  Fix bug #3603.
	* src/SDCCmain.c,
	  src/pdk/main.c,
	  src/z80/main.c:
	  Improve error message on invalid -mmarch option, part of RFE #881.

2023-06-22 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/scripts/sdcc.nsi:
	  Change references to bin\cc1.exe to libexec\sdcc\cc1 (picked from nativecrosstools branch).

2023-06-21 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc,
	  src/SDCCopt.c,
	  src/hc08/main.c,
	  src/*/ralloc2.cc:
	  Fixes for generalized constant propagation and support functions for _BitInt.

2023-06-20 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc:
	  Improve generalized constant propagation analysis and optimization.

2023-06-20 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCBBlock.c,
	  src/SDCCgenconstprop.cc,
	  src/SDCCopt.c,
	  src/SDCCopt.h:
	  Replace a multiplication narrowing optimization by a more generic one based on generalized constant propagation.

2023-06-20 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc:
	  Improve generalized constant propgation analysis and optimization.
	* src/hc08/gen.c,
	  src/pdk/gen.c,
	  src/stm8/gen.c,
	  src/z80/gen.c,
	  src/mos6502/ralloc2.cc:
	  Further use of information from generalized constant propagation analysis in code generation.

2023-06-19 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/hc08/gen.c,
	  src/hc08/gen.h,
	  src/hc08/main.c,
	  src/hc08/ralloc.c,
	  src/hc08/ralloc2.cc:
	  Use information from generalized constant propagation analysis in hc08 code generation, remove support for old register allocator.

2023-06-18 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc,
	  src/pdk/gen.c:
	  Improve generalized constant propagation analysis and optimization.

2023-06-18 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc,
	  src/z80/gen.c,
	  src/pdk/gen.c,
	  src/stm8/gen.c:
	  Use information from generalized constant propagation analysis in code generation.

2023-06-15 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCBBlock.c,
	  src/SDCCcse.c,
	  src/SDCCdflow.c,
	  src/SDCClrange.c,
	  src/SDCCopt.c,
	  src/SDCCralloc.hpp,
	  src/*/ralloc.c,
	  src/*/ralloc2.cc:
	  Simplify based on IC_(JT)COND now being an alias for IC_LEFT.

2023-06-15 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCdflow.h,
	  src/SDCCgenconstprop.cc,
	  src/SDCCopt.c,
	  src/z80/gen.c,
	  src/z80/gen.h,
	  src/z80/ralloc2.cc,
	  src/stm8/gen.c,
	  src/stm8/gen.h,
	  src/stm8/ralloc2.cc:
	  Basic generalized constant propgation analysis and optimization for individual operand bits.

2023-06-13 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc:
	  Fixes and improvements for generalized constant propagation optimization and analysis.

2023-06-13 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mos6502/gen.c
	  Fix negation of literals for mos6502.
	* src/SDCCgenconstprop.cc:
	  Fix handling of __bit in generalized constant propagation analysis.

2023-06-12 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCopt.c:
	  Fix an issue in handling parameters during conversion of builtin functions at the beginning of a basic block.

2023-06-12 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCBBlock.c,
	  src/SDCCglobl.h,
	  src/SDCCopt.c:
	  Dump iCode after generalized constant propagation.

2023-06-12 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCClrange.c:
	  Fix a corner case in live-range separation that would hang SDCC on compiling the pic14 library (and result in some missed optimizations for other ports).
	* src/pdk/gen.c:
	  Fix a pdk codegen issue that could result in invalid asm for pdk13 on bitwise and in if condition.
	* src/SDCCopt.c:
	  Fix an issue in support function call handling that gets exposed in the genconstprop branch via incorrect elimination of an iCode in live range separation.

2023-06-11 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCdflow.h,
	  src/SDCCgenconstprop.cc,
	  src/SDCCsymt.c,
	  src/SDCCsymt.h:
	  Basic generalized constant propagation operation narrowing optimization.

2023-06-11 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc:
	  Improve generalized constant propagation analysis.

2023-06-11 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/include/stdckdint.h:
	  Work around an issue in inlining _Generic results to mitigate strtotul code size regression.

2023-06-10 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc:
	  A few more bits of generalized constant propagation analysis and optimization.

2023-06-10 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc:
	  Improve proof-of-concept for generalized constant propagation analysis and optimization to the point where it almost passes regression tests.
	* src/SDCCglobl.h,
	  src/SDCCmain.c,
	  src/SDCCopt.c:
	  Introduce --nogenconstprop option.

2023-06-10 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCgenconstprop.cc:
	  Refactor proof-of-concept for generalized constant propagation analysis using new iCode operand handling.

2023-06-10 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCicode.h:
	  Store operands of IFX and JUMPTAB the same way as operands of other iCodes.

2023-06-10 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCdflow.h,
	  src/SDCCicode.c,
	  src/SDCCicode.h,
	  src/SDCClrange.c,
	  src/SDCCopt.c,
	  src/SDCCgenconstprop.cc:
	  A first proof-of-concept for generalized constant propagation analysis.

2023-06-08 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/MakeList:
	  Disable tests that fail due to known -ms08 --stack-auto bugs.
	* doc/sdccman.lyx:
	  Document hc08/s08 struct/union parameter support.

2023-06-08 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/hc08/gen.c,
	  src/mos6502/gen.c,
	  src/z80/gen.c:
	  support/regression/MakeList:
	  Fix a right-shift codegen sign issue triggered by register packing.

2023-06-08 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/hc08/gen.c,
	  support/regression/MakeList:
	  Catch bug #3598 early.

2023-06-08 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/hc08/gen.c:
	  Fix stacked hx result in shifts.
	* support/regression/MakeList:
	  Exclude some tests that need features not yet supported by s08 from s08-stack-auto testing.

2023-06-07 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/hc08/gen.c:
	  hc08/s08 --stack-auto struct/union parameters.

2023-06-07 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCsymt.c,
	  src/hc08/gen.c:
	  Caller-side support for hc08/s08 struct/union return.

2023-06-07 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c:
	  Improve z80 rotation.
	* src/mcs51/ralloc.c:
	  Work around a mcs51 register saving issue (codegen cannot handle a return value in a bit if other bits are live at the call).
	* src/SDCCicode.c,
	  src/SDCCopt.c:
	  Fix bug #3595.

2023-06-03 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/MakeList:
	  Disable trigraph test for host, since many host compilers no longer support trigraphs.

2023-06-02 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/ports/host/spec.mk.in:
	  Fix C99 flag handling.
	* support/regression/tests/align.c.in:
	  Fix test for current state of SDCC and host compilers wrt. C11 alignment support.

2023-06-02 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCast.c:
	  Fix type of result in optimization of shifts wider than operand.
	* src/z80/gen.c:
	  Fix left-shift for wide _BitInt.
	* src/hc08/gen.c:
	  Fix shift issues.
	* src/pdk/gen.c:
	  Fix 16-bit bitwise or for register operand with global operand. Fix a in left shift by 8 code generation that overwrote a live pseudoregister p when storing the shift result onto the stack.
	* src/stm8/gen.c:
	  Fix stack balance issue in left shift code generation.
	* support/regression/tests/bitintrot.c.in:
	  _BitInt rotation test.

2023-06-02 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/main.c,
	  src/z80/gen.c:
	  Improve z80 rotations.
	* src/pdk/main.c,
	  src/pdk/gen.c,
	  src/pdk/peeph.def:
	  Improve pdk rotations.
	* src/mcs51/main.c,
	  src/mcs51/gen.c:
	  Improve mcs51 rotations.
	* src/hc08/main.c,
	  src/hc08/gen.c:
	  Improve hc08 rotations.

2023-06-01 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCast.c,
	  src/SDCCsymt.c:
	  Simplify ROT optimization.
	* src/stm8/gen.c,
	  src/stm8/main.c:
	  Improve stm8 rotations.

2023-05-31 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/pdk/main.c,
	  src/pdk/gen.c:
	  Support arbitrary rotations of 8-bit values in pdk code generation.
	* src/stm8/main.c,
	  src/stm8/gen.c:
	  Support arbitrary rotations of 8-bit values in stm8 code generation.
	* src/hc08/gen.c,
	  src/hc08/ralloc2.cc:
	  Improve code generation for hc08/s08 rotations.

2023-05-31 Philipp Klaus Krause <philipp@colecovision.eu>

	* .version,
	  doc/sdccman.lyx,
	  src/SDCC.lex,
	  src/SDCC.y,
	  src/SDCCast.c,
	  src/SDCCcse.c,
	  src/SDCCicode.c,
	  src/SDCClospre.cc,
	  src/SDCCopt.c,
	  src/*/gen.c,
	  src/*/main.c,
	  src/*/ralloc2.cc:
	  Replace RLC, RRC, SWAP by ROT, RFE #877.

2023-05-31 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/port.h,
	  src/SDCCast.c,
	  src/*/main.c:
	  Prepare for generalized swap / rotation support.

2023-05-31 Philipp Klaus Krause <philipp@colecovision.eu>

	* configure,
	  configure.ac,
	  device/lib/Makefile.in,
	  device/lib/clean.mk,
	  device/lib/s08-stack-auto,
	  support/regression/ports/s08-stack-auto:
	  Infrastructure for testing s08 port with --stack-auto.

2023-05-30 Philipp Klaus Krause <philipp@colecovision.eu>

	* aclocal.m4,
	  configure,
	  configure.ac,
	  sdccconf_in.h:
	  Update configure-time host C compiler checks for currently used standard.

2023-05-30 Philipp Klaus Krause <philipp@colecovision.eu>

	* doc/sdccman.lyx:
	  Document change in -MMD vs. -MF argument.
	* .version,
	  doc/INSTALL.txt,
	  sdcc.spec:
	  Bump version to prepare for 4.3.0 release.

2023-05-30 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mos6502/peeph.def,
	  support/regression/tests/bug-3593.c:
	  Fix bug #3593, using a variant of a patch by Christopher Williams.

2023-05-29 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/pic14/Makefile.in,
	  device/lib/pic14/aclocal.m4,
	  device/lib/pic14/configure,
	  device/lib/pic14/configure.ac,
	  device/lib/pic14/libc/Makefile.in,
	  device/lib/pic14/libm/Makefile.in,
	  device/lib/pic14/libsdcc/enhanced/Makefile.in,
	  device/lib/pic14/libsdcc/enhanced-no-xinst/Makefile.in,
	  device/lib/pic14/libsdcc/regular/Makefile.in,
	  device/lib/pic16/Makefile.in,
	  device/lib/pic16/aclocal.m4,
	  device/lib/pic16/configure,
	  device/lib/pic16/configure.ac,
	  device/lib/pic16/debug/Makefile.in,
	  device/lib/pic16/libc/Makefile.in,
	  device/lib/pic16/libio/Makefile.in,
	  device/lib/pic16/libm/Makefile.in,
	  device/lib/pic16/libsdcc/Makefile.in,
	  device/lib/pic16/startup/Makefile.in,
	  device/non-free/lib/pic14/configure,
	  device/non-free/lib/pic14/configure.ac,
	  device/non-free/lib/pic16/Makefile.in,
	  device/non-free/lib/pic16/aclocal.m4,
	  device/non-free/lib/pic16/configure,
	  device/non-free/lib/pic16/configure.ac,
	  device/non-free/lib/pic16/libdev/Makefile.in:
	  Updates to pic library build system, fix bug #3140 by implementing maintainer mode.

2023-05-25 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-2854.,
	  support/regression/tests/bug-3474.c,
	  support/regression/tests/strto.c:
	  Disable tests for mcs51 medium model that need too much memory since recent strtoul fixes (see also RFE #875).

2023-05-24 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/stm8/gen.c,
	  support/regression/tests/bigstack.c.in:
	  Improve guards against a potential issue in the interaction of function entry stack adjustment and register parameters.
	* src/mos6502/gen.c:
	  Fix missing statement after label.

2023-05-23 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCopt.c:
	  Optimize out some redundant iTemps.
	* src/SDCClrange.c:
	  Live range separation fixes.

2023-05-23 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/stm8/__mululonguchar2ulonglong.s,
	  device/lib/stm8-large/__mululonguchar2ulonglong.s,
	  device/lib/stm8/Makefile.in,
	  device/lib/stm8-large/Makefile.in,
	  src/SDCCopt.c,
	  src/SDCCsymt.c,
	  src/SDCCsymt.h,
	  src/port.h,
	  src/*/main.c:
	  Special handling of 32x8->64 unsigned multiplication for optimization.

2023-05-23 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/stm8/gen.c:
	  Fix a segfault in a corner case in stm8 codegen.
	* device/lib/strtoul.c:
	  Improve strtoul range error check.
	* support/regression/tests/mulextra.c:
	  Improve test coverage for multiplication with operands of different types.

2023-05-21 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mos6502/gen.c,
	  src/mos6502/main.c:
	  mos6502 _BitInt support.
	* device/lib/strtoul.c,
	  support/regression/tests/strto.c:
	  Fix C23 binary prefix for strtoo(u)l.
	* src/hc08/gen.c:
	  Comparison codegen improvement.
	* device/lib/strtoul.c,
	  support/regression/tests/strto.c:
	  Fix a corner case in strtoul range check.

2023-05-21 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/hc08/gen.c
	  src/hc08/main.c,
	  doc/sdccman.lyx:
	  hc08/s08 _BitInt support up to 64 bits.

2023-05-21 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/hc08/gen.c,
	  src/hc08/main.c:
	  hc08/s08 _BitInt support: codegen for addition, subtraction and 16-bit shifts. Enable _BitInt up to 16 bits.

2023-05-19 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/hc08/ralloc2.cc,
	  src/hc08/gen.c:
	  Prepare for hc08/s08 _BitInt support: codegen for casts.

2023-05-17 Philipp Klaus Krause <philipp@colecovision.eu>

	* doc/sdccman.lyx:
	  Fix whitespace in cross-build configure example.
	* support/regression/tests/gcc-torture-execute-strlen-4.c:
	  Enable some more bits of this test that now pass.

2023-05-16 Felix Salfelder <felix AT salfelder.org>

	* bin/sd{ar,cpp,nm,objcopy,ranlib}.in:
	  fix #3587 (with Philipp).

2023-05-16 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCClrange.c,
	  support/regression/tests/bug-3455.c:
	  Fix bug #3455.
	* support/regression/tests/sizeof.c.in:
	  Disable a warning where we intentionally test something that is implementation-defined in SDCC (though undefined in the standard).
	* device/lib/ds400/Makefile.in:
	  Fix invokation of sdar during ds400 library build.

2023-05-15 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/linksrc/Makefile.in,
	  sdas/linksrc/aslink.h,
	  sdas/linksrc/lkout.c,
	  sdas/linksrc/lks19.c:
	  Port Motorola SREC format support from upstream asxxxx 5.40 to fix bug #3559.

2023-05-15 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCsymt.c,
	  support/regression/tests/bug-3585.c:
	  Fix bug #3585.

2023-05-01 Felix Salfelder <felix AT salfelder.org>

	* support/sdbinutils/bfd/{asxxxx,targets}.c:
	  Fix bug #3569 and a memory leak.

2023-05-14 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/ralloc2.cc,
	  src/f8/gen.c,
	  src/f8/peeph.def:
	  Improve jump on bit-field.

2023-05-13 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c,
	  src/SDCCicode.c,
	  src/f8/peeph.def:
	  Improve bit-field access.

2023-05-11 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c,
	  src/f8/main.c:
	  Improve narrow write via pointer. Jumptable support. Improved signed right shift.

2023-05-11 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-3352.c,
	  support/regression/tests/bug-3465.c,
	  support/regression/tests/bug-3523.c,
	  support/regression/tests/bug-3532.c,
	  support/regression/tests/bug-3547.c:
	  Disable warning 85 for some tests (as parameters are intentionally unused in these).

2023-05-11 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/f8/_divsint.s,
	  device/lib/f8/Makefile.in:
	  Hand-written 16x16->16 signed division support routine.

2023-05-10 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-3563.c:
	  Regression test for bug #3563 (disabled for mcs51, as the bug is not yet fixed).
	* src/SDCCmem.c,
	  support/regression/tests/*.c:
	  Fix bug #2874.

2023-05-09 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8.h,
	  sdas/asf8/f8mch.c:
	  Enable #d adressing mode for negative constants.
	* src/f8/gen.c:
	  Fix cost for addw y, #d.
	* src/f8/peeph.def:
	  More peephole optimizer rules for jump optimizations.

2023-05-07 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Carry bit tracking, improve codegen.
	* src/f8/ralloc.c:
	  Improve rematerialization.

2023-05-06 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Improve comparison.

2023-05-06 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c,
	  src/f8/ralloc2.cc:
	  Improve jump on bit.

2023-05-05 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/f8/_divuint.s,
	  device/lib/f8/Makefile.in:
	  Hand-written 16x16->16 unsigned division support routine.

2023-05-04 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Improve equality comparison.
	* device/lib/f8/_mulint.s,
	  device/lib/f8/Makefile.in:
	  Hand-written 16x16->16 multiplication support routine.
	* sdas/asf8/f8mch.c:
	  Fix handling of swapped operands on 8-bit two-operand instructions.
	* sim/ucsim/f8.src/glob.cc:
	  Fix disassembly of xch.

2023-05-04 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  support/regression/tests/bug-3579.c:
	  iy handling fixes in code generation.

2023-05-04 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  A few small codegen improvements.

2023-05-03 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Improve comparison.
	* src/f8/peeph.def:
	  Peephole optimizer rule to remove unused labels.

2023-05-02 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Improve negation.

2023-04-30 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Improve jump on comparison.
	* sdas/asf8/f8mch.c:
	  Use ldw y, #d instead of ldw y, #ii where appropriate.

2023-04-30 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/peeph.def,
	  src/f8/peep.c,
	  src/f8/gen.c,
	  src/f8/main.c:
	  A few first peephole optimizer rules.

2023-04-26 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCdwarf2.c:
	  Fix bug #3576.

2023-04-13 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asz80/z80mch.c:
	  Fix error message on use of undocumented inc/dec ixl/ixh/iyl/iyh. Fix error message on undocumented load between ix/iy l/h. Fix bug #3574.

2023-04-12 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCpeeph.c:
	  Improve error message on missing skip instruction target label at end of inline asm in __naked function. Fix bug #3566.
	* src/SDCCast.c,
	  support/regression/tests/bug-3570.c:
	  Fix bug #3570.
	* src/SDCCmem.c:
	  Fix bug #3030.

2023-04-11 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Codegen fixes and improvements.

2023-04-11 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8mch.c,
	  sim/ucsim/f8.src/decode.h,
	  sim/ucsim/f8.src/f8.cc,
	  sim/ucsim/f8.src/f8cl.h,
	  sim/ucsim/f8.src/glob.cc,
	  sim/ucsim/f8.src/imove.cc,
	  src/f8/gen.c,
	  src/f8/gen.h,
	  src/f8/ralloc.h,
	  src/f8/ralloc.h:
	  Flag register handling fix.
	* support/regression/tests/absolute.c.in,
	  support/regression/tests/bitfields-bits1.c.in,
	  support/regression/tests/bitfields-checks.c.in,
	  support/regression/tests/bitfields-dead-loop.c.in,
	  support/regression/tests/bitfields-nibbles.c.in,
	  support/regression/tests/bug-2304.c,
	  support/regression/tests/bug2686159.c,
	  support/regression/tests/bug3027957.c,
	  Fix use of absolute address in tests for f8.

2023-04-09 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  f8 codegen fixes.

2023-04-09 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Fix _BitInt *.
	* support/regression/ports/f8/support.c,
	  support/regression/ports/f8/uCsim.cmd:
	  Move simulator interface I/O to a free address.

2023-04-08 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Shift fix. Wide comparison fix. Addition fix.

2023-04-08 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Stack address rematerialization fix. Fix branch on negative zero. Comparison fixes. Signed cast fix.
	* sdas/asf8/f8mch.c:
	  Fix operand swap prefix for wide addition / subtraction.
	* support/regression/ports/f8/spec.mk:
	  Increase f8 regression test timeout.

2023-04-07 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Fix cast from global unsigned char to local int. Subtraction fix. Fix read from signed bit-field into xh register.
	* sim/ucsim/f8.src/disass.cc:
	  Fix (n, y) disassembly.

2023-04-05 Philipp Klaus Krause <philipp@colecovision.eu>

	* sim/ucsim/f8.src/ialu.cc:
	  Fix decw result.
	* sim/ucsim/f8.src/glob.cc:
	  Fix orw prefixes.
	* src/f8/gen.c:
	  Fix width-extending load move from global to local variable parts. Comparison fix. Stack address rematerialization fix.
	* support/regression/tests/gcc-torture-execute-20031012-1.c,
	  support/regression/tests/gcc-torture-execute-pr91137.c:
	  Disable tests that need excessive amounts of RAM for f8.

2023-04-04 Philipp Klaus Krause <philipp@colecovision.eu>

	* sim/ucsim/f8.src/ialu.cc:
	  Fix decw flags.
	* src/f8/gen.c:
	  Comparison fix. long long return fix.

2023-04-04 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Bit-field fix. Pointer read fix. _BitInt fixes.

2023-04-03 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Equality operator fix. Wide pointer write fix. Comparison fixes.
	  sim/ucsim/f8.src/ialu.cc:
	  Fix adcw, sbcw.

2023-04-02 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Equality operator fix. _BitInt fixes.

2023-04-02 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Fix !. Shift fixes.
	* sdas/asf8/f8mch.c:
	  Fix ld zh, xh.

2023-04-01 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Fixes for struct / union return values and parameters.

2023-04-01 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Shift fixes.

2023-04-01 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Fixes for return values wider than 64 bit.
	* device/lib/f8/Makefile.in,
	  device/lib/f8/heap.s,
	  device/lib/f8/setjmp.s,
	  sdas/asf8/f8mch.c,
	  sim/ucsim/f8.src/decode.h,
	  sim/ucsim/f8.src/f8cl.h,
	  sim/ucsim/f8.src/glob.cc,
	  sim/ucsim/f8.src/ialu.cc,
	  sim/ucsim/f8.src/imove.cc,
	  src/f8/gen.c:
	  Replace addw y, sp by ldw y, sp.
	* device/lib/f8/atomic_flag_test_and_set.s:
	  Fix atomic_flag_test_and_set.

2023-03-31 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Fixes in handling of 32-bit operands. Fix return values wider than 32 bit.
	* sdas/asf8/f8mch.c:
	  Fixes for #d operands.
	* sdas/asf8/f8.h,
	  sim/ucsim/f8.src/f8cl.h:
	  Cleanup.
	* sim/ucsim/f8.src/ialu.cc:
	  Fix orw, sbc flags.

2023-03-31 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/f8/Makefile.in:
	  Enable div function family for f8.
	* sdas/asf8/f8mch.c:
	  Fix addw y, #d.
	* src/f8/gen.c:
	  Fix subtraction workaround.

2023-03-31 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8mch.c,
	  src/f8/gen.c:
	  Initialization fixes.

2023-03-31 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Shift fixes.
	* sdas/asf8/f8mch.c:
	  Fix addw y, sp.

2023-03-31 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8mch.c,
	  sim/ucsim/f8.src/f8cl.h,
	  sim/ucsim/f8.src/ialu.cc,
	  src/f8/gen.c:
	  Comparison fixes.

2023-03-30 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Fix shift with global result. Fix 24-bit return values.

2023-03-30 Philipp Klaus Krause <philipp@colecovision.eu>

	* sim/ucsim/f8.src/ialu.cc:
	  Fix subw.
	* sim/ucsim/f8.src/glob.cc:
	  altacc'' fix.
	* src/f8/gen.c:
	  Fix an issue in callee-side handling of return values wider than 8 bytes. Fix function calls outside functions.

2023-03-30 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/main.c,
	  src/f8/gen.c:
	  Implement some more codegen.
	* sim/ucsim/f8.src/glob.cc,
	  sim/ucsim/f8.src/decode.h:
	  Fix wide rotate with sp-relative addressing.

2023-03-29 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8mch.c:
	  Fix handling of expressions for 8-bit immediate adressing mode.
	* src/f8/main.c,
	  device/lib/f8/Makefile.in:
	  Fix use of some support functions for multiplicative operators.
	* support/regression/tests/bug-2305.c,
	  support/regression/tests/bug-3167.c,
	  support/regression/tests/bug3379723.c:
	  Disable tests for __sfr for f8 (__sfr does not make sense for hardware which has all i/o in the generic address space).

2023-03-29 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8mch.c:
	  Support some more ld corner cases.
	* src/f8/gen.c:
	  Fixes in subtraction abstraction.

2023-03-28 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Support struct / union parameters.

2023-03-28 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8mch.c:
	  Fix clr with direct addressing.
	* sdas/asf8/f8pst.c,
	  sim/ucsim/f8.src/glob.cc:
	  Fix decw (n, sp).
	* sim/ucsim/f8.src/disass.cc:
	  Fix disassembly for (y) adressing.
	* sim/ucsim/f8.src/glob.cc:
	  Fix push disassembly.
	* src/f8/gen.c:
	  Fix jump on unsigned comparison.
	* sim/ucsim/f8.src/f8cl.h,
	  sim/ucsim/f8.src/imove.cc:
	  Fix ldw y, x.

2023-03-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/f8/gen.c:
	  Fix inversion of jump condition.
	* sdas/asf8/f8pst.c:
	  Fix popw.
	* sim/ucsim/f8.src/ialu.cc:
	  Fix incw.

2023-03-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8mch.c:
	  Fix ld with register source and indirect destination.

2023-03-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/ports/f8/spec.mk:
	  Compile f8 regression tests without --debug, like for the other ports.
	* sdas/asf8/f8mch.c:
	  Fix 1-operand 8-bit instructions.
	* src/f8/main.c:
	  f8 startup code.
	* sim/ucsim/f8.src/f8.cc:
	  Fix handling of altacc'' prefix in 16-bit mode.

2023-03-25 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/f8/Makefile.in:
	  Fix C standard version used for library.

2023-03-21 Felix Salfelder <felix AT salfelder.org>

	* src/SDCCmain.c:
	  Use -MF to pass dependency output file to sdcpp, fixing bug #3541.
	  See https://gcc.gnu.org/onlinedocs/cpp/Invocation.html#Invocation.

2023-03-20 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/asf8/f8mch.c:
	  Fix f8 byte order.
	* sim/ucsim/f8.src/f8cl.h:
	  Fix duplicate declarations.

2023-03-20 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-3567.c:
	  Disable a test for mcs51 small model, where it fails due to lack of memory.

2023-03-19 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  support/regression/tests/bug-3567.c:
	  Fix bug #3567.

2023-03-16 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/pdk/gen.c,
	  support/regression/tests/bug-3556.c:
	  Fix an issue in pdk shift codegen for non-dead shift amount in acc.

2023-03-15 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCast.c,
	  support/regression/tests/bug-3564.c:
	  Fix bug #3564.

2023-03-08 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bigreturn-remat.c.in,
	  support/regression/tests/rotate.c.in:
	  Improve test coverage.

2023-03-01 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/atomic.c,
	  support/regression/tests/bug-1918.c,
	  support/regression/tests/bug-2124.c,
	  support/regression/tests/bug-2181.c,
	  support/regression/tests/bug-2271.c,
	  support/regression/tests/bug-2373.c,
	  support/regression/tests/bug-2455.c,
	  support/regression/tests/bug-2497.c,
	  support/regression/tests/bug-716242.c,
	  support/regression/tests/bug1908493.c,
	  support/regression/tests/gcc-torture-execute-20030714-1.c,
	  support/regression/tests/gcc-torture-execute-980707-1.c:
	  Document why some regression tests are disabled for pdk.
	* device/include/mcs51/stc89.h,
	  src/SDCC.y,
	  src/SDCCmem.c,
	  src/SDCCsymt.c:
	  Fix typos.
	* src/SDCCicode.c:
	  Fix bug #3290.

2023-02-28 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/mcs51/rtrack.c: placed all comment emitting code in D(),
	  (_mcs51_rtrackUpdate): enabled literal mov to register part by removing D(),
	                         enabled tracking dptr by removing if(options.verboseAsm)
	* device/lib/ds390/Makefile.in,
	* device/lib/ds390/lcd390.c: removed buggy lcd390.c, the DS80C390 has no native LCD interface

2023-02-26 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCloop.c,
	  support/regression/tests/bug-3560.c:
	  Fix bug #3560.

2023-02-24 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/_minimal.c:
	  Pick minimal regression test from MP8 fork of sdcc to ease initial debugging of new ports.

2023-02-20 Felix Salfelder <felix AT salfelder.org>

	* Makefile.in:
	  fix literal sdcc-sdbinutils dep, towards fixing bug #3491.

2023-02-17 Felix Salfelder <felix AT salfelder.org>

	* support/cpp/libcpp/files.cc:
	  Remove stray assert, fix bug #3483.

2023-02-16 Felix Salfelder <felix AT salfelder.org>

	* src/clean.mk: Delete Makefile target only.

2023-02-10 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCCerr.h,
	  src/SDCCerr.c: changed possible to probable
	* src/SDCCast.c,
	  doc/sdccman.lyx: fixed spelling

2023-02-09 Philipp Klaus Krause <philipp@colecovision.eu>

	* doc/sdccman.lyx:
	  Fix bug #3382.
	* support/regression/tests/*.c,
	  src/*:
	  Spelling fixes for comments, from patch #459 by Konstantin Kim.

2023-02-08 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCicode.c,
	  support/regression/tests/bug-2776.c,
	  support/regression/tests/bug-3368.c:
	  Fix bugs #2776, #3378.

2023-02-06 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCicode.c,
	  support/regression/tests/bug-3352.c:
	  Fix bug #3352.
	* device/lib/sm83/crt0.s:
	  Fix bug #3548.
	* support/regression/tests/gcc-torture-execute-pr91137.c:
	  Fix bug #3549.
	* support/regression/tests/bug1723128.c:
	  Fix bug #3550.

2023-02-05 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/z80/gen.c,
	  support/regression/tests/bug-3547.c:
	  Fix bug #3547.

2023-02-04 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCerr.h,
	  src/SDCCerr.c,
	  src/SDCC.y:
	  Warn on deprecated _sdcc_external_startup, RFE #868.
	* device/lib/printf_large.c,
	  .version,
	  doc/sdccman.lyx,
	  support/regression/tests/snprintf.c.in:
	  Fix endiannness of %p output, based on patch #457 by Basil Hussain, bug #3543.
	* src/SDCCast.c,
	  src/SDCCglue.c,
	  support/valdiag/tests/bug-3060.c:
	  Fix bug #3060.
	* src/SDCCpeeph.c:
	  Fix bug #3545.

2023-02-02 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/cases/Makefile.in:
	  Disable a test that often times out on slower machines in the compile farm (due a large number of slow operations in a loop).

2023-02-01 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/bug-3249.c:
	  Do not test non-intrinsic named address space areas for mcs51, as DATA is overwritten by stack there.
	* support/regression/MakeList:
	  Disable a test for -mmcs51 --model-small --stack-auto that is known to fail for mcs51 with --stack-auto (bug #3540).
	* src/SDCCglue.c,
	  support/regression/tests/bug-1981238.c:
	  Fix bug #3542.

2023-01-31 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCglue.c:
	  Fix bug #2837 for z80 and related.

2023-01-30 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCsymt.c,
	  support/regression/tests/bug-3025.c,
	  support/regression/cases/Makefile.in,
	  Fix bug #3025.
	* src/mos6502/peeph.def:
	  Disable a rule that uses not-yet-implemented notUsed.
	* src/pdk/gen.c:
	  Fix a pdk issue similar to mcs51 bug #3023.
	* src/SDCC.y,
	  device/lib/printf_large.c,
	  device/lib/printfl.c,
	  device/lib/sprintf.c,
	  device/lib/vprintf.c:
	  Fix bug #3497.
	* src/z80/gen.c,
	  support/regression/tests/bug-3249.c:
	  Fix bug #3249.
	* support/regression/tests/inline.c:
	  Disable a test for host, which fails on GNU/Linux on aarch64 using GCC 12.2.
	* src/SDCC.y,
	  src/SDCCast.c,
	  src/SDCCerr.c,
	  src/SDCCerr.h:
	  Fix error message test for empty translation units.

2023-01-29 Benedikt Freisen <b.freisen AT gmx.net>

	* device/include/float.h,
	  device/lib/_divsint.c,
	  device/lib/_divslong.c,
	  device/lib/_divslonglong.c,
	  device/lib/_divuint.c,
	  device/lib/_divulong.c,
	  device/lib/_divulonglong.c,
	  device/lib/_modsint.c,
	  device/lib/_modslong.c,
	  device/lib/_modslonglong.c,
	  device/lib/_moduint.c,
	  device/lib/_modulong.c,
	  device/lib/_modulonglong.c,
	  device/lib/_mulint.c,
	  device/lib/_mullong.c,
	  device/lib/_mullonglong.c,
	  device/lib/_rlslonglong.c,
	  device/lib/_rlulonglong.c,
	  device/lib/_rrslonglong.c,
	  device/lib/_rrulonglong.c,
	  device/lib/_slonglong2fs.c,
	  device/lib/_ulonglong2fs.c:
	  Add conditional `__nonbanked` to fix mcs51 library build.

2023-01-28 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCerr.c,
	  src/SDCCerr.h,
	  src/ds390/gen.c,
	  src/mcs51/gen.c,
	  support/regression/tests/bug-3023.c:
	  Fix bug #3023.

2023-01-28 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCast.c,
	  src/SDCCerr.c,
	  src/SDCCerr.h,
	  src/SDCCsymt.c,
	  src/port.h,
	  src/*/main.c:
	  Fix bug #3160.
	* src/mos6502/ralloc.c,
	  src/z80/ralloc.c:
	  Code cleanup.

2023-01-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCicode.c,
	  support/regression/cases/Makefile.in,
	  support/regression/MakeList:
	  Fix bug #3394.
	* src/SDCCerr.h,
	  src/SDCCerr.c,
	  src/stm8/gen.c,
	  src/z80/gen.c,
	  support/valdiag/tests/bug-3228.c:
	  Fix bug #3228.
	* src/SDCCsymt.c,
	  .version,
	  doc/sdccman.lyx:
	  Fix bug #3263.

2023-01-27 Philipp Klaus Krause <philipp@colecovision.eu>

	* sdas/aspdk15/pdk15mch.c:
	  Fix bug #3191.
	* src/SDCCsymt.c:
	  Fix bug #3516.
	* src/SDCCopt.c,
	  support/regression/cases/Makefile.in:
	  Fix bug #3400.

2023-01-26 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCval.c:
	  Make ulFromVal a wrapper for ullFromVal to remove duplicate code and partially fix bug #3539.
	* src/z80/gen.c:
	  Fix an sm83 issue similar to z80 bug #3503.
	* doc/sdccman.lyx:
	  Add _BitInt to type list in manual.
	* src/SDCCglue.c:
	  Skip invalid init list bits. Fix bug #2928.
	* src/SDCCicode.c,
	  support/regression/tests/bug-2983.c:
	  Fix bug #2983.
	* src/pdk/peeph.def:
	  Fix an issue in two pdk peephole rule conditions.s
	* src/SDCCsymt.c:
	  Fix bug #2998.
	* src/SDCC.lex,
	  support/valdiag/tests/bug-3012.c:
	  Fix bug #3012.

2023-01-25 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCval.c:
	  Type fixes (fixing regressions visible on 32-bit big-endian hosts), partial fix for bug #3539.
	* src/stm8/gen.c:
	  Fix an stm8 issue similar to z80 bug #3503.
	* src/pdk/peeph.def:
	  Fix use of cneqsn, which is not supported on pdk13.

2023-01-24 Philipp Klaus Krause <philipp@colecovision.eu>

	* doc/sdccman.lyx,
	  doc/z80-stack-cleanup.svg:
	  Improve documentation on stack cleanup (support request #182).
	* src/SDCCpeeph.c,
	  src/pdk/gen.c,
	  src/pdk/peeph.def,
	  support/regression/tests/bug-3525.c:
	  Fix bug #3525.

2023-01-23 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCbtree.cc:
	  Fix bug #3505.
	* src/ds390/gen.c,
	  src/mcs51/gen.c,
	  src/z80/gen.c:
	  Type fixes for code generation (fixing regressions visible on 32-bit big-endian hosts), partial fix for bug #3539.
	* device/include/stdckdint.h,
	  device/lib/strtol.c,
	  device/lib/strtoul.c,
	  support/regression/tests/bug-3474.c,
	  support/regression/tests/bug-2854.c
	  Fix bug #3474.
	* support/regression/tests/gcc-torture-execute-p18298.c:
	  extern declaration for inline function to pass host regression tests where the host compiler does not inline.
	* support/regression/MakeList:
	  Exclude test for host, since it fails for GCC 7, which is still used on the PPC macOS machine in the compile farm.
	* src/z80/gen.c,
	  src/pdk/gen.c,
	  support/regression/tests/bug-3503.c:
	  Fix bug #3503.

2023-01-21 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/mos6502/main.c:
	  stdlib selection, patch #454 by Basil Hussain.
	* debugger/mcs51/cmd.c:
	  Avoid debugger segfault, patch #449 by Mark Symonds.
	* doc/sdccman.lyx:
	  Enhance documentation for __sdcc_external_startup, patch #456 by Basil Hussain.
	* src/SDCC.y:
	  Remove null-pointer checks on something that is not a pointer in current SDCC, patch #442 by Reini Urban.
	* src/pdk/main.c,
	  .version:
	  __sdcc_external_startup return checking for pdk, patch #455 by Basil Hussain.
	* src/mos6502/peeph.def:
	  mos6502 peephole rule fix, patch #453 by Michel Iwaniec.
	* src/stm8/gen.c
	  Type fix for code generation (fixing regressions visible on 32-bit big-endian hosts), partial fix for bug #3539.
	* src/z80/gen.c,
	  support/regression/tests/bug-3532.c:
	  Fix bug #3532.
	* src/SDCCbtree.cc,
	  support/regression/tests/bug-3523.c,
	  support/regression/tests/bug-3487.c:
	  Fix bugs #3523, #3487.

2023-01-19 Philipp Klaus Krause <philipp@colecovision.eu>

	* device/lib/*/crt0.s,
	  src/SDCCglue.c,
	  src/stm8/main.c,
	  .version:
	  Patch #453 by Basil Hussain to further harmonize __sdcc_external_startup (RFE #859).
	* src/z80/gen.c,
	  src/ds390/gen.c,
	  src/mcs51/gen.c:
	  Type fixes for code generation (fixing regressions visible on 32-bit big-endian hosts), partial fix for bug #3539.
	* doc/sdccman.lyx:
	  Improve __sdcc_external_startup documentation.

2023-01-17 Philipp Klaus Krause <philipp@colecovision.eu>

	* support/regression/tests/gcc-torture-execute-va-arg-5.c:
	  Disable Test for GCC up to 11, since it still fails on x86 hosts for that version.
	* support/regression/cases/Makefile.in:
	  Disable Test that tests for GCC implementation-defined behaviour (GIMPLE memory model).

2023-01-10 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCCcse.c: Improve pointer aliasing handling,
	  minor reduction in memory leakage
	* support/regression/tests/bug-2957.c,
	  support/regression/tests/gcc-torture-execute-pr20466-1.c:
	  Reenable tests

2023-01-08 Benedikt Freisen <b.freisen AT gmx.net>

	* src/SDCCmain.c:
	  Add "TD-" to the version string of treedec-less builds.

2023-01-08 Benedikt Freisen <b.freisen AT gmx.net>

	* doc/sdccman.lyx:
	  Amend claims concerning intrinsic address space support.

2023-01-02 Philipp Klaus Krause <philipp@colecovision.eu>

	* src/SDCCast.c,
	  support/regression/tests/bug-3504.c:
	  Fix bug #3504.

2022-12-31 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCClabel.c (labelUnreach, deleteIfx),
	  src/SDCCcse.c (ifxOptimize): disable conditional flow change and
	  unreachable code warnings within function inlining
	* src/SDCClabel.c (labelJumptable,iCodeLabelOptimize),
	  src/SDCCcse.c (cseBBlock): optimize jump tables
	* src/SDCClabel.c (labelUnreach): clean up dead code def/use info

2022-12-24 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* support/cpp/gcc/configure.ac,
	  support/cpp/gcc/configure: disable some assembler and
	  target tests unneeded for the preprocessor

2022-12-16 Philipp Klaus Krause <pkk AT spth.de>

	* doc/sdccman.lyx:
	  Fix bug #3500.
	* src/stm8/gen.c,
	  src/pdk/gen.c:
	  Fix bug #3515.

2022-12-15 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/gcc-torture-execute-941021-1.c:
	  Remove a test that apparently relies on implementation-defined floating-point rounding behaviour.

2022-12-14 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/bug-2567.c,
	  support/regression/tests/bug-2752.c:
	  Provide external declaration of inline function to pass test-host for non-inlining host compilers.
	* sdas/aspdk14/pdk14mch.c,
	  sdas/aspdk15/pdk15mch.c:
	  Fix bug #3376, patch by Free-PDK.

2022-12-13 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/sm83/divint.s,
	  support/regression/tests/muldiv.c.in,
	  support/regression/tests/onebyte.c.in:
	  Fix a % sm83 library issue, patch by Job Bolle.
	* src/stm8/main.c:
	  Fix __sdcc_external_startup handling for stm8 large memory model.
	* src/z80/peeph.def:
	  Fix bug #3528.

2022-12-04 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCopt.c,
	  support/regression/tests/bug-3522.c:
	  Fix bug #3522.

2022-12-03 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/_startup.c,
	  device/lib/ds390/tinibios.c,
	  device/lib/ez80_z80/crt0.s,
	  device/lib/mcs51/crtstart.asm,
	  device/lib/mcs51/crtxstack.asm,
	  device/lib/mos6502/crt0.s,
	  device/lib/mos6502-stack-auto/crt0.s,
	  device/lib/r2k/crt0.s,
	  device/lib/r2ka/crt0.s,
	  device/lib/r3ka/crt0.s,
	  device/lib/sm83/crt0.s,
	  device/lib/tlcs90/crt0.s,
	  device/lib/z180/crt0.s,
	  device/lib/z80/crt0.s,
	  device/lib/z80n/crt0.s,
	  doc/sdccman.lyx,
	  src/ds390/main.c,
	  src/hc08/main.c,
	  src/pdk/main.c,
	  src/stm8/main.c,
	  support/regression/ports/mcs51-common/support.c:
	  Rename _sdcc_external_startup to __sdcc_external_startup and make it work for all ports. Fixes bug #3520.

2022-11-30 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* support/cpp/gcc/pretty-print.cc: define some console
	  attribute constants if they are missing
	* support/cpp/gcc/gcc.cc,
	  support/cpp/gcc/opts.cc,
	  support/cpp/gcc/opts-common.cc,
	  support/cpp/gcc/opts-global.cc,
	  support/cpp/gcc/prefix.cc,
	  support/cpp/gcc/toplev.cc,
	  support/cpp/libcpp/lex.cc,
	  support/cpp/libcpp/mkdeps.cc,
	  support/cpp/gcc/c-family/c-opts.cc,
	  support/cpp/gcc/c-family/c-ppoutput.cc:
	  Possible fix for bug #3524

2022-11-29 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* support/cpp/gcc/system.h: don't try to check inodes when
	  compiled for Windows

2022-11-28 Philipp Klaus Krause <pkk AT spth.de>

	* src/pdk/peep.c,
	  src/pdk/gen.c:
	  Pdk peephole infrastructure improvements, patch #446 by Konstantin Kim.

2022-11-28 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* support/scripts/sdcc.nsi: add cc1.exe
	* support/cpp/gcc/Makefile.in,
	  support/cpp/gcc/cc1_dummies.cc,
	  support/cpp/gcc/c/Make-lang.in,
	  support/cpp/gcc/c-family/c-common.h,
	  support/cpp/gcc/c-family/c-opts.cc: remove some unneeded
	  compile time executable requirement so cross compile with
	  mingw can succeed

2022-11-26 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* support/cpp/gcc/Makefile.in: add missing $(exeext)
	* support/cpp/gcc/gcc.cc,
	  support/cpp/gcc/opts.cc,
	  support/cpp/gcc/opts-common.cc,
	  support/cpp/gcc/prefix.cc,
	  support/cpp/gcc/toplev.cc,
	  support/cpp/libcpp/lex.cc,
	  support/cpp/libcpp/mkdeps.cc,
	  support/cpp/gcc/c-family/c-opts.cc,
	  support/cpp/gcc/c-family/c-ppoutput.cc: move iostream header
	  last to avoid inconsistent struct offsets and thus segfaults

2022-11-24 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCClabel.c (labelGotoGoto, labelUnreach),
	  src/SDCCBBlock.c (iCodeFromeBBlock),
	  src/SDCCicode.h: fix bug #3501

2022-11-23 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCC.lex: process #line directive in __asm__ blocks

2022-11-14 Benedikt Freisen <b.freisen AT gmx.net>

	* src/pic16/pcodepeep.c:
	  Fix type mismatches, one of them critical. See [bugs:#3179].

2022-11-11 Felix Salfelder <felix AT salfelder.org>

	* support/cpp/gcc/config.gcc:
	  Workaround: Ignore "unsupported target"
	  ... as suggested by Free-PDK in bug #3517.

2022-11-06 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c:
	  Fix an issue related to bug #3471.

2022-11-04 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/peep.c,
	  src/z80/peeph.def:
	  Fix iy handling in peephole optimizer, variant of patch #441 by Job Bolle.
	* src/stm8/peeph.def,
	  support/regression/tests/modulong.c,
	  support/regression/ports/stm8/spec.mk:
	  clr-push stm8 peephole optimizer rule, variant of patch #443 by Basil Hussain.

2022-11-03 Benedikt Freisen <b.freisen AT gmx.net>

	* support/cpp/gcc/config/riscv/arch-canonicalize:
	  Add missing file from GCC CPP.

2022-10-25 Felix Salfelder <felix AT salfelder.org>

	* support/cpp/gcc/cc1_dummies.cc:
	  Fix argument type in dummy, #3492.

2022-10-21 Philipp Klaus Krause <pkk AT spth.de>

	* doc/sdccman.lyx:
	  Fix a typo noticed by Basil Hussain, that makes an aspect of the stm8 calling convention, version 0, ambiguous.

2022-10-13 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCopt.c:
	  Relax type match requirements on literal operands to multiplication support functions.

2022-10-11 Philipp Klaus Krause <pkk AT spth.de>

	* src/pdk/gen.c,
	  src/pdk/ralloc.c,
	  src/stm8/gen.c,
	  src/stm8/ralloc.c:
	  Small improvements in reads of bool bit-fields.

2022-10-07 Felix Salfelder <felix AT salfelder.org>

	* support/cpp/gcc/cc1_dummies.cc:
	  Add two more dummies.

2022-10-03 Benedikt Freisen <b.freisen AT gmx.net>

	* device/include/gcc_attr.h:
	  Use C23 version macro.

2022-10-01 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/MakeList:
	  Disable a test for pdk14 that fails due to lack of memory on the target device.

2022-09-29 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/peeph.def:
	  Use mov in more cases, patch by Basil Hussain.
	* device/include/assert.h:
	  Fix static_assert for C11.

2022-09-25 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCmain.c,
	  support/cpp/libcpp/init.cc:
	  Fix handling of c2x standard for preprocessor.
	* device/include/stdlib.h,
	  device/lib/Makefile.in,
	  device/lib/__stdc_count_leading_zeros.c,
	  device/lib/__stdc_first_leading_one.c,
	  device/lib/__stdc_first_trailing_oneull.c,
	  device/lib/_divslonglong.c,
	  device/lib/_divulonglong.c,
	  device/lib/_modslonglong.c,
	  device/lib/_mullonglong.c,
	  device/lib/_rlslonglong.c,
	  device/lib/_rlulonglong.c,
	  device/lib/_rrslonglong.c,
	  device/lib/_rrulonglong.c,
	  device/lib/aligned_alloc.c,
	  device/lib/*/Makefile.in,
	  device/lib/ds390/lcd390.c,
	  device/lib/printf_large.c,
	  device/lib/printfl.c,
	  device/lib/sprintf.c,
	  device/lib/vprintf.c:
	  Fix bug #3496.

2022-09-24 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* device/include/assert.h,
	  device/include/ctype.h,
	  device/include/limits.h,
	  device/include/stdarg.h,
	  device/include/stdbool.h,
	  device/include/stddef.h,
	  device/include/stdlib.h,
	  device/include/uchar.h,
	  device/include/setjmp.h,
	  device/include/stdalign.h,
	  device/include/stdint.h:
	  Replace include guards by C23 header version macros.

2022-09-23 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/z80/peep.c:
	  Improve handling of iyl, iyh in peephole rules, based on patch by Job Bolle.

2022-09-21 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/z80/peep.c:
	  Handling of immediates in canAssign for z80 and related.

2022-09-20 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/z80/peeph.def: fixed rules 85a, 85b to fix bug #3486,
	  Thanks Job Bolle

2022-09-19 Felix Salfelder <felix AT salfelder.org>

	* src/SDCCmain.c:
	  Pass -xc to preprocessor, overriding file-type-by-extension magic.

2022-09-18 Maarten Brock <sourceforge.brock AT dse.nl>

	* debugger/mcs51/cmd.c: applied patch #439,
	    also applied patch from bug #3485, Thanks Mark Symonds,
	    also cleaned up many whitespace irregularities

2022-09-17 Felix Salfelder <felix AT salfelder.org>

	* support/regression/MakeList,
	  support/regression/tcc/83_utf8_in_identifiers.c:
	  Revive erroneously disabled utf8 test.

2022-09-13 Benedikt Freisen <b.freisen AT gmx.net>

	* doc/sdccman.lyx,
	  src/ds390/gen.c,
	  support/regression/tests/gcc-torture-execute-strct-varg-1.c,
	  support/regression/tests/gcc-torture-execute-va-arg-23.c,
	  support/regression/tests/gcc-torture-execute-va-arg-4.c:
	  struct / union parameters on the stack for ds390, copied from mcs51.

2022-09-13 Felix Salfelder <felix AT salfelder.org>

	* support/cpp/gcc/{system,double-int}.h:
	  Remove wrong/unneeded gmp use.

2022-09-12 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* device/include/tinibios.h,
	  device/lib/ds390/tinibios.c,
	  device/lib/ds400/tinibios.c:
	  Provide function prototypes for tinybios.

2022-09-11 Benedikt Freisen <b.freisen AT gmx.net>

	* doc/sdccman.lyx,
	  src/SDCC.y,
	  src/SDCCerr.c,
	  src/SDCCsymt.c,
	  support/regression/cases/Makefile.in:
	  Handle types double and long double in checkTypeSanity.

2022-09-09 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCsymt.c,
	  src/SDCCast.c,
	  support/regression/tests/bug-3481.c:
	  Fix part of bug #3481.

2022-09-09 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/z80/gen.c:
	  Fix bug #3480.

2022-09-08 Felix Salfelder <felix AT salfelder.org>

	* support/cpp/libbacktrace/allocfail.sh:
	  Delete unused file.

2022-09-08 Felix Salfelder <felix AT salfelder.org>

	* device/lib/incl.mk:
	  Fix %.rel rules. Thanks to Job Bolle, see discussion/1865.

2022-09-08 Felix Salfelder <felix AT salfelder.org>

	* support/cpp/gcc/Makefile.in:
	  avoid tm-preds.h cleanup once more.

2022-09-07 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCpeeph.c,
	  src/z80/peeph.def,
	  support/regression/tests/bug-3478.c:
	  Fix bug #3478.

2022-09-06 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/z80/gen.c,
	  support/regression/tests/bug-3471.c:
	  Fix bug #3471.

2022-09-06 Felix Salfelder <felix AT salfelder.org>

	* support/cpp/gcc/Makefile.in,
	  support/cpp/libbacktrace/Makefile.am:
	  Revisit don't clean no-longer autogenerated files.

2022-09-06 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCcse.c,
	  support/regression/tests/bug-3470.c:
	  Fix part of bug #3470.

2022-09-04 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* Merge cpp branch to trunk.

2022-09-04 Felix Salfelder <felix AT salfelder.org>

	* support/cpp/gcc/hash-table.h:
	  Revert a compile warning fix.

2022-09-02 Felix Salfelder <felix AT salfelder.org>

	* support/cpp/gcc/cc1_dummies.cc,
	  support/cpp/gcc/ggc-common.cc,
	  support/cpp/gcc/hash-map.h,
	  support/cpp/gcc/hash-table.h,
	  support/cpp/gcc/vec.h:
	  Fix compile warnings

2022-09-01 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/valdiag/tests/universal.c,
	  support/valdiag/tests/universal2.c:
	  Separate out a test that needs to reside in a file on its own, since the diagnostic is emitted even inside #if 0.

2022-08-31 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/tests/checkedint.c.in:
	  Disable test for mcs51 medium memory model, where it fails due to lack of memory.

2022-08-31 Felix Salfelder <felix AT salfelder.org>

	* sdcc/support/cpp/gcc/opts.cc,
	  sdcc/support/cpp/libcpp/mkdeps.cc:
	  Test x2.

2022-08-30 Felix Salfelder <felix AT salfelder.org>

	* support/cpp/configure, support/cpp/configure.ac:
	  Omit gmp/mpfr checks and GCC_TOPLEV_SUBDIRS.

2022-08-23 Felix Salfelder <felix AT salfelder.org>

	* support/cpp/configure, support/cpp/configure.ac,
	  support/cpp/gcc/configure, support/cpp/gcc/configure.ac:
	  Reduce diff against upstream gcc.

2022-08-21 Felix Salfelder <felix AT salfelder.org>

	* support/regression/Makefile.in,
	  support/regression/cases/Makefile.in:
	  Test summary depends on test set.

2022-08-20 Felix Salfelder <felix AT salfelder.org>

	* support/cpp/gcc/Makefile.in:
	  Do not clean no-longer autogenerated files.

2022-08-30 Felix Salfelder <felix AT salfelder.org>

	* support/regression/cases/Makefile.in:
	  Add distclean rule.

2022-08-30 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCmem.c,
	  support/regression/tests/bug-3040.c.in:
	  Fix bug #3073.
	* support/regression/tests/checkedint.c.in:
	  Test checked integers, part of RFE #749.
	* tests/gcc-torture-execute-920711-1.c:
	  Remove a test that relies on undefined behaviour on signed integer overflow.
	* src/SDCCcse.c,
	  support/valdiag/tests/bug-3457.c:
	  Fix bug #3457.
	* src/SDCCmem.c,
	  src/SDCCval.c,
	  support/valdiag/tests/bug-3031.c:
	  Fix bug #3383.

2022-08-29 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/cases/Makefile.in:
	  Disable a GCC test that tests for GCC implementation-defined floating-point behaviour.

2022-08-26 Felix Salfelder <felix AT salfelder.org>

	* regression/ports/pic14/spec.mk:
	  LDFLAGS & EMU invocation fixes

2022-08-17 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* device/lib/f8/Makefile.in:
	  Build small integer modulo support routines for f8.
	* support/regression/ports/f8/spec.mk:
	  f8 regression test infrastructure.
	* sim/ucsim/f8.src/f8.cc,
	  src/f8/main.c:
	  f8 pc reset value.

2022-08-17 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/ports/hc08/spec.mk,
	  support/regression/ports/s08/spec.mk:
	  Increase regression test timeout slightly, so a passive-cooled Raspi 4B can run the qct_0042-prime regression test in Summer.

2022-08-16 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* device/include/stdatomic.h,
	  device/lib/atomic_flag_clear.c,
	  sdas/asf8/f8mch.c:
	  f8 fixes to make the standard library build.
	* Makefile.common.in,
	  sdas/linksrc/Makefile.in,
	  sdas/linksrc/sdld.c,
	  sdas/linksrc/sdld.h,
	  sdccconf_in.h:
	  Build linker for f8.

2022-08-16 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* doc/sdccman.lyx,
	  .version,
	  support/regression/tests/pragma_pedantic_parse_number.c:
	  Document dropped support for --pedantic-parse-number and #pragma pedantic_parse_number.

2022-08-16 Felix Salfelder <felix AT salfelder.org>

	* support/cpp:
	  Partially import gcc (12.1.0, 1ea978e3066a),
	  Isolate, dissect, gcc/cpp,
	  Create dummy target files,
	  (Re)add -obj-ext option,
	  Change # to #line in cpp output,
	* Makefile.common.in:
	  Set .DELETE_ON_ERROR
	* configure.ac, src/Makefile.in:
	  Obtain svn revision and paste into version.h
	* configure.ac, Makefile.in, bin/*:
	  Add Makefile, wrap executables, adjust rules.

2022-08-14 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* device/lib/pic16/startup/crt0.c,
	  device/lib/pic16/startup/crt0i.c,
	  device/lib/pic16/startup/crt0iz.c:
	  Update interrupt syntax for new parser

2022-08-10 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* device/include/stdbit.h:
	  Fix bit and byte utilities find first leading bit functions for ports that don't have _BitInt yet.

2022-08-10 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* doc/sdccman.lyx,
	  src/SDCC.y:
	  Document intentional deviation from C2X draft N3047 rules for tag compatibility for unions.

2022-08-09 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCast.c:
	  Fix handling of pointers to short, long and long long (without explicit int) in _Generic associations.
	* device/include/stdckdint.h,
	  device/lib/incl.mk,
	  device/lib/ckd_add.c,
	  device/lib/ckd_mul.c,
	  device/lib/ckd_sub.c,
	  doc/sdccman.lyx,
	  .version:
	  Checked integer arithmetic for all types except (unsigned) long long, part of RFE #749.

2022-08-09 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.y,
	  .version,
	  support/valdiag/tests/enum.c:
	  C2X enum tag compatibility rules, RFE #852.

2022-08-09 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.y,
	  src/SDCCerr.c,
	  src/SDCCerr.h,
	  src/SDCCsymt.c,
	  src/SDCCsymt.h,
	  support/valdiag/tests/struct.c:
	  C2X struct / union tag compatibility rules, part of RFE #852.

2022-08-08 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* device/include/stdlib.h,
	  device/lib/incl.mk,
	  device/lib/call_once.c:
	  call_once, RFE #777.

2022-08-08 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* device/include/stdbit.h,
	  device/lib/incl.mk,
	  device/lib/__stdc_first_leading_one.c,
	  support/regression/tests/bitfirstleading.c.in:
	  Provide bit and byte utilities find first leading bit functions. RFE #854.

2022-08-08 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* device/include/stdbit.h,
	  device/lib/incl.mk,
	  device/lib/__stdc_count_leading_zeros.c,
	  support/regression/tests/bitcountleading.c.in:
	  Provide bit and byte utilities count leading bits functions. Part of RFE #854.
	* src/SDCCast.c:
	  Fix type handling for bit-precise types in _Generic association.

2022-08-08 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* device/include/stdbit.h,
	  device/lib/incl.mk,
	  device/lib/__stdc_first_trailing_oneull.c,
	  support/regression/tests/bitfirst.c.in:
	  Provide bit and byte utilities first trailing bit functions. Part of RFE #854.

2022-08-08 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* device/include/stdbit.h,
	  device/lib/__stdc_count_trailing_onesull.c,
	  device/lib/incl.mk,
	  support/regression/tests/bitcounttrailing.c.in:
	  Provide bit and byte utilities trailing bit count functions. Part of RFE #854.

2022-08-07 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCsymt.c,
	  support/regression/tests/c2xkeywords.c:
	  Fix bug #3468.

2022-08-06 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* device/include/stdbit.h,
	  device/lib/incl.mk,
	  device/lib/__stdc_bit_ceilull.c,
	  device/lib/__stdc_bit_widthull.c,
	  support/regression/tests/bitcount.c.in:
	  Provide bit and byte utilities bit width floor and ceiling functions. Part of RFE #854.

2022-08-05 Benedikt Freisen <b.freisen AT gmx.net>

	* device/include/stddef.h:
	  Protect NULL macro with parentheses, fixing bug #3467.

2022-08-05 Benedikt Freisen <b.freisen AT gmx.net>

	* doc/sdccman.lyx:
	  Missing K&R function support is not a deviation from C2X compliance.

2022-08-05 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* device/include/stdbit.h,
	  device/include/stdint.h,
	  device/lib/_mulint.c,
	  device/lib/_mullong.c,
	  device/lib/_rlulonglong.c,
	  device/lib/_rrslonglong.c,
	  device/lib/_rrulonglong.c,
	  device/lib/_startup.c,
	  device/lib/__stdc_count_onesull.c,
	  support/regression/tests/bitcount.c.in,
	  device/lib/_mullong.c:
	  Provide and use bit and byte utility types and macros. Provide bit and byte utilities bit count and single-bit check functions. Part of RFE #854.

2022-08-05 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* .version,
	  src/SDCC.y,
	  src/SDCCerr.c,
	  src/SDCCerr.h,
	  src/SDCCsymt.c,
	  support/regression/tests/bug-3462.c:
	  Fix bug #3462.
	* doc/sdccman.lyx:
	  Update manual section on standard compliance for recent improvements.

2022-08-05 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* Merge parser branch to trunk.

2022-08-05 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.y,
	  src/SDCCsymt.c,
	  src/SDCCsymt.h,
	  support/regression/tests/bug-3465.c:
	  Basic C99 VLA type support, RFE #786, fix bug #3465.

2022-08-04 Benedikt Freisen <b.freisen AT gmx.net>

	* support/scripts/sdcc.nsi:
	  Correct STM8 memory model name from small to medium, fixing bug #3466.

2022-08-04 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.y,
	  src/SDCCerr.c,
	  src/SDCCerr.h,
	  src/SDCCmem.c,
	  src/SDCCsymt.c,
	  src/SDCCsymt.h:
	  Infrastructure for VLA types.

2022-08-04 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.y,
	  src/SDCCerr.c,
	  src/SDCCerr.h,
	  src/SDCCsymt.c,
	  src/SDCCval.h,
	  C2X {} empty initializers, RFE #782.

2022-08-04 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/util/dbuf_string.c:
	  Code cleanup.
	* src/SDCCglue.c:
	  Fix area directive for sseg, patch by Tarn.

2022-08-03 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.y:
	  Refactor handling of array declarators.

2022-08-03 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* Merge parser branch to trunk.

2022-08-03 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCerr.h,
	  src/SDCCerr.c,
	  src/SDCC.y:
	  Allow more attribute arguments, warn on unknown attributes.

2022-08-03 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.y:
	  Allow attributes in direct declarators. Avoiding grammar conflicts for K&R function definitions made this a bit more complex.

2022-08-03 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.y,
	  src/SDCCsymt.c,
	  src/SDCCsymt.h,
	  support/regression/tests/bug-2664.c:
	  Fix bug #2664.
	* support/valdiag/tests/bug-3009.c,
	  support/valdiag/tests/bug-3011.c:
	  Ignore a warning that is irrelevant for these test cases.

2022-08-02 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.y,
	  src/SDCCast.c,
	  src/SDCCsymt.c,
	  src/SDCCsymt.h,
	  support/regression/tests/bug-2222.c,
	  support/regression/tests/bug-2263.c,
	  support/regression/tests/bug-2320.c,
	  support/regression/tests/bug-2629.c,
	  support/regression/tests/bug-2956.c,
	  support/regression/tests/bug-3079.c,
	  support/regression/tests/bug-3081.c,
	  support/regression/tests/bug-3093.c,
	  support/regression/tests/bug-3135.c,
	  support/regression/tests/bug-3169.c,
	  support/regression/tests/bug-3215.c:
	  Fix handling of pre-C2X function declarators without prototype, RFE #776.

2022-08-02 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* Merge parser branch to trunk.

2022-08-02 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.y,
	  src/SDCCsymt.c,
	  support/regression/tests/auto.c,
	  support/valdiag/tests/bug-3464.c:
	  C2X auto, RFE #849, fix bug #3464.

2022-08-02 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.y,
	  src/SDCCast.h,
	  src/SDCCast.c,
	  .version,
	  support/regression/tests/typeof.c:
	  C2X typeof, typeof_unqual, RFE #739, RFE #783.

2022-08-01 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* device/include/stddef.h,
	  src/SDCCicode.c,
	  src/SDCCsymt.c,
	  support/regression/tests/unreachable.c:
	  C2X unreachable, RFE #778.

2022-08-01 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* device/include/stdlib.h,
	  device/lib/incl.mk,
	  device/lib/memalignment.c,
	  support/regression/tests/memalignment.c.in:
	  C2X memalignment, RFE #856.

2022-08-01 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* Merge parser branch to trunk.

2022-08-01 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.lex,
	  src/SDCC.y,
	  src/SDCCast.c,
	  src/SDCCerr.c,
	  src/SDCCerr.h,
	  src/SDCCsymt.h,
	  device/include/stddef.h,
	  support/regression/tests/c2xkeywords.c,
	  support/regression/tests/typeof.c:
	  Basic C2X typeof and typeof_unqual support, part of RFE #739, RFE #783. RFE #853.

2022-08-01 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.lex,
	  src/SDCC.y,
	  src/SDCCerr.c,
	  src/SDCCerr.h,
	  src/SDCCsymt.c,
	  src/SDCCsymt.h,
	  src/SDCCval.c,
	  src/SDCCval.h:
	  Basic C2X nullptr support, part of RFE #853.

2022-08-01 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.y:
	  Simplify grammar rules for enum.

2022-07-29 Felix Salfelder <felix AT salfelder.org>

	* src/SDCC.y:
	  Remove obsolete __func__ magic handling from parser.

2022-07-26 Felix Salfelder <felix AT salfelder.org>

	* device/lib/Makefile.in, device/lib/*/Makefile.in,
	  device/lib/incl.mk:
	  Deduplicate CC, introduce SDAR, add Makefile rules,
	  fix error propagation.

2022-07-24 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* device/lib/ds400/ds400rom.c:
	  Fix use of macro for #.

2022-07-22 Felix Salfelder <felix AT salfelder.org>

	* src/SDCC.lex:
	  Skip "line" in lineinfo line. This fixes [r13587].

2022-07-22 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCast.c,
	  support/regression/tests/bug-3401.c:
	  Fix bug #3401.

2022-07-22 Felix Salfelder <felix AT salfelder.org>

	* support/cpp/c-ppoutput.c:
	  Add "line" to lineinfo lines, following the standard.

2022-07-21 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCglue.c,
	  support/regression/tests/bug-3461.c:
	  Fix third and last part of bug #3461.

2022-07-20 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/ds390/gen.c,
	  src/hc08/gen.c,
	  src/mcs51/gen.c,
	  src/mos6502/gen.c,
	  support/regression/tests/bug-3463.c:
	  Fix bug #3463.

2022-07-19 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/pdk/gen.c,
	  src/stm8/gen.c,
	  src/z80/gen.c,
	  support/regression/tests/bug-3461.c:
	  Fix bug #3461.

2022-07-18 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/tests/bug-3410.c.in:
	  Disable a test for mos6502, since that port it still lacks _BitInt.
	* support/regression/tests/bug-3461.c:
	  New (currently disabled) test for bug #3461.
	* device/lib/ds400/ds400rom.c:
	  Remove use of #pragma sdcc_hash.
	* src/stm8/gen.c,
	  src/pdk/gen.c,
	  src/z80/gen.c:
	  Partial fix for bug #3461.

2022-07-17 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/f8/gen.c:
	  Fix literal emission in f8 subtraction codegen.

2022-07-16 Felix Salfelder <felix AT salfelder.org>

	* src/SDCC.{lex,y}, support/cpp/libcpp/{init,macro}.c:
	  move __func__ elaboration entirely to sdcc.

2022-07-16 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/tests/bug-1952.c,
	  support/valdiag/tests/bug-1952.c:
	  Tests for __func__.
	* support/regression/tests/bug-3410.c.in:
	  Disable a test for mos65c02, since that port it still lacks _BitInt.

2022-07-12 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCsymt.c,
	  support/regression/tests/bug-3410.c.in:
	  Fix bug #3410.
	* src/SDCCsalloc.hpp:
	  Fix bug #3397.

2022-07-12 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/z80/gen.c,
	  support/regression/tests/bug-3459.c:
	  Fix bug #3459.

2022-07-12 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCsymt.c,
	  support/regression/tests/bug-3456.c,
	  support/regression/tests/bug-3459.c,
	  support/regression/tests/bug-3460.c.in:
	  Fix bug #3460.

2022-07-11 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/tests/bug-3459.c:
	  An attempt at creating a regression test for bug #3459.
	* src/z80/gen.c,
	  support/regression/tests/bug-3456.c:
	  Fix bug #3456.

2022-07-06 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* sdas/asf8/f8mch.c,
	  sdas/asf8/f8.h,
	  sdas/asf8/f8pst.c,
	  src/f8/gen.c:
	  Improve f8 assembler instruction support.

2022-07-06 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/f8/gen.c:
	  Fix f8 codegen for large return value.
	* src/SDCCglue.c,
	  src/SDCCpeeph.c,
	  src/f8/main.c:
	  Fix use of f8 vs. mcs51 jumps.
	* support/regression/ports/f8/spec.mk:
	  Update f8 regression test infrastructure.
	* sdas/asf8/f8.h,
	  sdas/asf8/f8mch.c,
	  sdas/asf8/f8pst.c:
	  Support f8 assembler instructions rot r, #i and ldw sp, rr.

2022-07-06 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/MakeList:
	  Exclude a test for host (since it fails when compiled with clang on FreeBSD 13.1 on aarch64).

2022-07-05 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* sdas/asf8/f8.h,
	  sdas/asf8/f8adr.c,
	  sdas/asf8/f8mch.c,
	  sdas/asf8/f8pst.c,
	  src/f8/gen.c:
	  More bits of an f8 assembler.

2022-07-04 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* sdas/asf8/f8.h,
	  sdas/asf8/f8adr.c,
	  sdas/asf8/f8mch.c:
	  Infrastructure for f8 assembler.

2022-07-01 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* Makefile.in,
	  configure,
	  configure.ac,
	  sdas/asf8,
	  src/f8/main.c:
	  Infrastructure for f8 assembler.

2022-07-01 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/MakeList:
	  Disable tcc/110_average test for pdk, due to lack of memory on those targets.

2022-06-29 Benedikt Freisen <b.freisen AT gmx.net>

	* device/include/float.h,
	  src/SDCCmain.c:
	  Provide macros for double, as requested in [feature-requests:#304].

2022-06-29 Benedikt Freisen <b.freisen AT gmx.net>

	* device/lib/_slonglong2fs.c,
	  device/lib/_ulonglong2fs.c,
	  device/lib/incl.mk,
	  doc/sdccman.lyx,
	  support/regression/cases/Makefile.in:
	  Implement long long to float conversion, fixing bug #3396.

2022-06-28 Benedikt Freisen <b.freisen AT gmx.net>

	* doc/sdccman.lyx,
	  src/SDCCargs.h,
	  src/SDCCerr.c,
	  src/SDCCerr.h
	  src/SDCCmain.c:
	  Improve command line parser flexibility and GCC compatibility.

2022-06-28 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/include/mcs51/at89c55.h,
	  device/include/mcs51/at89x51.h,
	  device/include/mcs51/at89x52.h,
	  device/include/mcs51/C8051F040.h,
	  device/include/mcs51/C8051F060.h,
	  device/include/mcs51/mcs51reg.h,
	  device/include/mcs51/reg764.h,
	  device/include/mcs51/regc515c.h,
	  device/include/mcs51/sab80515.h: fixed SBIT uses

2022-06-25 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/z80/gen.c,
	  support/regression/tests/bug-3458.c.in:
	  Fix bug #3458.

2022-06-21 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.y:
	  Fix SDCC crash on error message for duplicate default label.

2022-06-21 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* doc/sdccman.lyx,
	  device/lib/ds390/lcd390.c,
	  device/lib/ds390/rtc390.c,
	  support/regression/tests/absolute.c.in,
	  support/regression/tests/bitfields-bits1.c.in,
	  support/regression/tests/bitfields-checks.c.in,
	  support/regression/tests/bitfields-dead-loop.c.in,
	  support/regression/tests/bitfields-nibbles.c.in,
	  support/regression/tests/bug1723128.c,
	  support/regression/tests/bug1750318.c,
	  support/regression/tests/bug663539.c,
	  support/regression/tests/simplefloat.c:
	  Place __at next to identifier in declarations.

2022-06-21 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCCicode.c/h (PRINTFUNC, +piCode, iCodePrint): replaced
	  void*/iCode* with const iCode*
	* device/include/ds80c390.h,
	  device/include/mcs51/at89S8252.h: use parentheses with __at
	* device/include/mcs51/at89c55.h,
	  device/include/mcs51/at89x51.h,
	  device/include/mcs51/at89x52.h,
	  device/include/mcs51/C8051F040.h,
	  device/include/mcs51/C8051F060.h,
	  device/include/mcs51/mcs51reg.h,
	  device/include/mcs51/reg764.h,
	  device/include/mcs51/regc515c.h,
	  device/include/mcs51/sab80515.h: use compiler.h
	* device/include/mcs51/at89x051.h: cosmetics
	* device/lib/_setjmp.c: stack is in __idata
	* device/lib/ds390/tinibios.c,
	  device/lib/ds400/tinibios.c,
	  device/lib/ser_ir.c: use parentheses with __interrupt
	* device/lib/ser_ir_cts_rts.c: use __bit
	* src/mos6502/gen.c,
	  src/z80/gen.c: commented out some unused code to fix warnings
	* src/z80/peeph.def: removed rule 88 as it is a duplicate of 85a

2022-06-20 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.y:
	  Fix handling of C2X predefined constants.
	* device/lib/ds390/tinibios.c:
	  Fix use of __interrupt.
	* support/regression/tests/compare_2_n.m4:
	  Fix missing return type.

2022-06-20 Felix Salfelder <felix AT salfelder.org>

	* support/regression/cases/Makefile.in:
	  suppress implicit return type warnings in gte main functions.

2022-06-19 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.y:
	  Remove warning on label without statement, as it gives too many false positives.
	* support/regression/tests/rotate2.c.in:
	  Fix missing return type.

2022-06-19 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* Merge from parser branch.

2022-06-19 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* SDCC.y,
	  SDCCerr.h,
	  SDCCerr.c:
	  C2X allows labels in blocks even when not followed by a statement. Warn on C90 implicit int return type.

2022-06-17 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.lex,
	  src/SDCC.y,
	  src/SDCCerr.c,
	  src/SDCCerr.h,
	  .version,
	  doc/sdccman.lyx,
	  device/include/mcs51/ser.h,
	  device/include/mcs51/ser_ir.h,
	  device/include/mcs51/serial.h,
	  device/include/tinibios.h,
	  support/regression/fwk/lib/testfwk.c,
	  support/regression/ports/mcs51-common/T2_isr.c,
	  support/regression/tests/bug1535242.c,
	  support/regression/tests/critical.c,
	  support/regression/tests/interrupt.c.in,
	  support/regression/tests/setjmp.c,
	  device/lib/_ser.c,
	  device/lib/serial.c:
	  Steps towards a parser suitable for C2X, inspired by the Jutta Degener grammar as extended by Jens Gustedt.

2022-06-17 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* doc/sdccman.lyx:
	  Document standard version pragmas.

2022-06-15 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* Merge from parser branch.

2022-06-15 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.lex,
	  src/SDCC.y,
	  src/SDCCerr.c,
	  src/SDCCerr.h:
	  Lexer support for complex numbers and decimal floating point (to emit an error message for these unsupported features instead of a non-descriptive syntax error)
	* tests/bitintconst.c.in:
	  Test for bug #3454.

2022-06-15 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.lex,
	  src/SDCCval.c:
	  Fix bug #3454.

2022-06-15 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/z80/peeph.def: fixed rules 79 to 82 to fix bug #3387
	* support/regression/tests/bug-3387.c: new, added

2022-06-15 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* doc/sdccman.lyx:
	  Fix two typos in the manual

2022-06-15 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.lex,
	  src/SDCC.y,
	  src/pic14/ralloc.c,
	  src/pic16/ralloc.c,
	  src/altlex.c,
	  src/Makefile.in:
	  Steps towards a lexer suitable for C2X, inspired by the Jutta Degener grammar as extended by Jens Gustedt.

2022-06-14 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* doc/sdccman.lyx:
	  Improve calling convention documentation, fix bug #3412.

2022-06-01 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/z80/gen.c,
	  support/regression/tests/bug-3406.c:
	  Fix bug #3406.

2022-06-01 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCast.c:
	  Add an assertion to show the underlying issue of bug #3401.

2022-05-31 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/cases/Makefile.in:
	  Document reasons for some failing gte tests, enable tests that failed due to bug #3402 before.

2022-05-31 Felix Salfelder <felix AT salfelder.org>

	* support/regression/cases/Makefile.in:
	  jump to end of gte test in wrapped exit(0) calls, enable two
	  more, 20010116-1.c, 20070424-1.c

2022-05-29 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* support/sdbinutils/include/ansidecl.h: revert to previous
	* support/sdbinutils/libiberty/Makefile.in: check local include
	  files first

2022-05-27 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* support/regression/cases/Makefile.in: replace "echo -n" with
	  "printf" to handle hosts that don't support "-n" option
	* support/sdbinutils/include/ansidecl.h: disable some attributes
	  when compiling with clang so the Mac OS snapshot will build

2022-05-24 Daniel Drotos <drdani AT mazsola.iit.uni-miskolc.hu>

	* support/scripts/sdcc.nsi: install/deinstall more uCsim
	  binaries with correct names

2022-05-24 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* support/scripts/sdcc.nsi: update for hc08 simulator name change
	* support/regression/Makefile.in: only display first 20 failures
	  per test file (check the .out file if you need all of them)

2022-05-23 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/MakeList,
	  support/regression/cases/Makefile.in:
	  Document reasons for some failing gte tests.

2022-05-22 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/MakeList,
	  support/regression/cases/Makefile.in:
	  Document reasons for some failing TinyC tests.

2022-05-22 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/MakeList,
	  support/regression/cases/Makefile.in:
	  Document reasons for some failing gte tests.

2022-05-21 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/MakeList,
	  support/regression/cases/Makefile.in:
	  Document reasons for failing QuickC tests (lack of memory / speed vs. SDCC bugs).

2022-05-21 Felix Salfelder <felix AT salfelder.org>

	* support/sdbinutils/bfd/asxxxx.c:
	  name 2 unnamed parameters to comply with c99 & al.

2022-05-20 Felix Salfelder <felix AT salfelder.org>

	* support/sdbinutils/bfd/asxxxx.c:
	  edit out C++ style comments.

2022-05-19 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/MakeList:
	  Disable a test for targets that cannot complete it within reasonable time.

2022-05-19 Felix Salfelder <felix AT salfelder.org>

	* support/packihx/Makefile.in:
	  packihx: fix build (MAKEDEP related).

2022-05-19 Felix Salfelder <felix AT salfelder.org>

	* support/regression/cases/Makefile.in:
	  avoid segv in __fail, ASSERT(0) instead.

2022-05-18 Felix Salfelder <felix AT salfelder.org>

	* Makefile.common.in, Makefile.in,
	  sdas/*/Makefile.in, src/Makefile.in, src/port.mk:
	  deduplicate dependency generation and fix for ports

2022-05-18 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/MakeList,
	  support/regression/cases/Makefile.in:
	  Disable a test that tests for QuickC implementation-defined behaviour.

2022-05-18 Felix Salfelder <felix AT salfelder.org>

	* Makefile.common.in, configure, configure.ac, src/Makefile.in:
	  C vs. C++ distinction in dependency generation.

2022-05-18 Felix Salfelder <felix AT salfelder.org>

	* support/sdbinutils:
	  Merge upstream GNU Binutils 2.38 (feature request #766).
	* support/regression/Makefile.in:
	  clean-results rule

2022-05-18 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/tests/setjmp.c,
	  support/regression/tests/loop.c.in:
	  Disable two tests for FreeBSD 13.1, since a known issue from FreeBSD 13.0 is still present.
	* support/regression/MakeList:
	  Disable a test for targets that cannot complete it within reasonable time.
	* support/regression/tests/bug-3385.c:
	  Disable new test for mos6502, where it fails (bug #3386).
	* support/regression/tests/gcc-torture-execute-20040409-?.c:
	  Disable parts of tests that test for GCC implementation-defined behaviour.
	* support/regression/tests/mm-pnvi-ae-udi-pointer_from_int_disambiguation_1_xy.c,
	  support/regression/tests/mm-pnvi-ae-udi-provenance_basic_using_uintptr_t_auto_yx.c,
	  support/regression/tests/mm-pnvi-ae-udi-provenance_basic_using_uintptr_t_global_xy.c:
	  Disable tests for clang 13 that fail there due to clang 13 TS 6010 Provenance non-compliance.

2022-05-17 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* Merge regtest branch.

2022-05-17 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCval.c,
	  src/SDCCast.c:
	  support/regression/tests/bug-3391.c:
	  Fix bug #3391.

2022-05-16 Felix Salfelder <felix AT salfelder.org>

	* support/regression/Makefile.in:
	  avoid various newline compound echo arguments.

2022-05-15 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/z80/gen.c:
	  Fix bug #3388.
	* src/SDCCsymt.c,
	  support/valdiag/tests/bug-3389.c:
	  device/include/float.h,
	  support/regression/tests/bug-1805702.c:
	  Fix bug #3389.

2022-05-13 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/tests/bug-3385.c:
	  Disable new test for hc08 and s08, where it fails (bug #3386).

2022-05-12 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* Merge regtest branch.

2022-05-12 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/stm8/peeph.def,
	  support/regression/tests/bug-3385.c:
	  Fix bug #3385, patch by Ryan Hartlage (ryanplusplus).

2022-05-11 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/MakeList:
	  Exclude tests that fail on mcs51 due to abnormal stops.

2022-05-11 Felix Salfelder <felix AT salfelder.org>

	* support/regression/MakeList
	  exclude queen on pdk15-stack-auto.

2022-05-11 Felix Salfelder <felix AT salfelder.org>

	* support/regression/Makefile.in:
	  verbosity fix.

2022-05-10 Felix Salfelder <felix AT salfelder.org>

	* support/valdiag/Makefile.in:
	  adjust compact-results invocation, add Makefile rule.

2022-05-10 Felix Salfelder <felix AT salfelder.org>

	* support/regression/compact-results.py:
	  simplify compact-results output.

2022-05-10 Felix Salfelder <felix AT salfelder.org>

	* support/regression/Makefile.in:
	  honour EXCLUDE_PORTS in test-mcs51.

2022-05-10 Felix Salfelder <felix AT salfelder.org>

	* support/regression/MakeList:
	  tcc_49_bracket_evaluation excludes on mcs51.

2022-05-10 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCglue.c:
	  Fix bug #3031.
	* src/SDCCerr.h,
	  src/SDCCerr.c,
	  src/SDCCutil.c,
	  src/SDCC.lex,
	  support/valdiag/tests/universal.c:
	  ISO C23 diagnostics for invalid universal character names.

2022-05-02 Benedikt Freisen <b.freisen AT gmx.net>

	* doc/sdccman.lyx:
	  Document language override option -x.

2022-04-22 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/Makefile.in,
	  support/regression/ports/host/spec.mk.in:
	  Deduplicate EMU rule: handle test-host similar to other targets, patch by Felix Salfelder (felixs).

2022-04-22 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/MakeList:
	  Exclude a test for some pdk15-stack-auto target (due to lack of memory), patch by Felix Salfelder (felixs).

2022-04-22 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/MakeList:
	  Exclude some tests for some mcs51 targets (due to lack of memory), patch by Felix Salfelder (felixs).

2022-04-22 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/tests/bug-1981238.c,
	  support/regression/tests/bug-3368.c:
	  Disable some warnings about stuff that is meant to be tested.

2022-04-22 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/MakeList:
	  Exclude some known-failing among the new tests, patch by Felix Salfelder (felixs).
	* support/regression/Makefile.in,
	  support/regression/ports/host/spec.mk.in:
	  Work around a linker error reporting issue, patch by Felix Salfelder (felixs).

2022-04-22 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* device/lib/z180/setjmp.s,
	  device/lib/z80/setjmp.s,
	  device/lib/z80n/setjmp.s:
	  Fix an issue triggered by tail-call optimization on calls to longjmp.

2022-04-22 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/gte/README,
	  support/regression/qct/README,
	  support/regression/tcc/README:
	  Document Licenses of imported tests, patch by Felix Salfelder (felixs).

2022-04-21 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/MakeList,
	  support/regression/cases/Makefile.in,
	  support/regression/tcc,
	  support/regression/qct:
	  Add tests from TCC, QuickC, patch by Felix Salfelder (felixs).

2022-04-21 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/cases/Makefile.in:
	  Disable some warnings in gce tests, patch by Felix Salfelder (felixs).
	* support/regression/MakeList:
	  Disable new tests for z80-undoc (where they fail), patch by Felix Salfelder (felixs).

2022-04-21 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/Makefile.in,
	  support/regression/cases/Makefile.in,
	  support/regression/ports/mcs51-common/spec.mk,
	  support/regression/ports/stm8/spec.mk,
	  support/regression/gte:
	  GCC tests from the execute part of the torture suite. Patch by Felix Salfelder (felixs).
	* support/regression/gte/951204-1.c:
	  Un-edit a GCC torture-execute test, patch by Felix Salfelder (felixs).

2022-04-21 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/Makefile.in,
	  support/regression/ports/host/spec.mk.in:
	  Fix out creation logic to avoid duplicates, patch by Felix Salfelder (felixs).

2022-04-21 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/tests/genericnonintrinsicnaddr.c:
	  Use PORT_HOST, just like the other tests, instead of TEST_HOST.

2022-04-21 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/Makefile.in:
	  Hack to silence trigraph warning in p99 test, patch by Felix Salfelder (felixs).

2022-04-21 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/Makefile.in:
	  Filter out tests listed in EXCLUDE_${PORT}, TEST_PREFIX: select tests by prefix (e.g. m4_), TEST_SLICE: slice test list (Python style). Patch by Felix Salfelder (felixs).

2022-04-21 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/Makefile.in:
	  .PRECIOUS does not play with .DELETE_ON_ERROR, use .SECONDARY instead. Patch by Felix Salfelder (felixs).

2022-04-21 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* Merge implicitintrinsicnamedaddressspaces branch.

2022-04-21 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/Makefile.in:
	  Split EXCLUDE_PORTS, add uc6502-stack-auto, patch Felix Salfelder (felixs).

2022-04-21 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/tests/genericintrinsicnaddr.c,
	  support/regression/tests/genericnonintrinsicnaddr.c:
	  Test _Generic on pointers into named address spaces.
	* src/SDCCmem.c,
	  src/SDCCast.c:
	  Fix a _Generic implicit intrinsic named address space issue affecting large and huge mcs51 memory model.

2022-04-20 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/MakeList,
	  support/regression/Makefile.in,
	  support/regression/cases/Makefile.in,
	  support/regression/gte:
	  Import missing gcc torture execute tests, patch by by Felix Salfelder (felixs).

2022-04-20 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* Merge regtest branch.

2022-04-20 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/cases/Makefile.in:
	  Test cases cleanup, patch by Felix Salfelder (felixs).

2022-04-20 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCast.c,
	  src/SDCCcse.c,
	  src/SDCCglue.c,
	  src/SDCCicode.c,
	  src/SDCClospre.hpp,
	  src/SDCCopt.c,
	  src/SDCCsymt.c,
	  src/SDCCsymt.h,
	  src/ds390/ralloc.c,
	  src/mcs51/ralloc.c,
	  src/pic14/glue.c,
	  src/pic14/ralloc.c,
	  src/pic16/glue.c,
	  src/pic16/ralloc.c,
	  support/regression/tests/bug-3254.c,
	  support/regression/tests/bug-3245.c:
	  Fix bugs #3254, #3145.

2022-04-20 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCglue.c,
	  support/valdiag/tests/generic.c:
	  Fix another part of bug #3145.

2022-04-19 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCast.c:
	  Fix array-to-pointer decay in _Generic.

2022-04-15 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCsymt.c,
	  support/regression/tests/bug-2629.c:
	  Fix bug #2629.

2022-04-15 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCsymt.c:
	  Assertion to catch bug #2629 earlier.
	* support/regression/tests/bug-2629.c:
	  (Disabled) test for bug #2629.

2022-04-15 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCsymt.c:
	  Fix printing of plain char for error messages and debug output.

2022-04-13 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* doc/sdccman.lyx:
	  Update documentation on standard compliance.

2022-04-11 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/stm8/gen.c,
	  support/regression/tests/bug-3379.c:
	  Fix bug #3379.

2022-04-10 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/tests/bug-2981.c:
	  Test for bug #2981.
	* src/SDCCast.c,
	  support/regression/tests/bug-3255.c:
	  Fix bug #3255.
	* src/SDCCglue.c,
	  support/valdiag/tests/generic.c:
	  Fix part of bug #3145.

2022-04-04 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/cases/Makefile.in:
	  Fix rm flag for cleaning MakeList.
	* support/regression/Makefile.in:
	  Fix build of mcs51 regression test framework libraries, fix by Felix Salfelder (felixs).

2022-04-03 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/Makefile.in,
	  support/regression/ports/mcs51-small-stack-auto:
	  Rename mcs51-stack-auto to mcs51-small-stack-auto for consistency with mcs51-small and mcs51-large-stack-auto.
	* doc/sdccman.lyx:
	  Clarify __z88dk_callee behaviour.

2022-04-03 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/mcs51/gen.c,
	  src/stm8/gen.c,
	  support/regression/tests/funptrsstructreturn.c.in:
	  Fixes for calls via function pointers to functions returning struct / union.

2022-04-03 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCicode.c,
	  src/SDCCsymt.c,
	  src/mcs51/gen.c,
	  src/mcs51/main.c,
	  support/regression/tests/structreturn.c.in,
	  device/lib/div.c,
	  device/lib/ldiv.c,
	  device/lib/lldiv.c,
	  device/lib/mcs51/Makefile.in,
	  support/regression/tests/div.c,
	  device/include/stdlib.h:
	  struct / union return for mcs51.

2022-04-02 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/mcs51/gen.c,
	  support/regression/tests/gcc-torture-execute-strct-varg-1.c,
	  support/regression/tests/gcc-torture-execute-va-arg-23.c,
	  support/regression/tests/gcc-torture-execute-va-arg-4.c,
	  support/regression/tests/structparam.c,
	  support/regression/tests/structparam.c.in:
	  struct / union parameters on the stack for mcs51.

2022-04-01 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* ChangeLog,
	  src/SDCCicode.c,
	  src/SDCCmem.c,
	  support/regression/ports/mcs51-common/spec.mk,
	  support/regression/tests/gcc-torture-execute-20040707-1.c,
	  support/regression/tests/gcc-torture-execute-20050713-1.c,
	  support/regression/tests/gcc-torture-execute-20180131-1.c,
	  support/regression/tests/gcc-torture-execute-pr67226.c,
	  support/regression/tests/structparam.c:
	  Fix bug #3377.

2022-03-31 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCicode.c,
	  src/SDCCsymt.c,
	  src/ds390/main.c,
	  src/hc08/main.c,
	  src/mcs51/main.c,
	  src/mos6502/main.c,
	  support/regression/tests/bug-3368.c,
	  support/regression/tests/gcc-torture-execute-20050713-1.c,
	  support/regression/tests/gcc-torture-execute-20180131-1.c,
	  support/regression/tests/gcc-torture-execute-pr67226.c,
	  support/regression/tests/gcc-torture-execute-strct-varg-1.c,
	  support/regression/tests/gcc-torture-execute-va-arg-4.c,
	  support/regression/tests/structparam.c,
	  support/regression/tests/gcc-torture-execute-20021118-1.c,
	  support/regression/tests/gcc-torture-execute-20040707-1.c,
	  support/regression/tests/gcc-torture-execute-20180131-1.c,
	  support/regression/tests/gcc-torture-execute-pr67226.c,
	  support/regression/tests/gcc-torture-execute-920625-1.c,
	  support/regression/tests/gcc-torture-execute-va-arg-23.c:
	  struct parameter support for non-reentrant functions.

2022-03-29 Benedikt Freisen <b.freisen AT gmx.net>

	* doc/sdccman.lyx:
	  Reference section 3.2.5 in 3.2.4, fix typo in 1.2.

2022-03-29 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/sdbinutils/bfd/*:
	  Delete unused files as suggested by Felix Salfelder (felixs).

2022-03-28 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* device/lib/tlcs90/strlen.s:
	  Fix regression from [r13318].

2022-03-28 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/ports/tlcs90/spec.mk:
	  Do not emit debug info to ease reading asm files.
	* src/z80/ralloc2.cc:
	  Fix code generation issues in use of iy.

2022-03-28 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/Makefile.in:
	  Conditional MakeList include, and conditional test-port, part of patch #430 by Felix Salfelder (felixs).

2022-03-28 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/Makefile.in,
	  support/regression/cases/Makefile.in:
	  Silence case expansion messages by default, part of patch #430 by Felix Salfelder (felixs).

2022-03-28 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/Makefile.in,
	  support/regression/cases/Makefile.in,
	  support/regression/ports/host/spec.mk.in:
	  V flag to control verbosity, decouple test-ports and print-summary. Part of patch #430 by Felix Salfelder (felixs).

2022-03-28 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/Makefile.in,
	  support/regression/ports/*/spec.mk:
	  Deduplicate spec.mk by using rules in Makefile.in instead. Part of patch #430 by Felix Salfelder (felixs).

2022-03-28 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/Makefile.in,
	  support/regression/ports/host/spec.mk.in:
	  Regression test infrastructure, picked from patch #430 by Felix Salfelder (felixs): fixes for error reporting, number of compact-results calls, CLEAN_PORTS.

2022-03-28 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/z80/gen.c:
	  Fix bug #3373.

2022-03-28 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sim/ucsim/z80.src/gb80.cc,
	  sim/ucsim/z80.src/gb80cl.h,
	  sim/ucsim/z80.src/inst.cc,
	  sim/ucsim/z80.src/inst_gb80.cc:
	  Fix cycle accuracy.

2022-03-27 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sdas/astlcs90/tt90.asm,
	  sim/ucsim/tlcs.src/inst_arith.cc,
	  sim/ucsim/tlcs.src/inst_jump.cc,
	  sim/ucsim/tlcs.src/tlcs.cc:
	  Improve cycle accuracy.

2022-03-27 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sdas/astlcs90/tt90.asm:
	  Add some test assembly.

2022-03-26 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/tests/bitintvararg.c.in:
	  Fix host test disable condition.

2022-03-26 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/Makefile.in,
	  support/regression/cases/Makefile.in,
	  support/regression/cases/mkdrv.py,
	  support/regression/ports/*/spec.mk,
	  support/regression/ports/host/spec.mk.in:
	  Regression test infrastructure, picked from patch #430 by Felix Salfelder (felixs).
	* support/regression/tests/structparam.c.in:
	  Fix test file extension for parametrized test.

2022-03-26 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* configure,
	  configure.ac,
	  support/regression/Makefile.in,
	  support/regression/ports/host/spec.mk.in,
	  support/regression/cases:
	  Regression test infrastructure improvements, picked from patch #430 by Felix Salfelder (felixs), made less verbose.



2022-03-26 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* device/lib/tlcs90/abs.s,
	  device/lib/tlcs90/atomic_flag_test_and_set.s,
	  device/lib/tlcs90/crt0.s,
	  device/lib/tlcs90/memcpy.s,
	  device/lib/tlcs90/memmove.s,
	  device/lib/tlcs90/strcpy.s,
	  device/lib/tlcs90/strlen.s:
	  Optimize handwritten assembly.

2022-03-26 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/Makefile.in:
	  Fix an issue in test-host regression test output, fix suggested via chat by Felix Salfelder (felixs).

2022-03-26 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/tests/bitintvararg.c.in:
	  Disable a test for clang 11.0 host, where it fails.
	* device/lib/tlcs90/atomic_flag_test_and_set.s:
	  Bring back previous atomic_flag_test_and_set implementation as comment, explain why it was chosen, and under which circumstances we might want to revert back to it.

2022-03-26 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sim/ucsim/tlcs.src/inst_arith.cc
	  sim/ucsim/tlcs.src/inst_bit.cc
	  sim/ucsim/tlcs.src/inst_jump.cc
	  sim/ucsim/tlcs.src/tlcs.cc:
	  Add partial cycle counting.

2022-03-26 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* device/include/stdatomic.h,
	  device/lib/atomic_flag_clear.c,
	  device/lib/tlcs90/atomic_flag_test_and_set.s:
	  Switch to faster atomic test with shift. (8T vs 12T)

2022-03-25 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/Makefile.in,
	  support/regression/generate-cases.py,
	  support/regression/tests/*.c.in:
	  Regression test infrastructure improvements, picked from patch #430 by Felix Salfelder (felixs).

2022-03-25 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/Makefile.in:
	  Regression test infrastructure improvements, picked from patch #430 by Felix Salfelder (felixs).

2022-03-25 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCglobl.h,
	  src/SDCCglue.c,
	  src/z80/main.c,
	  src/z80/z80.h,
	  support/regression/ports/ucz80-undoc,
	  support/regression/Makefile.in,
	  src/z80/gen.c:
	  Support for undocumented Z80 instructions.

2022-03-25 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sdas/asz80/z80mch.c:
	  Disable undocumented instructions for Z180.

2022-03-24 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/Makefile.in,
	  support/regression/generate-cases.py:
	  Regression test infrastructure improvements, picked from patch #430 by Felix Salfelder (felixs).

2022-03-24 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCast.c,
	  src/SDCCsymt.c,
	  support/regression/tests/widebitintbitfield.c:
	  _BitInt promotion fix.
	* src/SDCCicode.c:
	  support/regression/tests/gcc-torture-execute-920625-1.c,
	  support/regression/tests/bug-3368.c:
	  Fix bug #3368.
	* support/regression/tests/bug-3235.c:
	  Test for a bug that was fixed a while ago.

2022-03-24 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCast.c,
	  support/regression/tests/bug-3372.c:
	  Fix bug #3372.
	* src/SDCCsymt.c:
	  Improve debug output for bit-fields.

2022-03-24 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sdas/as8xcxxx/ds8adr.c,
	  sdas/as8xcxxx/ds8mch.c:
	  Merge error messages from upstream ASxxxx 5.40.

2022-03-24 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sdas/as8xcxxx/ds8pst.c,
	  sdas/aspdk13/pdk13pst.c,
	  sdas/aspdk14/pdk14pst.c,
	  sdas/aspdk15/pdk15pst.c,
	  sdas/aspdk16/pdk16pst.c,
	  sdas/asrab/rabpst.c,
	  sdas/asstm8/stm8pst.c,
	  sdas/astlcs90/t90pst.c,
	  sdas/asz80/z80pst.c:
	  Enable .incbin for all targets.

2022-03-24 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/tests/widebitintbitfield.c:
	  Disable a test that had been accidentially enabled even for ports where the feature is not supported.

2022-03-24 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sdas/as8051/i51adr.c,
	  sdas/as8051/i51mch.c,
	  sdas/as8051/i51pst.c:
	  Merge error messages from upstream ASxxxx 5.40.

2022-03-24 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sdas/asz80/z80.h:
	  Fix .allow_undocumented for z80 [bugs:#3275].

2022-03-24 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sdas/asxxsrc/assubr.c:
	  Fix detailed error messages in sdas.

2022-03-23 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/tests/widebitintbitfield.c:
	  Temporarily disable new failing _BitInt test.

2022-03-23 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/tests/bitint.c,
	  support/regression/tests/bitintarith.c,
	  support/regression/tests/bitintbitfield.c,
	  support/regression/tests/bitintvararg.c,
	  support/regression/tests/widebitintbitfield.c:
	  Enable some tests for bit-precise integers on clang 11 host.

2022-03-22 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCcse.c,
	  support/regression/tests/bitint.c:
	  Fix bug #3371.

2022-03-22 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sdas/asz80/z80mch.c:
	  Fix/add cycles of z80 and z80n.

2022-03-20 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCglue.c:
	  Fix bug #3353.

2022-03-20 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/pdk/gen.c,
	  support/regression/tests/bug-2368.c,
	  support/regression/tests/bug-2770.c,
	  support/regression/tests/bug-3231.c,
	  support/regression/tests/bug3440327.c,
	  support/regression/tests/cse.c,
	  support/regression/tests/gcc-torture-execute-20021118-1.c,
	  support/regression/tests/gcc-torture-execute-20040707-1.c,
	  support/regression/tests/gcc-torture-execute-20050713-1.c,
	  support/regression/tests/gcc-torture-execute-20180131-1.c,
	  support/regression/tests/gcc-torture-execute-pr67226.c,
	  support/regression/tests/malloc.c,
	  support/regression/tests/memory.c,
	  support/regression/tests/preserves_regs.c,
	  support/regression/tests/structparam.c:
	  struct parameters for pdk (--stack-auto only).

2022-03-19 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/pdk/ralloc2.cc,
	  src/stm8/ralloc2.cc,
	  src/z80/ralloc2.cc,
	  support/regression/tests/gcc-torture-execute-20050713-1.c,
	  support/regression/tests/gcc-torture-execute-920625-1.c:
	  Fix a register allocation issue affecting calls to functions with multiple struct parameters.

2022-03-19 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.y,
	  src/SDCCcse.c,
	  src/SDCCicode.c,
	  src/SDCCicode.h,
	  src/pdk/gen.c,
	  src/stm8/gen.c,
	  src/z80/gen.c,
	  support/regression/tests/gcc-torture-execute-20021118-1.c,
	  support/regression/tests/gcc-torture-execute-20050713-1.c,
	  support/regression/tests/gcc-torture-execute-20180131-1.c,
	  support/regression/tests/gcc-torture-execute-pr67226.c,
	  support/regression/tests/gcc-torture-execute-strct-varg-1.c,
	  support/regression/tests/gcc-torture-execute-struct-ret-1.c,
	  support/regression/tests/gcc-torture-execute-va-arg-23.c,
	  support/regression/tests/gcc-torture-execute-va-arg-4.c,
	  support/regression/tests/structparam.c:
	  Rewrite struct parameter support to fix bug #3365.

2022-03-19 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCast.c,
	  support/regression/tests/gcc-torture-execute-920625-1.c,
	  support/regression/tests/gcc-torture-execute-strct-stdarg-1.c,
	  support/regression/tests/gcc-torture-execute-strct-varg-1.c:
	  Basic support for struct varargs.
	* support/regression/tests/gcc-torture-execute-20040707-1.c,
	  support/regression/tests/gcc-torture-execute-pr71700.c,
	  support/regression/tests/gcc-torture-execute-struct-ini-1.c,
	  support/regression/tests/gcc-torture-execute-va-arg-23.c,
	  support/regression/tests/gcc-torture-execute-va-arg-4.c:
	  Enable some GCC tests that pass due to recent improvements in struct / union support.
	* src/mos6502/gen.c,
	  src/mos6502/ralloc.c,
	  src/pdk/gen.c,
	  src/pdk/ralloc.c,
	  src/stm8/gen.c,
	  src/stm8/ralloc.c,
	  src/z80/gen.c,
	  src/z80/ralloc.c:
	  Remove remains of support for unused IPOP.
	* doc/README.txt,
	  doc/sdccman.lyx,
	  LICENSE:
	  Make it a bit easier to read about the license situation.

2022-03-19 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/mcs51/gen.c:
	  Fix bug #3364.
	* support/regression/tests/bitintvararg.c:
	  Enable test for widths, for which it passes.
	* support/regression/tests/gcc-torture-execute-bswap-2.c:
	  Remove GCC test that requires int to be at least 32 bits wide.
	* support/regression/tests/gcc-torture-execute-20020215-1.c,
	  support/regression/tests/gcc-torture-execute-20020810-1.c,
	  support/regression/tests/gcc-torture-execute-20021010-2.c,
	  support/regression/tests/gcc-torture-execute-20021118-1.c,
	  support/regression/tests/gcc-torture-execute-20050713-1.c,
	  support/regression/tests/gcc-torture-execute-20170401-1.c,
	  support/regression/tests/gcc-torture-execute-20180131-1.c,
	  support/regression/tests/gcc-torture-execute-920625-1.c,
	  support/regression/tests/gcc-torture-execute-pr67226.c,
	  support/regression/tests/gcc-torture-execute-restrict-1.c,
	  support/regression/tests/gcc-torture-execute-strct-stdarg-1.c,
	  support/regression/tests/gcc-torture-execute-strct-varg-1.c,
	  support/regression/tests/gcc-torture-execute-struct-ret-1.c:
	  Enable some GCC tests that pass due to recent improvements in struct / union support.

2022-03-18 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* device/include/stdarg.h,
	  src/SDCCast.c,
	  src/SDCCerr.c,
	  src/SDCCicode.c,
	  support/regression/tests/gcc-torture-execute-pr60017.c,
	  support/regression/tests/bitintvararg.c:
	  Fixes for bit-precise varargs, bug #3361.

2022-03-18 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCicode.c,
	  src/SDCCsymt.c,
	  src/stm8/gen.c,
	  src/z80/gen.c,
	  support/regression/tests/bug-3359.c,
	  support/regression/tests/structparam.c,
	  .version,
	  doc/sdccman.lyx:
	  Fix bug #3359 and implement struct / union parameters for stm8, z80 and related (and for pdk with --stack-auto), RFE #23.

2022-03-16 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c:
	  Refactor genAnd(), genOr() and genXor().

2022-03-16 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/z80/gen.c:
	  Fix access before array.
	* support/regression/tests/gcc-torture-execute-20020206-1.c,
	  support/regression/tests/gcc-torture-execute-20050713-1.c,
	  support/regression/tests/gcc-torture-execute-20071210-1.c,
	  support/regression/tests/gcc-torture-execute-20131127-1.c,
	  support/regression/tests/gcc-torture-execute-20170401-1.c,
	  support/regression/tests/gcc-torture-execute-20171008-1.c,
	  support/regression/tests/gcc-torture-execute-pr60017.c,
	  support/regression/tests/gcc-torture-execute-pr82387.c,
	  support/regression/tests/gcc-torture-execute-pr82388.c:
	  Update reasons why we skip some gcc tests.
	* device/include/uchar.h,
	  src/SDCCval.c:
	  In C23, u8-prefixed string literals are arrays of char8_t, a typedef for unsigned char. RFE #779.

2022-03-16 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/Makefile.in,
	  support/regression/ports/ds390/spec.mk,
	  support/regression/ports/ez80-z80/spec.mk,
	  support/regression/ports/mcs51-common/spec.mk,
	  support/regression/ports/pdk13/spec.mk,
	  support/regression/ports/pdk15/spec.mk,
	  support/regression/ports/pdk15-stack-auto/spec.mk,
	  support/regression/ports/stm8/spec.mk,
	  support/regression/ports/ucz180/spec.mk,
	  support/regression/ports/ucz180-resiy/spec.mk,
	  support/regression/ports/ucz80-nmos/spec.mk,
	  support/regression/ports/ucz80n/spec.mk:
	  Regression test infrastructure improvements, picked from patch #430 by Felix Salfelder (felixs).

2022-03-15 Gabriele Gorla <gorlik@yahoo.com>

	* support/regression/tests/div.c,
	  device/lib/s08/Makefile.in,
	  device/lib/hc08/Makefile.in,
	  device/lib/mos6502/Makefile.in,
	  device/lib/mos65c02/Makefile.in,
  	  device/lib/mos6502-stack-auto/Makefinle.in:
	  Enable div and ldviv for mos6502 and hc08/s08 ports.
	* src/mos6502/gen.c,
	  src/mos6502/main.c:
	  Add support for GETBYTE and GETWORD iCodes.

2022-03-15 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/pdk/gen.c,
	  device/lib/lldiv.c:
	  Fix pdk heap corruption on returning large struct.
	* src/stm8/gen.c:
	  Fixes for large struct return.

2022-03-15 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* device/lib/div.c,
	  device/lib/ldiv.c,
	  device/lib/lldiv.c,
	  support/regression/tests/div.c,
	  device/lib/Makefile.in,
	  device/lib/*/Makefile.in:
	  Division functions, RFE #167.

2022-03-15 Benedikt Freisen <b.freisen AT gmx.net>

	* device/include/gcc_attr.h:
	  Compatibility macros for GCC attribute syntax.

2022-03-15 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCsymt.c,
	  support/regression/tests/structreturn.c:
	  Enable struct / union return for hc08, s08, mos6502, ds390.
	* device/include/stdlib.h:
	  Provide prototypes for division functions.

2022-03-15 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/pdk/gen.c,
	  src/z80/gen.c,
	  src/SDCCsymt.c,
	  doc/sdccman.lyx,
	  support/regression/tests/structreturn.c:
	  struct / union return support for pdk and z80 and related.

2022-03-15 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCcse.c,
	  src/SDCCicode.c,
	  src/SDCCicode.h,
	  src/SDCClrange.c,
	  src/SDCCopt.c,
	  src/SDCCsymt.c,
	  src/ds390/ralloc.c,
	  src/mcs51/ralloc.c,
	  src/pic14/glue.c,
	  src/pic14/ralloc.c,
	  src/pic16/glue.c,
	  src/pic16/ralloc.c,
	  src/stm8/gen.c,
	  src/z80/ralloc.c:
	  struct / union return support for stm8.

2022-03-15 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* device/include/assert.h:
	  Improve test for assert C23-compliance.

2022-03-15 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c:
	  genPlusInc(), genMinusDec() and genlshTwo() improvements.

2022-03-14 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/z80/main.c,
	  src/z80/gen.c:
	  Enable _BitInt for sm83 up to 64 bits.
	* device/include/assert.h,
	  support/regression/tests/assert.c:
	  C23-compliant assert, RFE #780.

2022-03-14 Gabriele Gorla <gorlik@yahoo.com>

	* support/regression/tests/gcc-torture-execute-20021120-1.c:
	  Make stack-auto exception only for mos6502 port. Enable test for S08 and HC08.

2022-03-14 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/tests/bitintarith.c:
	  Disable part of test for pdk14 to not run out of code memory.
	* src/z80/gen.c,
	  support/regression/tests/bitintbitfield.c,
	  support/regression/tests/widebitintbitfield.c:
	  Fix write to wide bit-field on z80.

2022-03-14 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCval.c:
	  Use unsigned long long to represent bit-field values at compile time.
	* src/mcs51/main.c:
	  Enable _BitInt for mcs51.
	* support/regression/tests/bitintarith.c,
	  support/regression/tests/bug-3355.c:
	  Test for bug #3355 (disabled for now).
	* src/ds390/main.c,
	  src/ds390/gen.c:
	  _BitInt for ds390.
	* src/z80/gen.c,
	  support/regression/tests/bitintarith.c:
	  Fix a z80 _BitInt decrement issue.

2022-03-14 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c:
	  Make regInfoStr display SP relative values when appropriate.
	  Additional improvements to genAddrOf().

2022-03-13 Gabriele Gorla <gorlik@yahoo.com>

	* support/regression/tests/gcc-torture-execute-20021120-1.c:
	  Make large local allocation static when compiling with --stack-auto.

2022-03-13 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sdas/as6500/r65pst.c,
	  sdas/as6808/m08pst.c,
	  sdas/as8051/i51pst.c,
	  sdas/as8xcxxx/ds8pst.c,
	  sdas/aspdk13/pdk13pst.c,
	  sdas/aspdk14/pdk14pst.c,
	  sdas/aspdk15/pdk15pst.c,
	  sdas/aspdk16/pdk16pst.c,
	  sdas/asrab/rabpst.c,
	  sdas/asstm8/stm8pst.c,
	  sdas/astlcs90/t90pst.c,
	  sdas/asz80/z80pst.c:
	  Enable new mnemonics on all ports.

2022-03-12 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* support/regression/tests/bitintarith.c,
	  src/pdk/main.c:
	  Disable a test that failed on pdk15 for wide _BitInt due to lack of memory, reenable 64-_BitInt support for pdk.

2022-03-12 Gabriele Gorla <gorlik@yahoo.com>

	* src/mod6502/gen.c:
	  Small genCast() improvements.

2022-03-12 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* src/z80/peeph.def:
	  Eliminate nop jps.

2022-03-11 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/pdk/main.c:
	  Limit _BitInt size to 16 for pdk (temporarily, until an issue is fixed).
	* src/pdk/main.c:
	  Fix handling of parameters of odd size > 2.

2022-03-11 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* Merge _BitInt branch.

2022-03-11 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/mcs51/gen.c:
	  Basic _BitInt support for mcs51.

2022-03-11 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/pdk/gen.c,
	  src/stm8/gen.c,
	  src/z80/gen.c,
	  support/regression/tests/bitint.c,
	  support/regression/tests/widebitintbitfield.c:
	  Fix cast from signed integer type to wider unsigned bit-precise type.

2022-03-11 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* Merge _BitInt branch.

2022-03-11 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCsymt.c,
	  src/SDCCval.c,
	  src/z80/gen.c:
	  support/regression/tests/widebitintbitfield.c:
	  Fixes for bit-precise bit-fields.

2022-03-11 Daniel Drotos <drdani@mazsola.iit.uni-miskolc.hu>

	* src/pdk/gen.c:
	  Fix compile by gcc 9.4.0: label must be on statement

2022-03-11 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCglue.c,
	  src/SDCCsymt.c,
	  src/SDCCval.c,
	  support/regression/tests/bitint.c,
	  support/regression/tests/bitintbitfield.c:
	  Fix issues in casts between bitprecise types of different sign.

2022-03-10 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/ds390/main.c,
	  src/hc08/main.c,
	  src/mcs51/main.c,
	  src/pic14/main.c,
	  src/pic16/main.c:
	  Explicitly state _BitInt non-support.

2022-03-10 Gabriele Gorla <gorlik@yahoo.com>

	* src/SDCCglue.c:
	  Make assembly comments more consistent.
	* src/mos6502/main.c,
	  src/mos6502/ralloc2.cc:
	  Refactor to make files more similar to stm8 port.

2022-03-10 Benedikt Freisen <b.freisen AT gmx.net>

	* doc/sdccman.lyx:
	  Clarify --std-cxx and --std-sdccxx.

2022-03-10 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* Merge _BitInt branch.

2022-03-10 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* src/SDCCpeeph.c:
	  Calculate size of general ASxxx directives, apply [patches:428].

2022-03-10 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCmain.c
	  src/pdk/gen.c
	  src/pdk/main.c
	  src/pdk/peep.c
	  Support for bit-precise integer types on pdk.
	* src/stm8/gen.c,
	  src/stm8/main.c,
	  src/z80/gen.c,
	  support/regression/tests/bitintarith.c:
	  Fix left shift of bit-precise integer types.

2022-03-10 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/z80/gen.c,
	  src/z80/main.c:
	  Support for bit-precise integer types on sm83 up to a width of 16.

2022-03-10 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* Merge _BitInt branch.

2022-03-10 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* doc/sdccman.lyx,
	  src/z80/gen.c,
	  src/z80/main.c,
	  support/regression/tests/bitint.c:
	  Bit-precise types and bit-fields thereof for z80-related (except sm83, which only gets support up to a width of 8 bits for now).

2022-03-09 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c,
	  src/mos6502/main.c,
	  src/mos6502/ralloc.h:
	  Avoid marking the accumulator dirty after a compare operation.

2022-03-10 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sdas/asxxsrc/asmain.c,
	  sdas/asxxsrc/asxxxx.h:
	  Merge all kinds of .if directives from upstream ASxxxx.
	* sdas/asgb/gbpst.c:
	  Enable in sm83 for testing.

2022-03-09 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/peeph.def:
	  Add rules for redundant stores after loads.
	* device/lib/mos6502/crt0.s:
	  Use ZP for memcpy and memset parameters.

2022-03-09 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* Merge _BitInt branch.

2022-03-09 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCsymt.c,
	  support/regression/tests/bitintbitfield.c:
	  Fix signed bit-precise bit-fields.

2022-03-09 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCopt.c,
	  src/SDCCsymt.h,
	  src/SDCCval.c,
	  src/stm8/gen.c,
	  support/regression/tests/bitint.c,
	  support/regression/tests/bitintarith.c:
	  Multiplicative operators for bit-precise integers.

2022-03-09 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCopt.c,
	  src/stm8/main.c:
	  Improve diagnostics for unimplemented bit-precise operators.

2022-03-09 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c:
	  Fix corner cases in genPointerSet() and genPointerGet().

2022-03-09 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCast.c,
	  src/SDCCval.c,
	  support/regression/tests/bitint.c,
	  support/regression/tests/bitintarith.c,
	  src/stm8/gen.c:
	  Various _BitInt fixes.

2022-03-09 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCCast.c,
	  src/SDCCsymt.c,
	  src/SDCCval.c:
	  Fix casts for bit-precise types.
	* src/stm8/gen.c:
	  Fix return of types with odd size greater than 4.
	* support/regression/tests/bitint.c,
	  support/regression/tests/bitintarith.c:
	  Somethings already work for _BitInt, so we can test them!

2022-03-09 Maarten Brock <sourceforge.brock AT dse.nl>

	* doc/sdccman.lyx: fixed bug #3343

2022-03-08 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/peeph.def:
	  Minor peephole optimizations.
	* src/mos6502/gen.c:
	  Special case 16b left and 8bit right in genPlus and genMinus.

2022-03-08 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sdas/as8xcxxx/ds8mch.c,
	  sdas/asxxsrc/asxxxx.h:
	  Fix ASxxxx warnings by merging with upstream for [bugs:#3347].

2022-03-08 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* src/SDCC.lex,
	  src/SDCCerr.c,
	  src/SDCCerr.h,
	  src/SDCCsymt.c,
	  src/SDCCval.c,
	  src/stm8/main.c,
	  src/SDCCglue.c,
	  src/SDCCast.c,
	  src/SDCCsymt.h,
	  src/stm8/gen.c:
	  Infrastructure for bit-precise integer literals.

2022-03-08 Philipp Klaus Krause <krauseph AT informatik.uni-freiburg.de>

	* device/include/limits.h,
	  src/SDCC.lex,
	  src/SDCC.y,
	  src/SDCCerr.c,
	  src/SDCCerr.h,
	  src/SDCCmain.c,
	  src/SDCCsymt.c,
	  src/SDCCsymt.h,
	  src/SDCCval.c,
	  src/port.h:
	  Infrastructure for bit-precise integers.

2022-03-08 Philipp Klaus Krause <pkk AT spth.de>

	* .version:
	  Start post-4.2.0 development.

2022-03-08 Philipp Klaus Krause <pkk AT spth.de>

	* Merge sdcc-next branch to trunk.

2022-03-08 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* src/z80/peep.c:
	  Make it compile again.

2022-03-07 Gabriele Gorla <gorlik@yahoo.com>

	* support/regression/tests/bug3475630.c,
	  support/regression/tests/bug2094505.c:
	  Adjust tests parameters for stack-auto.
  	* src/mos6502/gen.c,
	  src/mos6502/main.c,
	  src/mos6502/ralloc2.cc:
  	  Use DPTR instead of YX for indexed addressing.

2022-03-07 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* src/z80/peep.c:
	  Accept more z80, sm83 and z80n mnemonics for size counting [bugs:#3330].

2022-03-07 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c:
	  Clear temp register literal values after a label.
	* src/mos6502/gen.c,
	  src/mos6502/ralloc2.cc:
	  Add codegen for rotate.

2022-03-07 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sim/ucsim/z80.src/inst_gb80.cc:
	  Add `ld (c), a`.
	  support/regression/ports/ucgbz80/support.c,
	  support/regression/ports/ucgbz80/uCsim.cmd:
	  Reduce size of __put.

2022-03-07 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sim/ucsim/z80.src/gb80.cc,
	  sim/ucsim/z80.src/inst_cb.cc,
	  sim/ucsim/z80.src/inst_gb80.cc:
	  Improve cycle counting.

2022-03-06 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sim/ucsim/z80.src/gb80.cc,
	  sim/ucsim/z80.src/z80mac.h:
	  Fix bug #3340 (`pop af` and `and`).

2022-03-06 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/ralloc.c,
	  src/mos6502/ralloc.h,
	  src/mos6502/ralloc2.cc:
	  Prepare for new spillt allocator.

2022-03-06 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* src/z80/peeph.def:
	  Remove rlca when sub already sets carry.

2022-03-05 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* src/SDCCgen.c:
	  Improve labels in inline assembly and fix bug #2831.
	  Patch based on patch by Tom Li.
	* device/lib/_memmove.c,
	  device/lib/sm83/crt0.s,
	  device/lib/sm83/memcpy.s,
	  src/z80/gen.c,
	  src/z80/main.c,
	  src/z80/peep.c:
	  Add missing copyright notices.

2022-03-05 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c:
	  Improve debug output.

2022-03-04 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c,
	  src/mos6502/gen.h:
	  Change asmop.type to enum.
	* src/mos6502/gen.c:
	  Remove unused "result" parameter from aopOp().
	* src/mos6502/gen.c:
	  Allow AX in genCpl().
	* src/mos6502/gen.c:
	  Remove unused parameters in freeAsmop().
	* src/mos6502/main.c,
	  src/mos6502/main.h:
	  Removed unnecessary main.h

2022-03-03 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* device/lib/sm83/memcpy.s:
	  Replace redundancy with macros.

2022-03-02 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* src/z80/peeph.def:
	  Disable rule that pessimized some ports.

2022-03-02 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* src/z80/main.c:
	  Add -bo and -ba for z80, apply patch #399.

2022-03-02 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* device/lib/sm83/mul.s:
	  Speed up multiplication algorithm.

2022-03-02 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* device/lib/_memset.c,
	  device/lib/sm83/abs.s,
	  device/lib/sm83/crt0.s,
	  device/lib/sm83/memcpy.s,
	  device/lib/sm83/setjmp.s:
	  Improve sm83 assembly.

2022-03-01 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sdas/asxxsrc/asdata.c,
	  sdas/asxxsrc/asmain.c,
	  sdas/asxxsrc/asxxxx.h:
	  Add -h and hidden -t flags.
	* sdas/asgb/gbadr.c,
	  sdas/asgb/gb.h:
	  Reduce customizations.

2022-03-01 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* src/z80/peeph.def:
	  Improve stdlib code through peephole rules.

2022-02-28 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/gen.c:
	  Refactor storeRegToAop()

2022-02-28 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sdas/asz80/z80adr.c,
	  sdas/asz80/z80mch.c:
	  Merge error messages from upstream ASxxxx 5.40.
	  Add a few for extensions/custom ports. Part 2.

2022-02-27 Gabriele Gorla <gorlik@yahoo.com>

	* src/mos6502/ralloc.c,
	  src/mos6502/gen.c:
	  Remove freeAllRegs()
	* src/mos6502/gen.c:
	  Fix corner cases in assignResultValue() and genPointerSet()
	* support/regression/ports/mos6502/spec.mk
	  Removed redundant --out-fmt-ihx command line option
	* device/lib/mos6502/_strcpy.s,
	  device/lib/mos6502/_strcmp.s,
	  device/lib/mos6502/_mullong.s,
	  device/lib/mos6502/_mulint.s,
	  device/lib/mos6502/_divuint.s,
	  device/lib/mos6502/_divulong.s,
	  device/lib/mos6502/__memcpy.s:
	  Move function parameters to overlay segment.
	* device/lib/mos6502/_divsint.s,
	  device/lib/mos6502/_divslong.s,
	  device/lib/mos6502/_modsint.s,
	  device/lib/mos6502/_modslong.s,
	  device/lib/mos6502/_moduint.s,
	  device/lib/mos6502/_modulong.s,
	  device/lib/mos6502/_mulschar.s,
	  device/lib/mos6502/_muluchar.s,
	  device/lib/mos6502/abs.c:
	  Add assembly implementation of divs, mod, mulchar and abs.
	* src/mos6502/gen.c:
	  Add m6502_unimplemented()
	* src/mos6502/gen.c:
	  Refactopr genCpl() and genPointerSet()

2022-02-26 Gabriele Gorla <gorlik@yahoo.com>

	* sdas/asxxsrc/aslist.c:
	  Revert changes in slew() which caused regression failures on z80 ports.
	* src/mos6502/ralloc.c:
	  Remove dead code from old ralloc.

2022-02-26 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sdas/asgb/gbmch.c:
	  Add cycle table from upstream.

2022-02-26 Philipp Klaus Krause <krauseph@informatik.uni-freiburg.de>

	* src/SDCCsymt.c,
	  support/regression/tests/bug-3332.c:
	  Fix bugs #3332 and #3333.

2022-02-24 Philipp Klaus Krause <krauseph@informatik.uni-freiburg.de>

	* doc/sdccman.lyx:
	  Improve calling convention documentation.

2022-02-24 Philipp Klaus Krause <krauseph@informatik.uni-freiburg.de>

	* doc/sdccman.lyx:
	  Fix a minor documentation issue.

2022-02-23 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* src/z80/peeph.def:
	  Remove ldi/ldh rules.
	* src/z80/peeph-sm83.def:
	  Add ldi/ldh rules.

2022-02-22 Gabriele Gorla <gorlik@yahoo.com>

	* sdas/asxxsrc/asxxxx.h,
	  sdas/asxxsrc/asmain.c,
	  sdas/as6500/r65pst.c:
	  Add .error and .message directives.
	* sdas/asxxsrc/assubr.c,
	  sdas/asxxsrc/aslex.c,
	  sdas/asxxsrc/asexpr.c:
	  More updates from upstream asxxxx 5.40

2022-02-22 Gabriele Gorla <gorlik@yahoo.com>

	* sdas/asxxsrc/asxxxx.h,
	  sdas/asxxsrc/asmain.c,
	  sdas/asxxsrc/asexpr.c,
	  sdas/asxxsrc/asdata.c:
	  Enable -v option (out of range errors) from upstream asxxxx 5.40.
	* sdas/asxxsrc/assubr.c,
	  sdas/asxxsrc/asout.c,
	  sdas/asxxsrc/asmcro.c,
	  sdas/asxxsrc/aslex.c:
	  Change protoypes to ANSI C. Add some detailed error messages.
	* sdas/asxxsrc/assym.c:
	  Make area name comparisons case insensitive.

2022-02-22 Sebastian 'basxto' Riedel <sdcc@basxto.de>

	* sdas/asgb/gbadr.c,
	  sdas/asgb/gbmch.c,
	  sdas/asrab/rabadr.c,
	  sdas/asrab/rabmch.c:
	  Merge error messages from upstream ASxxxx 5.40.
	  Add a few for extensions/custom ports.

2022-02-22 Gabriele Gorla <gorlik@yahoo.com>

	* src/SDCC.lex,
	  src/mos6502/main.c:
	  Add __zp keyword to the mos6502 port.
	* src/SDCCmain.c,
	  src/mos6502/main.c,
	  device/lib/mos6502/crt0.s,
	  device/lib/mos6502/_strcpy.s,
	  device/lib/mos6502/_strcmp.s,
	  device/lib/mos6502/_setjmp.c,
	  device/lib/mos6502/_mullong.s,
	  device/lib/mos6502/_mulint.s,
	  device/lib/mos6502/_divulong.s,
	  device/lib/mos6502/_divuint.s,
	  device/lib/mos6502/__memcpy.s,
	  device/lib/mos6502-stack-auto/crt0.s,
	  device/lib/mos6502-stack-auto/_setjmp.c:
	  Rename linker segments.
	* src/mos6502/gen.h:
	  Remove unused anonymous enum.
	* sdas/as6500/r65pst.c:
	  Prepeare for additional asxxxx upstream merge.

2022-02-22 Gabriele Gorla <gorlik@yahoo.com>

	* sdas/asxxsrc/asxxxx.h,
	  sdas/asxxsrc/assym.c,
	  sdas/asxxsrc/assubr.c,
	  sdas/asxxsrc/asmcro.c,
	  sdas/asxxsrc/asmain.c,
	  sdas/asxxsrc/aslist.c,
	  sdas/asxxsrc/aslex.c,
